define(function() {

    var newsDefaultData = null;
    var newsCardContainer = null;
    var new_card_area;
    var totalPageIndex = 0;       //当前数据最大的翻页数
    var PAGE_MAX_COUNT = 4;       //每一页最大的条目数
    var newsItems = [];  //新闻条目数组
    var currentPageIndex = 0; //当前页码
    // 屏幕滑动距离检测器
    var moveOverCheck = new checkMoveOver();
    var newsCacheData = null;
    var isResourceAndCssLoaded = false;
    var isOnceRequestSuccess = false; //是否请求成功过一次
    var isNewsCardRequesting = false;
    var newsCardBottomBtnTxt;
    var newsCardBottomBtnUrl;
    var MAX_NEWS_ITEM_COUNT = 20;
    var NEWS_CARD_CMD = 1007;
    var displayTime;
    var news_card_brief_default_img = "./news/res/ic_mainpage_news_default.png";

    var HOT_NEWS_SOURCE_ID = "13003";

    var NEWS_CARD_CLICKE_KEY = "VIAFLY_NEWS_CARD_CLICK_INFO";

    var cardRequestBaseInfo;

    var NEWS_CARD_STATE = {
        NO_NET:"无网络，请检查网络设置",
        FAIL:"加载失败，点击重试",
        LOADING:"加载中。。。",
        SUCCESS:"获取数据成功"
    };

    var opCodeKey = {
        "item": "newsItem",
        "moreBtn": "newsMoreBtn",
        "switchBtn": "newsSwitchBtn"
    };

    var current_news_card_state; //当前卡片的状态
    var news_card_loading_div;
    var news_card_no_data_div;
    var news_card_content_main_div;
    var isNeedCallBack = false; //在主界面启动时是否需要回调卡片请求状态

    //卡片创建的主入口
    function createCardFrame(newsData){
        newsDefaultData = newsData;
        newsCardContainer = document.createElement("div");
        newsCardContainer.id = newsData.id;

        //读取缓存并解析，以便于提前判断是否需要加载缓存

        var newsCacheString = cacheMgr.getCache(newsData.id);
        if(newsCacheString) {
            if(typeof newsCacheString == "string") {
                try{
                    newsCacheData = JSON.parse(newsCacheString);
                    console.log("cached news data parsed");
                }catch(e){
                    console.log("JSON parse exception");
                }
            }
        } else {
            cacheMgr.setCache(newsDefaultData.id, newsData);
        }
        console.log("news card CacheString" + newsCacheString);

        //判断是否需要展示，如果需要展示，读取缓存，否则不处理
        if((newsCacheData && newsCacheData.show) || (!newsCacheData && newsData.show)){
            isNeedCallBack = true;
            setTimeout(function(){xcssParser.parseStyleFile("./news/business.x.css", onResourceLoadFinish);},50);
        } else {
            if(listener && listener.callBack) {
                listener.callBack(newsDefaultData.id, true);
            }
        }


        /**
         * 更新卡片的开启关闭状态
         * @param state
         */
        newsCardContainer.updateState = function(state){

            console.log("newsCardContainer.updateState state:" + state);

            if(!newsCacheData) {
                var newsCacheString = cacheMgr.getCache(newsData.id);
                if(newsCacheString) {
                    if(typeof newsCacheString == "string") {
                        try{
                            newsCacheData = JSON.parse(newsCacheString);
                            console.log("cached news data parsed");
                        }catch(e){
                            console.log("JSON parse exception");
                        }
                    }
                } else {
                    newsCacheData = newsDefaultData;
                    newsCacheData.show = state;
                }
            }
            if(newsCacheData) {
                newsCacheData.show = state;
                cacheMgr.setCache(newsDefaultData.id, newsCacheData);
            } else {
                newsCacheData = newsDefaultData;
                newsCacheData.show = state;
                cacheMgr.setCache(newsDefaultData.id, newsCacheData);
            }

            if(state) {
                console.log("newsCardContainer.updateState show");
                newsCardContainer.style.display = "block";
                if(isResourceAndCssLoaded) {
                    console.log("newsCardContainer.updateState isResourceAndCssLoaded");
                    //如果不在请求过程中，且没有可用的新闻数据，则请求
                    console.log("isNewsCardRequesting:" + isNewsCardRequesting + ";isOnceRequestSuccess:" + isOnceRequestSuccess);
                    if(!isNewsCardRequesting && !isOnceRequestSuccess) {
                        doCardRequest();
                    }
                } else {
                    console.log("newsCardContainer.updateState ResourceAndCssNotLoaded");
                    setTimeout(function(){xcssParser.parseStyleFile("./news/business.x.css", onResourceLoadFinish);},50);
                }
            } else {
                console.log("newsCardContainer.updateState hidden" );
                newsCardContainer.style.display = "none";
            }
        };
        return newsCardContainer;
    }

    /**
     * 创建新闻区域卡片
     * @param newsData
     */
    function createNewsArea(newsData){

        if(!newsData){
            console.log("news data is null");
        }

        new_card_area = document.createElement("div");
        new_card_area.className = "news_card_content_white";
        new_card_area.id = "id_news_card_box_content_white";

        new_card_area.appendChild(createNewsCardTitle());

        if(newsCardContainer){
            console.log("new card need show");
            newsCardContainer.appendChild(new_card_area);
            //如果有可用缓存，则先展示缓存
            if(newsCacheData && newsData.version == newsCacheData.version && newsCacheData.content) {
                console.log("news card newsCacheData show");
                handleNewsCardData(JSON.stringify(newsCacheData.content),true);
            }
            var netWorkResultString = exec("SystemComponents", "isNetWorkAvailable", []);
            var netWorkResult = getResultMessage(netWorkResultString);
            if (netWorkResult == true) {
                //请求新数据
                doCardRequest();
            } else {
                if(!newsItems || newsItems.length < PAGE_MAX_COUNT)  {
                    changeNewsCardState(NEWS_CARD_STATE.FAIL);
                }
                if(isNeedCallBack && listener && listener.callBack) {
                    listener.callBack(newsDefaultData.id, true);
                    isNeedCallBack = false;
                }
            }
       }
    }

    //资源解析完成的回调
    function onResourceLoadFinish(){
        if(!isResourceAndCssLoaded) {
            isResourceAndCssLoaded = true;
            createNewsArea(newsDefaultData);
        }
        console.log("news  onResourceLoadFinish");
    }


    /**
     * 处理新闻卡片数据请求结果和缓存数据
     * @param result
     * @param isCachedData 是否是缓存数据
     */
    function handleNewsCardData(result,isCachedData) {
        if(isNeedCallBack && !isCachedData && listener && listener.callBack) {
            listener.callBack(newsDefaultData.id, true);
            isNeedCallBack = false;
        }
        if(!isCachedData) {
            isNewsCardRequesting = false;
        }
        if(!isCachedData) {
            console.log("news card request success: " + result );
        }

        //结果不存在，如果是缓存数据不处理，如果不是则按失败处理
        if(!result) {
            if(isCachedData) {
                return;
            } else {
                if((!newsItems || newsItems.length < PAGE_MAX_COUNT) && !isCachedData) {
                    changeNewsCardState(NEWS_CARD_STATE.FAIL);
                }
            }
        }
        var jsonData;

        try{
            jsonData = JSON.parse(result);
        } catch (err) {
            console.log("JSON parser error");
        }

        if(jsonData) {
            console.log("handleNewsResult");
            var jsonObject = jsonData;
            if("success" == jsonObject.status) {
                if(!isCachedData) {
                    isOnceRequestSuccess = true;
                }
                var i = 0;
                var tmpNewsItems = [];
                var tmpTotalPageIndex = 0;
                if(!isCachedData) {
                    if(jsonObject.content && jsonObject.content.news) {
                        var items = jsonObject.content.news;
                        var itemslength = items.length;
                        var index = 0;
                        displayTime = jsonObject.content.display_time;

                        for(;index < itemslength && i < MAX_NEWS_ITEM_COUNT; index++) {
                            var item = items[index];
                            if(isNewsItemLegal(item)) {
                                i++;
                                if(i % PAGE_MAX_COUNT == 0) {
                                    tmpTotalPageIndex++;
                                }
                                tmpNewsItems.push(item);
                            }
                        }
                    }
                }

                if(!newsCacheData) {
                    //读取缓存，来重写
                    var newsCacheString = cacheMgr.getCache(newsDefaultData.id);
                    if(newsCacheString) {
                        if(typeof newsCacheString == "string") {
                            try{
                                newsCacheData = JSON.parse(newsCacheString);
                            }catch(e){
                                console.log("JSON parse exception");
                            }
                        }
                    }
                }

                if(tmpNewsItems.length < MAX_NEWS_ITEM_COUNT) {
                    if(newsCacheData && newsDefaultData.version == newsCacheData.version && newsCacheData.content && newsCacheData.content.content && newsCacheData.content.content.news) {

                        if(!displayTime){
                            displayTime = jsonObject.content.display_time;
                        }
                        var newsCacheDataItems = newsCacheData.content.content.news;
                        console.log("****************" + JSON.stringify(newsCacheDataItems));
                        var j = 0;
                        var tmpIndex = 0;
                        var remainItemLength = MAX_NEWS_ITEM_COUNT - tmpNewsItems.length;
                        for(;tmpIndex <= remainItemLength && j < newsCacheDataItems.length; j++) {
                            if(isNewsItemLegal(newsCacheDataItems[j])) {
                                tmpNewsItems.push(newsCacheDataItems[j]);
                                console.log("****************tmpNewsItems.push:" + newsCacheDataItems[j]);
                                tmpIndex++;
                                i++;
                                if(i % PAGE_MAX_COUNT == 0) {
                                    tmpTotalPageIndex++;
                                    console.log("****************tmpTotalPageIndex:" + tmpTotalPageIndex);
                                }
                            }
                        }
                    }
                }

                if(tmpNewsItems.length >0 && !isCachedData){

                    jsonData.content.news = tmpNewsItems;

                    if(!newsCacheData){
                        newsCacheData = {};
                        newsCacheData.id = newsDefaultData.id;
                        newsCacheData.show = newsDefaultData.show;
                        newsCacheData.name = newsDefaultData.name;
                        newsCacheData.version = newsDefaultData.version;
                        newsCacheData.content = jsonData;
                    } else {
                        if(newsDefaultData.version == newsCacheData.version) {
                            newsCacheData.id = newsDefaultData.id;
                            newsCacheData.content = jsonData;
                            newsCacheData.name = newsDefaultData.name;
                        } else {
                            newsCacheData.id = newsDefaultData.id;
                            newsCacheData.version = newsDefaultData.version;
                            newsCacheData.content = jsonData;
                            newsCacheData.name = newsDefaultData.name;
                        }
                    }
                    cacheMgr.setCache(newsDefaultData.id, newsCacheData);
                }

                //判断数据是否可用
                if(tmpTotalPageIndex > 0) {

                    console.log("changeNewsCardState begin");
                    changeNewsCardState(NEWS_CARD_STATE.SUCCESS);
                    console.log("changeNewsCardState end");
                    newsItems = tmpNewsItems;
                    totalPageIndex = tmpTotalPageIndex;
                    currentPageIndex = 0;
                    console.log("refreshNewsView begin");
                    refreshNewsView(currentPageIndex,false);

                    var bottomBtnData = jsonObject.content.bottomButton;
                    if(bottomBtnData && bottomBtnData.length > 0) {
                        newsCardBottomBtnTxt = bottomBtnData[0].name;
                        newsCardBottomBtnUrl = bottomBtnData[0].url;
                        refreshNewsBtn();
                    }

                } else {
                    if((!newsItems || newsItems.length < PAGE_MAX_COUNT) && !isCachedData) {
                        changeNewsCardState(NEWS_CARD_STATE.FAIL);
                    }
                }

            } else { //请求失败
                if((!newsItems || newsItems.length < PAGE_MAX_COUNT) && !isCachedData) {
                    changeNewsCardState(NEWS_CARD_STATE.FAIL);
                }
            }
        } else {
            if((!newsItems || newsItems.length < PAGE_MAX_COUNT) && !isCachedData) {
                changeNewsCardState(NEWS_CARD_STATE.FAIL);
            }
        }
    }

    /**
     * 新闻缓存和请求结果的解析
     * @param result
     */
    function handleCardRequestData(result) {
        handleNewsCardData(result,false);
    }

    function handleCardRequestFail(){
        console.log("news card request fail");
        if(!newsItems || newsItems.length < PAGE_MAX_COUNT) {
            changeNewsCardState(NEWS_CARD_STATE.FAIL);
        }
        isNewsCardRequesting = false;
        if(isNeedCallBack && listener && listener.callBack) {
            listener.callBack(newsDefaultData.id,false);
            isNeedCallBack = false;
        }

    }

    function doCardRequest(){
        console.log("news card request");
        var requestOptions = {};
        requestOptions.cmd = "1007";

        requestOptions.onSuccess = handleCardRequestData;
        requestOptions.onFail = handleCardRequestFail;


        if(null == cardRequestBaseInfo) {
            cardRequestBaseInfo = getBseInfo();
        }
        var timeStr = new Date().valueOf();
        if (cardRequestBaseInfo && cardRequestBaseInfo.businessRequestUrl) {

           requestOptions.url = cardRequestBaseInfo.businessRequestUrl + "?c=1007&gz=0&v=1.0&t=" + timeStr;
//           requestOptions.url = cardRequestBaseInfo.businessRequestUrl + "?c=m1001&gz=0&v=1.0&t=" + timeStr;

        } else {
            //FIXME 默认使用现网地址
            requestOptions.url = CARD_REQUEST_URL + "?c=1007&gz=0&v=1.0&t="+ timeStr;
        }


//        requestOptions.url = CARD_REQUEST_URL + "?c=1007&gz=0&v=1.0&t="+ new Date().getTime()+"&gz=0";

//        requestOptions.url = "http://172.16.95.16:8089/llbx/do?c=1007&v=1.0&t=" + new Date().getTime()+"&gz=0";
//        requestOptions.url = "http://192.168.77.214/Client_Test_developer/Default.aspx?c=newscardJson";
//        requestOptions.url = "http://192.168.77.214/Client_Test_developer/Default.aspx?c=newscard";ß


        var json = {};

        //cmd
        json.cmd = NEWS_CARD_CMD;

        json.base = organizeJsonBaseData(getBseInfo());

        //param
        var param = {};
        param.id = newsDefaultData.id;
        param.version = "" + newsDefaultData.version;
        param.extendParam = {};
        if(displayTime) {
            param.extendParam.since_time = displayTime;
        }
        json.param = param;

         var jsonStr = JSON.stringify(json);

         console.log('createtNewsCardJSONStr end, jsonStr is ' + jsonStr);


        requestOptions.data = JSON.stringify(json);

        sendJsonAjaxRequest(requestOptions);

        isNewsCardRequesting = true;
    }

    /**
     * 创建标题
     * @returns {HTMLElement}
     */
    function createNewsCardTitle() {
        var newsCardTitleDiv;
        newsCardTitleDiv = document.createElement("div");
        var label = document.createElement("label");
        label.className = "css_card_title_text";
        if(newsDefaultData && newsDefaultData.name) {
            label.innerText = newsDefaultData.name;
        } else {
            label.innerText = "新闻";
        }
        newsCardTitleDiv.className = "css_card_title_bar";
        newsCardTitleDiv.appendChild(label);
        return newsCardTitleDiv;
    }

    /**
     * 创建失败界面的提示
     */
    function createNoDataView() {
        // 没数据状态下的显示元素
        news_card_no_data_div = document.createElement("div");
        news_card_no_data_div.id = "id_news_card_no_data_div";
        news_card_no_data_div.className = "css_dialog_news_no_data";

        var news_card_no_data_desc = document.createElement("div");
        news_card_no_data_desc.id = "id_news_loading_failer";
        news_card_no_data_desc.className = "css_news_card_failertext";
        news_card_no_data_desc.innerText = NEWS_CARD_STATE.FAIL;
        news_card_no_data_div.appendChild(news_card_no_data_desc);

        news_card_no_data_div.addEventListener("touchstart", function(){
            event.stopPropagation();
            moveOverCheck.start(event);
        });
        news_card_no_data_div.addEventListener("touchmove", function(){
            event.stopPropagation();
            moveOverCheck.check(event);
        });
        news_card_no_data_div.addEventListener("touchend", function(){
            event.stopPropagation();
            if (!moveOverCheck.isMoveOver()) {
                changeNewsCardState(NEWS_CARD_STATE.LOADING);
                doCardRequest();
            }
        });
    }

    /**
     * 创建加载界面
     */
    function createLoadingView() {
        // loading 状态下的显示元素
        news_card_loading_div = document.createElement("div");
        news_card_loading_div.id = "id_news_card_loading_div";
        news_card_loading_div.className = "css_dialog_news_card_loading";
        var news_card_loading_div_img = document.createElement("img");
        news_card_loading_div_img.className = "css_dialog_news_card_loading_img";
        news_card_loading_div_img.src = frame_loading_img;
        var news_card_loading_div_txt = document.createElement("div");
        news_card_loading_div_txt.className = "css_dialog_news_card_loading_txt";
        news_card_loading_div_txt.innerText = "正在加载";
        news_card_loading_div.appendChild(news_card_loading_div_img);
        news_card_loading_div.appendChild(news_card_loading_div_txt);
        news_card_loading_div.startRoate = function() {
            startRotateAnimation(news_card_loading_div_img);
        };
        news_card_loading_div.stopRoate = function() {
            stopRotateAnimation(news_card_loading_div_img);
        }
    }




    /**
     * 改变卡片的状态：成功、无网络、加载、失败
     * @param news_card_state
     */
    function changeNewsCardState(news_card_state) {
        console.log("current_news_card_state:" + current_news_card_state + ";news_card_state:" + news_card_state);
        if(!news_card_state || news_card_state == current_news_card_state) {
            return;
        }
//        if(NEWS_CARD_STATE.FAIL == current_news_card_state) {
            if(null != news_card_no_data_div) {
                news_card_no_data_div.style.display = "none";
            }
//        } else if(NEWS_CARD_STATE.LOADING == current_news_card_state) {
            if(null != news_card_loading_div) {
                news_card_loading_div.stopRoate();
                news_card_loading_div.style.display = "none";
            }
//        } else if(NEWS_CARD_STATE.NO_NET == current_news_card_state) {
            if(null != news_card_no_data_div) {
                news_card_no_data_div.style.display = "none";
            }
//        } else if(NEWS_CARD_STATE.SUCCESS == current_news_card_state) {
            if(null != news_card_content_main_div) {
                news_card_content_main_div.style.display = "none";
            }
//        } else {
//            console.log("不合法的状态");
//        }

        if(NEWS_CARD_STATE.FAIL == news_card_state) {
            if(null == news_card_no_data_div && new_card_area){
                createNoDataView();
                new_card_area.appendChild(news_card_no_data_div);
            } else {
                news_card_no_data_div.style.display = "block";
            }
            document.getElementById("id_news_loading_failer").innerText=NEWS_CARD_STATE.FAIL;
        } else if(NEWS_CARD_STATE.LOADING == news_card_state) {
            if(null == news_card_loading_div && new_card_area) {
                createLoadingView();
                new_card_area.appendChild(news_card_loading_div);
                news_card_loading_div.startRoate();
            } else {
                news_card_loading_div.style.display = "block";
            }
        } else if(NEWS_CARD_STATE.NO_NET == news_card_state) {
            if(null == news_card_no_data_div && new_card_area){
                createNoDataView();
                new_card_area.appendChild(news_card_no_data_div);
            } else {
                news_card_no_data_div.style.display = "block";
            }
            document.getElementById("id_news_loading_failer").innerText=NEWS_CARD_STATE.NO_NET;
        } else if(NEWS_CARD_STATE.SUCCESS == news_card_state) {
            if(null == news_card_content_main_div && new_card_area) {
                createNewsView();
                new_card_area.appendChild(news_card_content_main_div);
            } else {
                news_card_content_main_div.style.display = "block";
            }
        } else {
            console.log("不合法的状态");
        }
        current_news_card_state = news_card_state;
    }

    /**
     * 创建实际的新闻区域
     */
    function createNewsView() {
        console.log("createNewsView");
        // 新闻内容区域主容器
        news_card_content_main_div = document.createElement("div");
        news_card_content_main_div.className = "css_dialog_sohu_content_main_div";
        news_card_content_main_div.id = "id_dialog_sohu_content_main_div";

        var dialog_news_content_wrapper = document.createElement("div");
        dialog_news_content_wrapper.className = "css_news_card_content_wrapper";
        dialog_news_content_wrapper.id = "id_sohu_news_content_wrapper";

        for (var i = 0; i < PAGE_MAX_COUNT; i++) {
            var item = createNewsItem(i);
            dialog_news_content_wrapper.appendChild(item);
        }

        var newsItemRecoverTimeout;
        var targetItem;
        dialog_news_content_wrapper.addEventListener("touchstart", function () {
            console.log("----------------->> touchstart");
            event.stopPropagation();
            targetItem = getParentOfClass("css_news_card_item_div", event.target);
            if (targetItem) {
                moveOverCheck.start(event);
                if(newsItemRecoverTimeout) {
                    clearTimeout(newsItemRecoverTimeout);
                    newsItemRecoverTimeout = null;
                }
                targetItem.style.backgroundColor = "#e3e4e6";
                newsItemRecoverTimeout = setTimeout(function(){
                    targetItem.style.backgroundColor = "";
                    newsItemRecoverTimeout = null;
                },500);
            }
        }, false);
        dialog_news_content_wrapper.addEventListener("touchmove", function () {
            console.log("----------------->> touchmove");
            if (targetItem) {
                targetItem.style.backgroundColor = "";
                if(newsItemRecoverTimeout) {
                    clearTimeout(newsItemRecoverTimeout);
                }
                if (moveOverCheck.check(event)) {
                    targetItem = null;
                }
            }
        }, false);
        dialog_news_content_wrapper.addEventListener("touchend", function () {
            console.log("----------------->> touchend");
            event.stopPropagation();
            if (targetItem) {
                if(newsItemRecoverTimeout) {
                    clearTimeout(newsItemRecoverTimeout);
                    newsItemRecoverTimeout = null;
                }
                if("" != targetItem.style.backgroundColor) {
                    targetItem.onClick();
                }
                targetItem.style.backgroundColor = "";

            }
        }, false);

        news_card_content_main_div.appendChild(dialog_news_content_wrapper);
//        new_card_area.appendChild(news_card_content_main_div);

        var bottom_container_div = document.createElement("div");
        bottom_container_div.style.position="relative";
        bottom_container_div.className = "css_bottom_container_div";

        var change_news_div = document.createElement("div");
        change_news_div.className="css_news_card_bottom_change_div";
        change_news_div.innerText="换一换";

        var get_more_div = document.createElement("div");
        get_more_div.className="css_news_card_bottom_get_more_div";
        get_more_div.id = "id_news_card_bottom_get_more_div";
        get_more_div.innerText="查看更多";

        bottom_container_div.appendChild(change_news_div);
        bottom_container_div.appendChild(get_more_div);

        change_news_div.addEventListener("touchstart", function(){
            event.stopPropagation();
            change_news_div.style.backgroundColor = "#e3e4e6";
            moveOverCheck.start(event);
        });
        change_news_div.addEventListener("touchmove", function(){
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                change_news_div.style.backgroundColor = "";
            }
        });
        change_news_div.addEventListener("touchend", function(){
            event.stopPropagation();
            if (!moveOverCheck.isMoveOver()) {
                change_news_div.style.backgroundColor = "";
                exec("WidgetMMPContainerComponents", "appenCardCpaLog", [newsDefaultData.id]);
                exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.news, opCodeKey.switchBtn]);
                if(isRefreshing) {
                    return;
                }
                isRefreshing = true;
                currentPageIndex++;
                refreshNewsView(currentPageIndex, true);
            }

        });

        get_more_div.addEventListener("touchstart", function(){
            event.stopPropagation();
            get_more_div.style.backgroundColor = "#e3e4e6";
            moveOverCheck.start(event);
        });
        get_more_div.addEventListener("touchmove", function(){
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                get_more_div.style.backgroundColor = "";
            }
        });
        get_more_div.addEventListener("touchend", function(){
            event.stopPropagation();
            if (!moveOverCheck.isMoveOver()) {
                if(newsCardBottomBtnUrl) {
                    exec("UIComponents", 'openBrowser', [ "", newsCardBottomBtnUrl]);
                }
                exec("WidgetMMPContainerComponents", "appenCardCpaLog", [newsDefaultData.id]);
                exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.news, opCodeKey.moreBtn]);
            }
            get_more_div.style.backgroundColor = "";
        });
        news_card_content_main_div.appendChild(bottom_container_div);
    }


    var isRefreshing = false;
    /**
     * 刷新新闻
     * @param pageIndex
     * @param isNeedAnimation
     */
    function refreshNewsView(pageIndex,isNeedAnimation) {
        console.log("news card refreshNewsView" + pageIndex);
        var tempPageIndex = pageIndex%totalPageIndex;
        // 新闻内容正文区。
        var beginIndex = tempPageIndex*PAGE_MAX_COUNT;
        clearContent();
        if(isNeedAnimation) {
            setTimeout(function(){refreshContent(beginIndex,true);},100);
        } else {
            refreshContent(beginIndex, false);
        }
    }

    /**
     * 刷新底部更多按钮的文本
     */
    function refreshNewsBtn() {

        var news_card_bottom_get_more_btn = document.getElementById("id_news_card_bottom_get_more_div");
        console.log("refreshNewsBtn" + news_card_bottom_get_more_btn);
        if(news_card_bottom_get_more_btn) {
            news_card_bottom_get_more_btn.innerText = newsCardBottomBtnTxt;
        }
    }

    function clearContent() {
        for (var i = 0; i < PAGE_MAX_COUNT; i++) {
            var item = document.getElementById("news_card_item" + i);
            if(item && item.clear) {
                item.clear();
            }
        }
    }

    function refreshContent(i,isNeedAnimation){
        var item = document.getElementById("news_card_item" + i%PAGE_MAX_COUNT);
        console.log("refreshContent" + item);
        if(item) {
            item.refresh(newsItems[i]);
        }
        if(i%PAGE_MAX_COUNT == PAGE_MAX_COUNT-1) {
            isRefreshing = false;
        } else {
            if(isNeedAnimation) {
                setTimeout(function(){
                    refreshContent(++i,true);
                },100);
            } else {
                refreshContent(++i,false);
            }

        }
    }

    /**
     * 判断新闻条目是否可用
     * @param item
     * @returns {boolean}
     */
    function isNewsItemLegal(item) {
        return (item && item.title && item.news_url);
    }

    //创建每一条新闻条目
    function createNewsItem(id) {
        var itemDiv = document.createElement("div");
        itemDiv.id = "news_card_item" + id;
        itemDiv.className = "css_news_card_item_div";

        var briefDiv = document.createElement("div");
        briefDiv.className = "css_news_card_item_brief_div";
        briefDiv.innerText = "";

        var newsImg = document.createElement("img");
        newsImg.className = "css_news_card_item_img";
        newsImg.onerror = function() {
            if (newsImg.src != news_card_brief_default_img) {
                newsImg.src = news_card_brief_default_img;
            }
        };

        itemDiv.appendChild(newsImg);
        itemDiv.appendChild(briefDiv);

        var sourceId;
        var newsUrl;
        var newsId;
        itemDiv.refresh = function(newsItem) {
            console.log("itemDiv.refresh" + id);
            if(newsItem) {
                newsId = newsItem.id;
                sourceId = newsItem.dataSourceId;
                briefDiv.innerText = newsItem.title;
                newsImg.src = newsItem.image_url;
                newsUrl = newsItem.news_url;
                newsImg.style.visibility = "visible";
            }
        };

        itemDiv.onClick = function() {
            exec('UIComponents',"openBrowser",["",newsUrl]);
            exec("WidgetMMPContainerComponents", "appenCardCpaLog", [newsDefaultData.id]);
            exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.news, opCodeKey.item + (id+1)]);
            var netWorkResultString = exec("SystemComponents", "isNetWorkAvailable", []);
            var netWorkResult = getResultMessage(netWorkResultString);

            if(HOT_NEWS_SOURCE_ID == sourceId && newsId) {
                var newsCardClickInfoStr = cacheMgr.getCache(NEWS_CARD_CLICKE_KEY);
                var newsCardClikcInfo;
                var item = {};
                item.news_id = newsId;
                item.type = "enter";
                if(newsCardClickInfoStr) {
                    newsCardClikcInfo = JSON.parse(newsCardClickInfoStr);
                    if (newsCardClikcInfo && newsCardClikcInfo.items && newsCardClikcInfo.items.length >= 4) {
                        if(netWorkResult == true) {
                            newsCardClikcInfo.items.push(item);
                            cacheMgr.setCache(NEWS_CARD_CLICKE_KEY,{"items":[]});
                            sendHotNewsClickInfo(newsCardClikcInfo.items);
                            return;
                        }
                    }
                }
                if(!newsCardClikcInfo || !newsCardClikcInfo.items) {
                    newsCardClikcInfo = {"items":[]};
                }
                newsCardClikcInfo.items.push(item);
                cacheMgr.setCache(NEWS_CARD_CLICKE_KEY,newsCardClikcInfo);
            }
        };
        itemDiv.clear = function() {
            console.log("itemDiv.clear" + id);
            briefDiv.innerText = "";
            newsImg.src = news_card_brief_default_img;
            newsImg.style.visibility = "hidden";
        };
        return itemDiv;
    }

    function sendHotNewsClickInfo(newsClickInfo) {
        console.log("sendHotNewsClickInfo:" + JSON.stringify(newsClickInfo));

        var requestOptions = {};

        if(null == cardRequestBaseInfo) {
            cardRequestBaseInfo = getBseInfo();
        }

        var timeStr = new Date().valueOf();

        requestOptions.url = "http://ossptest.voicecloud.cn:90/vaclient/do?c=1106&v=3.0&t=" + timeStr;
//        if (cardRequestBaseInfo && cardRequestBaseInfo.businessRequestUrl) {
//            requestOptions.url = cardRequestBaseInfo.businessRequestUrl + "?c=1106&gz=0&v=1.0&t=" + timeStr;
//        } else {
//            //FIXME 默认使用现网地址
//            requestOptions.url = CARD_REQUEST_URL + "?c=1007&gz=0&v=1.0&t="+ timeStr;
//        }


        var json = {};

        json.base = organizeJsonBaseData(getBseInfo());

        //param
        var param = {};
        param.actions = newsClickInfo;
        json.param = param;

        var jsonStr = JSON.stringify(json);

        console.log('createtNewsCardJSONStr end, jsonStr is ' + jsonStr);

        requestOptions.data = JSON.stringify(json);

        sendJsonAjaxRequest(requestOptions);

    }

    //return create;
    return createCardFrame;

});