define(function () {
    //常量定义部分
    var DEFAULT_URL = "http://192.168.77.214/Client_Test_developer/Default.aspx?c=N011";

    var ARG_FORCE_AUTH = 1;
    var ARG_NOT_FORCE_AUTH = 0;
    var COMMON_NO_TOKEN_ERROR = "000004";
    var TOKEN_INEFFCTIVE_ERROR = "000001";
    var DEFAULT_ERROR = "999999";
    var WAIT_FOR_AUTH_ERROR = "-100000";
    var ERROR_EXISTING_RUNNING_AUTH = "1007";
    var ic_mainpage_refresh = "./bill/res/ic_mainpage_refresh.png";
    var ic_mainpage_calls = "./bill/res/ic_mainpage_calls.png";
    var ic_mainpage_flow = "./bill/res/ic_mainpage_flow.png";
    var TELEPHONE_FEE_FOCUS = "telephone_fee";
    var DATA_TRANSFER_FOCUS = "data_transfer";
    var ERROR_VALUE = "---";
    var TIP_NO_NET = "网络无连接，请检测网络设置";
    var TIP_NET_EXCEPTION = "网络异常，请稍后重试";
    var TRAFFIC_UNIT = 1024;
    var TRAFFIC_UNIT_LIMIT = 1023.99;
    var CREDIT_UNIT = 10000;
    var CREDIT_UNIT_LIMIT = 9999.99;
    var VALUE_FIXED_NUMBER = 2;
    var UNIT_MB = "M";
    var UNIT_GB = "G";
    var UNIT_TB = "T";
    var UNIT_MB_OLD = "MB";
    var UNIT_GB_OLD = "GB";
    var UNIT_TB_OLD = "TB";

    //卡片刷新的四种刷新原因
    var UPDATE_TRIGGER_FRAME_LOAD = "frame_load";
    var UPDATE_TRIGGER_FRAME_REFRESH = "frame_refresh";
    var UPDATE_TRIGGER_USER = "user_trigger";
    var UPDATE_TRIGGER_AUTH_SUCC = "auth_succ_trigger";

    var cardContainer =  document.createElement("div");
    //cardContainInner包含title、内容和阴影三部分
    var cardContainInner =  document.createElement("div");
    cardContainInner.className="css_card";
    cardContainer.appendChild(cardContainInner);
    var isCardContentCreated = false;
    var isCssLoaded = false;
    var currentImsi = null;
    var errorCode = DEFAULT_ERROR;
    var isFirstIn = true;

    //结果页面刷新的显示div
    var updateTimeDiv = null;
    var refreshBtnDiv = null;

    var operatorBusinessData = {};

    //更新卡片全局刷新策略的标志位
    var isRequesting = false; //是否正在请求,该定义不能定义于发送方法前，调用之后，否则数据被复位
    var requestCondition = 0;//0:无网络，不需要请求;1:不判断网络，直接请求;2：判断网络，再请求
    var updateTrigger = UPDATE_TRIGGER_FRAME_LOAD; //刷新的来源。框架、用户右上角刷新和错误界面刷新

    //动画控件标识
    var rotateId = null;
    
    //是否需要在数据请求回来后通知框架
    var isNeedNotifyFrame = true;

    var currentErrorCode = DEFAULT_ERROR;
    
    //说法示例界面
    var speechCaseView = null;
    
    //错误置顶界面
    var cardActionView = null;

    function getFrameTitle() {
        var title = "话费流量";
        if(operatorBusinessData.name) {
            title = operatorBusinessData.name;
            if(title.length > 4) {
                title = title.substring(0,4);
            }
        }
        return title;
    }

    function deleteContentIfIMSIChange() {
        currentImsi = getCurrentIMSI();
        //imsi不相同则删除卡片内容
        if(operatorBusinessData.content && operatorBusinessData.content.imsi != currentImsi) {
            operatorBusinessData.content = null;
            cacheMgr.setCache(operatorBusinessData.id, JSON.stringify(operatorBusinessData));
            console.log("delete stored data for imsi change");
        }

        function getCurrentIMSI() {
            console.log("HFLL_ getCurrentIMSI:");
            var result = exec("lxOvsExtComponents", "getCurrentIMSI", []);
            var realResult = getResultMessage(result);
            console.log("HFLL_ getCurrentIMSI exec : " + realResult);
            return realResult;
        }
    }

    function createCardFrame(defaultData, initNetState) {
        console.log("HFLL_ cmcc business card defaultData: " + JSON.stringify(defaultData));
        if(!defaultData) {
            console.error("HFLL_ defaultData is null");
            return;
        }

        // //本地判断是电信联通用户，则默认卡片不显示
        // var simTypeResultStr = exec("lxOvsExtComponents","querySimType",[]);
        // var simType = getResultMessage(simTypeResultStr);
        // console.log("HFLL_ queried simType: " + simType);
        // //话费流量卡片非移动用户默认关闭,默认关闭不意味着就是关闭，
        // if(simType === "CHINA_UNICOM" || simType === "CHINA_TELECOM") {
            // console.log("HFLL_ this card default not show card.");
            // defaultData.show = false;
        // }


        //读取缓存的卡片数据
        var storedBusinessDataStr = cacheMgr.getCache(defaultData.id);
        console.log("HFLL_ cmcc business card storedBusinessDataStr: " + storedBusinessDataStr);
        var storedBusinessData = null;
        try {
            storedBusinessData = JSON.parse(storedBusinessDataStr);
        }catch (e) {
            console.log("HFLL_ cmcc business card storedBusinessData is not json ");
        }

        if(!storedBusinessData) {
            //如果没有缓存过数据，保存数据
            console.log("HFLL_ cmcc business card store defaultData");
            operatorBusinessData = defaultData;
            cacheMgr.setCache(defaultData.id, JSON.stringify(operatorBusinessData));
        } else if(storedBusinessData && defaultData.version != storedBusinessData.version) {
            //如果当前卡片内容版本不等于卡片版本时，删除数据
            console.log("HFLL_ cmcc business card delete stored data");
            defaultData.show = storedBusinessData.show;
            operatorBusinessData = defaultData;
            cacheMgr.setCache(defaultData.id, JSON.stringify(operatorBusinessData));
        } else {
            //保证卡片title使用默认数据的title
            storedBusinessData.name = defaultData.name;
            storedBusinessData.caseList = defaultData.caseList;
            operatorBusinessData = storedBusinessData;
        }
        deleteContentIfIMSIChange();
        cardContainer.id = operatorBusinessData.id;
        if(operatorBusinessData.show) {
            if (initNetState) {
                requestCondition = 1;
            } else {
                requestCondition = 0;
            }
            xcssParser.parseStyleFile("./bill/business.x.css", handleOperatorBusiness);
        } else {
            listener.callBack(operatorBusinessData.id, CARD_CONTENT_NO_REQUEST);
            cardContainer.style.display = "none";
            requestCondition = 2;
        }

        cardContainer.updateState = function(state) {
            console.log("HFLL_ updateState " + state);
            operatorBusinessData.show = state;
            cacheMgr.setCache(operatorBusinessData.id, JSON.stringify(operatorBusinessData));
            if(state) {
                cardContainer.style.display = "block";
                console.log("HFLL_ updateState: isCardContentCreated: " + isCardContentCreated);
                if(isCardContentCreated) {
                    // do nothing,产品支持再从关到开不用再请求数据，所以只要加载过内容，则使用之前的内容
                } else {
                    if(isCssLoaded) {
                        handleOperatorBusiness();
                    } else {
                        xcssParser.parseStyleFile("./bill/business.x.css", handleOperatorBusiness);
                    }
                }
            } else {
                cardContainer.style.display = "none";
            }
        };
        cardContainer.updateData = function(){
            if (operatorBusinessData.show) {
                sendDataRequest(UPDATE_TRIGGER_FRAME_REFRESH);
            } else {
                if (!isRequesting) {
                    listener.callBack(operatorBusinessData.id, CARD_CONTENT_NO_REQUEST);
                }
            }
        };
        cardContainer.initShowState = operatorBusinessData.show;
        cardContainer.showContentPage = showContent;
        return cardContainer;
    }

    function sendDataRefreshOrAuth(clickScene) {
        if(TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode) {
            //鉴权结果监听
            window.onAuthResult = function(tokenId) {
                console.log("HFLL_ onAuthResult: " + tokenId);
                //页面内用户鉴权可能会等很长时间，这时候需要防止用户热插拔SIM卡
                deleteContentIfIMSIChange();
                if(tokenId && tokenId !== "") {
                    //鉴权回来后刷新界面
                    showRefreshingPage();
                    sendDataRequest(UPDATE_TRIGGER_AUTH_SUCC);
                } else {
                    errorCode = COMMON_NO_TOKEN_ERROR;
                    showCacheDataOrErrorPage();
                }
            };

            window.onAuthCancel = function() {
                console.log("HFLL_ onAuthCancel ");
                //页面内用户取消鉴权可能会等很长时间，这时候需要防止用户热插拔SIM卡
                deleteContentIfIMSIChange();
                showCacheDataOrErrorPage();
            };

            window.onAuthError = function(errorCodeForAuth) {
                console.log("HFLL_ onAuthError: " + errorCodeForAuth);
                if(ERROR_EXISTING_RUNNING_AUTH == errorCodeForAuth || 1007 == errorCodeForAuth) {
                    console.log("HFLL_ onAuthError: return");
                    return;
                }
                //1003错误表示是网络鉴权错误，所以还要重新鉴权一次，这一次鉴权应该走短信鉴权
                if(1003 == errorCodeForAuth) {
                    console.log("HFLL_ onAuthError: reAuth");
                    exec("AuthComponents", "startAuth", [ARG_NOT_FORCE_AUTH]);
                    showCacheDataOrErrorPage(WAIT_FOR_AUTH_ERROR);
                    return;
                }
                deleteContentIfIMSIChange();
                errorCode = COMMON_NO_TOKEN_ERROR;
                showCacheDataOrErrorPage();
            };
            //鉴权后要从java回调一个请求数据的动作回来
            console.log("HFLL_ startAuth: " + clickScene);
            var authArg = ARG_NOT_FORCE_AUTH;
            if(TOKEN_INEFFCTIVE_ERROR == errorCode) {
                //TOKEN 失效则强制鉴权
                authArg = ARG_FORCE_AUTH;
            }
            if("fail_auto_auth" == clickScene) {
                exec("AuthComponents", "startAuth", [authArg]);
                showCacheDataOrErrorPage(WAIT_FOR_AUTH_ERROR);
            } else {
                exec("AuthComponents", "startAuthUI", [authArg]);
            }
        } else {
            var tmpNetState = isNetConnect();
            if(!tmpNetState) {
                //没网就不用刷新界面了
                exec("UIComponents", "showToast", [TIP_NO_NET, 1]);
                return;
            }
            if("result_page" != clickScene) {
                showRefreshingPage();
            } else {
                if (updateTimeDiv) {
                    updateTimeDiv.innerText = "正在更新...";
                }
                if (refreshBtnDiv) {
                    refreshBtnDiv.disabled = true;
                }
                startLoading(refreshBtnDiv.refreshImg);
            }
            sendDataRequest(UPDATE_TRIGGER_USER);
        }
    }

    function userRightCornerRefresh() {
        console.log("HFLL_ userRightCornerRefresh()");
        sendDataRefreshOrAuth("result_page");
    }

    function cardStickToTop() {
        console.log("HFLL_ cardStickToTop()");
        stickTopSort(operatorBusinessData.id);
    }

    function closeCard() {
        console.log("HFLL_ closeCard()");
    }
    
    function showContent() {
        console.log("HFLL_ showContent()");
        if(speechCaseView) {
            speechCaseView.style.display = "none";
        }
        if(cardActionView) {
            cardActionView.style.display = "none";
        }
        cardContainInner.style.display = "block";
        showCacheDataOrErrorPage();
    }

    function getSpeechCase() {
        var speechCase = operatorBusinessData.caseList;
        if(!speechCase) {
            speechCase = [];
        }
        return speechCase;
    }
    function operateCallBack(callBackId) {
        switch(callBackId) {
            case 0://取消
                showContent();
                break;
            case 1://置顶
                showContent();
                stickTopCardByDom(cardContainer);
                break;
            case 2://关闭
                showCloseConfirmDialogById(cardContainer.id);
                break;
            default:
                break;
        }
    }
    function titleResponseListener(responseId){
        switch(responseId) {
            case 0://点击说法示例区域
                recordClickLog("speechCase", null);
                exec("LogComponents", "addCmccLog", [cpaCode.speechCase]);
                if(cardActionView) {
                    cardActionView.style.display = "none";
                }

                cardContainInner.style.display = "none";
                if (speechCaseView) {
                    speechCaseView.style.display = "block";
                } else {
                    speechCaseView = createSpeechCaseView("bill", getFrameTitle(), getSpeechCase());
                    //判断一下是否为空
                    if(speechCaseView) {
                        speechCaseView.setCancelListener(showContent);
                        cardContainer.appendChild(speechCaseView);
                    }
                }
                break;
            case 1://点击置顶箭头按钮
                recordClickLog("menu", null);
                if(speechCaseView) {
                    speechCaseView.style.display = "none";
                }
                cardContainInner.style.display = "none";

                if (cardActionView) {
                    cardActionView.style.display = "block";
                } else {
                    cardActionView = createOperationView("bill", getFrameTitle());
                    //判断一下是否为空
                    if(cardActionView) {
                        cardActionView.setOpListener(operateCallBack);
                        cardContainer.appendChild(cardActionView);
                    }
                }
                break;
            case 2://刷新，暂时没有实现
                break;
            default:
                break;
        }
    }

    function createCardTitle() {
        console.log("HFLL_ createCardTitle() ");
        var titleDiv = document.createElement("div");
        titleDiv.className = "card_main_top_bar_left";
        var cardTitle = document.createElement("div");
        titleDiv.cardTitle = cardTitle;
        cardTitle.className = "card_main_top_bar_left_tile";
        titleDiv.appendChild(cardTitle);

        var speechCaseGuide = document.createElement("div");
        speechCaseGuide.className = "card_main_top_bar_left_case";
        var caseText = getSpeechCase()[0];
        if(caseText.length > 9) {
            caseText = caseText.substring(0, 9);
            caseText = caseText + "”";
        }
        speechCaseGuide.innerHTML = caseText;
        titleDiv.appendChild(speechCaseGuide);

        var speechCaseGuideArrow = document.createElement("img");
        speechCaseGuideArrow.className = "card_main_top_bar_left_case_arrow";
        speechCaseGuideArrow.src = ic_viewsample_arrow_down;
        speechCaseGuide.appendChild(speechCaseGuideArrow);

        addOnClickListener(titleDiv, titleResponseListener, 0, "");
        return titleDiv;
    }

    function createHeadPart() {
        var headPartRoot = document.createElement("div");
        headPartRoot.className = "card_main_top_bar";

        headPartRoot.refreshData = function(isNeedShowRefreshBtn, isNeedShowUpdateTime) {
            //title部分刷新
            if(!headPartRoot.titleDiv) {
                var title = createCardTitle();
                headPartRoot.titleDiv = title;
                headPartRoot.appendChild(title);
            }
            headPartRoot.titleDiv.cardTitle.innerText = getFrameTitle();
            if(!headPartRoot.cardActionMenu) {
                var cardActionMenuRoot = document.createElement("div");
                cardActionMenuRoot.className = "card_main_top_bar_right";
                
                var cardActionMenu = document.createElement("img");
                cardActionMenu.className = "card_main_top_bar_right_arrow";
                cardActionMenu.src = ic_mainpage_arrow_down;
                headPartRoot.cardActionMenu = cardActionMenu;

                addOnClickListener(cardActionMenuRoot, titleResponseListener, 1, "");
                cardActionMenuRoot.appendChild(cardActionMenu);
                headPartRoot.appendChild(cardActionMenuRoot);
            }

            //如果不需要显示刷新按钮，则隐藏，如果需要显示则创建或显示
            if(!isNeedShowRefreshBtn) {
                if(headPartRoot.refreshButton) {
                    headPartRoot.refreshButton.style.display = "none";
                }
            } else {
                if(!headPartRoot.refreshButton) {
                    //右边的刷新按钮区域
                    var refreshButton = document.createElement("div");
                    refreshButton.className = "css_head_part_refreshbtn_div";

                    var refreshImg = document.createElement("img");
                    refreshImg.className = "css_operator_business_refresh_img";
                    refreshImg.src = ic_mainpage_refresh;
                    refreshButton.refreshImg = refreshImg;
                    refreshButton.appendChild(refreshImg);
                    refreshButton.disabled = false;
                    headPartRoot.refreshButton = refreshButton;
                    refreshBtnDiv = refreshButton;
                    
                    refreshButton.clickLogFocus = TELEPHONE_FEE_FOCUS;
                    refreshButton.clickLogId = "retryBtn";
                    addOnClickListener(refreshButton, userRightCornerRefresh);
                    headPartRoot.appendChild(refreshButton);
                } else {
                    stopLoading(headPartRoot.refreshButton.refreshImg);
                    headPartRoot.refreshButton.style.display = "inline-block";
                }
            }
        };

        //创建时两者都不显示
        headPartRoot.refreshData(false, false);

        cardContainInner.headPart = headPartRoot;
        cardContainInner.appendChild(headPartRoot);
    }

    function getUpdateTime(content) {
        try{
            return content.updateTime;
        }catch(e) {
            return null;
        }
    }

    function showCacheDataOrErrorPage(errorDesc) {
        if (isOpBusinessDataLegal(operatorBusinessData)) {
            showOperatorBusinessPage();
        } else {
            showErrorPage(errorDesc);
        }
    }

    function sendOPBAjaxRequest(handleCardRequestData, handleCardRequestFail) {
        console.log("HFLL_ sendOPBAjaxRequest()");
        var requestOptions = {};

        var cardRequestBaseInfo = getBseInfo();

        if (cardRequestBaseInfo && cardRequestBaseInfo.businessRequestUrl) {
            var timeStr = new Date().valueOf();
            requestOptions.url = cardRequestBaseInfo.businessRequestUrl + "?c=1007&gz=0&v=1.0&t=" + timeStr;
        } else {
            if(handleCardRequestFail && typeof handleCardRequestFail == 'function') {
                handleCardRequestFail();
            }
            return;
        }
        
        //requestOptions.url = DEFAULT_URL;

        requestOptions.cmd = "1007";
        requestOptions.onSuccess = handleCardRequestData;
        requestOptions.onFail = handleCardRequestFail;

        var base = organizeJsonBaseData(cardRequestBaseInfo);
        if(!base){
            base = {};
        }

        var requestJson = {
            "cmd": "1007",
            "base" : base,
            "param":{
                "id":operatorBusinessData.id,
                "version":"" + operatorBusinessData.version,
                "extendParam":{}
            }
        };
        requestOptions.data = JSON.stringify(requestJson);

        sendJsonAjaxRequest(requestOptions);
    }

    function sendDataRequest(triggerFromScene) {
        console.log("HFLL_ sendDataRequest() triggerFromScene: " + triggerFromScene + " isRequesting: " + isRequesting);
        if(isRequesting) {
            return;
        }
        updateTrigger = triggerFromScene;

        var netState = isNetConnect();

        if(triggerFromScene == UPDATE_TRIGGER_FRAME_LOAD) {
            console.log("HFLL_ sendDataRequest() requestCondition: " + requestCondition + " netState: " + netState);
            //框架创建时，按首次置的状态决定是否发出请求，包括卡片默认开和卡片后开
            if (1 == requestCondition) {
                //不用判断网络，直接请求，所以往下走即可
                console.log("HFLL_ sendDataRequest() rc1");
            } else if (2 == requestCondition) {
                console.log("HFLL_ sendDataRequest() rc2");
                //需要判断网络，然后决定是否请求，有网则请求
                if (!netState) {
                    console.log("HFLL_ sendDataRequest() rc2n");
                    handleRequestFail(null, triggerFromScene, TIP_NO_NET);
                    return;
                }
            } else {
                handleRequestFail(null, triggerFromScene, TIP_NO_NET);
                return;
            }
        } else {
            //其他情况都判断网络，再决定是否请求
            if (!netState) {
                handleRequestFail(null, triggerFromScene, TIP_NO_NET);
                return;
            }
        }
        if(!isRequesting) {
            isRequesting = true;
        } else {
            //数据正在请求的处理
            console.log("HFLL_ sendDataRequest is requesting");
            return;
        }
        
        isNeedNotifyFrame = true;

        sendOPBAjaxRequest(function (data) {
            isRequesting = false;
            handleRequestSuccess(data, triggerFromScene);
        }, function (data) {
            isRequesting = false;
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
        });
    }

    function handleRequestSuccess(data, triggerFromScene) {
        if (!data) {
            console.log("HFLL_ handleRequestSuccess error 1");
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        var returnedData = null;
        try {
            returnedData = JSON.parse(data);
        }catch (e) {
            console.log("HFLL_ returnedData is not json: " + data);
        }
        if(!returnedData) {
            console.log("HFLL_ handleRequestSuccess error 2");
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        if (returnedData.status != "success") {
            console.log("HFLL_ handleRequestSuccess error 3");
            handleRequestFail(data, triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        //校验返回结果
        if(!isOpBusinessDataLegal(returnedData)) {
            console.log("HFLL_ handleRequestSuccess error 4");
            handleRequestFail(data,triggerFromScene, TIP_NET_EXCEPTION);
            return;
        }
        if(isNeedNotifyFrame) {
            isNeedNotifyFrame = false;
            listener.callBack(operatorBusinessData.id,  CARD_CONTENT_REQUEST_SUCCESS);
        }
        console.log("HFLL_ returnedData.content " + JSON.stringify(returnedData.content));

        //为下一次用户刷新请求使用
        errorCode = DEFAULT_ERROR;

        console.log("HFLL_ handleRequestSuccess data: " + data);
        operatorBusinessData.content = returnedData.content;
        initDataUnit(operatorBusinessData);
        if(operatorBusinessData.content) {
            operatorBusinessData.content.imsi = currentImsi;
        }
        cacheMgr.setCache(operatorBusinessData.id, JSON.stringify(operatorBusinessData));
        if(!operatorBusinessData.show) {
            cardContainer.style.display = "none";
        }
        showOperatorBusinessPage();
    }

    function handleRequestFail(data, triggerFromScene, netTip) {
        console.log("HFLL_ handleRequestFail data: " + data);

        //这里如果有数据表示是校验错误，就不用回调了
        if(isNeedNotifyFrame) {
            isNeedNotifyFrame = false;
            listener.callBack(operatorBusinessData.id, CARD_CONTENT_REQUEST_FAILE);
        }
        
        if(!operatorBusinessData.show) {
            cardContainer.style.display = "none";
        } else {
            //卡片在显示，而且有缓存时，用户触发，需要toast提示
            if(netTip && isOpBusinessDataLegal(operatorBusinessData) && triggerFromScene === UPDATE_TRIGGER_USER) {
                exec("UIComponents", "showToast", [netTip, 1]);
            }
        }
        errorCode = DEFAULT_ERROR;
        try {
            if (data) {
                var jsonData = JSON.parse(data);
                errorCode = jsonData.errorCode;
            }
        } catch (e) {
            console.error("HFLL_ error data is not json");
        }
        var isStartedAuth = startAuthIfNeed();
        if(!isStartedAuth) {
            showCacheDataOrErrorPage();
        }
    }

    function startAuthIfNeed() {
        var result = exec("UIComponents","isNewUserGuide",[]);
        var realResult = getResultMessage(result);
        console.log("HFLL_ startAuthIfNeed exec : " + realResult);
        if (!realResult) {
            if (isFirstIn && (TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode)) {
                sendDataRefreshOrAuth("fail_auto_auth");
                isFirstIn = false;
                return true;
            }
        } else {
            window.onUserGuideClick = function(result) {
                isFirstIn = false;
                if (TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode) {
                    sendDataRefreshOrAuth("fail_auto_auth");
                }
            };
        }
        return false;
    }

    function showRefreshingPage() {
        console.log("HFLL_ showRefreshingPage()");
        if(cardContainInner.contentPartContainer.operatorBusinessPageView) {
            cardContainInner.contentPartContainer.operatorBusinessPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.errorPageView) {
            cardContainInner.contentPartContainer.errorPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.refreshingPageView) {
            cardContainInner.contentPartContainer.refreshingPageView.style.display = "block";
            try {
                cardContainInner.contentPartContainer.refreshingPageView.refreshData();
            }catch (e) {
                console.log("HFLL_ contentPartContainer.refreshingPageView.refreshData fail");
            }
        } else {
            var refreshingPage = createOperatorBusinessWaitingView();
            cardContainInner.contentPartContainer.refreshingPageView = refreshingPage;
            cardContainInner.contentPartContainer.appendChild(refreshingPage);
        }

    }

    function showOperatorBusinessPage() {
        console.log("HFLL_ showOperatorBusinessPage() ");
        if(cardContainInner.contentPartContainer.errorPageView) {
            cardContainInner.contentPartContainer.errorPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.refreshingPageView) {
            cardContainInner.contentPartContainer.refreshingPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.operatorBusinessPageView) {
            cardContainInner.contentPartContainer.operatorBusinessPageView.style.display = "block";
            try {
                cardContainInner.contentPartContainer.operatorBusinessPageView.refreshData();
            }catch (e) {
                console.log("HFLL_ contentPartContainer.operatorBusinessPageView.refreshData fail");
            }
        } else {
            var operatorPage = createOperatorBusinessMainPage();
            cardContainInner.contentPartContainer.operatorBusinessPageView = operatorPage;
            cardContainInner.contentPartContainer.appendChild(operatorPage);
        }
    }

    function showErrorPage(errorDesc) {
        console.log("HFLL_ showErrorPage() " + errorDesc);
        if(cardContainInner.contentPartContainer.operatorBusinessPageView) {
            cardContainInner.contentPartContainer.operatorBusinessPageView.style.display = "none";
        }
        if(cardContainInner.contentPartContainer.refreshingPageView) {
            cardContainInner.contentPartContainer.refreshingPageView.style.display = "none";
        }
        var errorCodeShow = errorCode;
        if(errorDesc == WAIT_FOR_AUTH_ERROR) {
            errorCodeShow = errorDesc;
        }
        console.log("HFLL_ errorCodeShow: " + errorCodeShow);
        if(cardContainInner.contentPartContainer.errorPageView) {
            cardContainInner.contentPartContainer.errorPageView.style.display = "block";
            try {
                cardContainInner.contentPartContainer.errorPageView.refreshData(errorCodeShow);
            }catch (e) {
                console.log("HFLL_ contentPartContainer.errorPageView.refreshData fail");
            }
        } else {
            var errorPage = createOperatorBusinessErrorView(errorCodeShow);
            cardContainInner.contentPartContainer.errorPageView = errorPage;
            cardContainInner.contentPartContainer.appendChild(errorPage);
        }
    }

    function isEmptyStr(str) {
        if(!str || str === "") {
            return true;
        }
        return false;
    }

    function isOpBusinessDataLegal(data) {
        console.log("HFLL_ isOpBusinessDataLegal param: " + JSON.stringify(data));
        try {
            var content = data.content;
            //共同校验
            var detailText = content.bottomButton[0].name;
            console.log("HFLL_ isOpBusinessDataLegal detailText: " + detailText);
            if(isEmptyStr(detailText)) {
                return false;
            }
            var detailUrl = content.bottomButton[0].url;
            console.log("HFLL_ isOpBusinessDataLegal detailUrl: " + detailUrl);
            if(isEmptyStr(detailUrl)) {
                return false;
            }

            var operator = content.operator;
            if(operator == "cmcc") {
                var updateTime = content.updateTime;
                console.log("HFLL_ isOpBusinessDataLegal updateTime: " + updateTime);
                if(isEmptyStr(updateTime)) {
                    return false;
                }

                //解析话费流量
                var isBalanceEmpty = false;
                if(!content.bill) {
                    isBalanceEmpty = true;
                } else {
                    var balance = content.bill.balance;
                    console.log("HFLL_ isOpBusinessDataLegal balance: " + balance);
                    if(isEmptyStr(balance) || isNaN(Number(balance))) {
                        isBalanceEmpty = true;
                    }
                }
                if(isBalanceEmpty) {
                    if(!content.bill) {
                        content.bill = {};
                    }
                    content.bill.balance = ERROR_VALUE;
                    content.bill.unit = "元";
                }
                //解析GPRS
                var isGPRSEmpty = false;
                if(!content.gprs) {
                    isGPRSEmpty = true;
                } else {
                    var gprs = content.gprs.left;
                    console.log("HFLL_ isOpBusinessDataLegal gprs: " + gprs);
                    if(isEmptyStr(gprs) || isNaN(Number(gprs))) {
                        isGPRSEmpty = true;
                    }
                }
                if(isGPRSEmpty) {
                    if(!content.gprs) {
                        content.gprs = {};
                    }
                    content.gprs.left = ERROR_VALUE;
                    content.gprs.unit = UNIT_MB;
                }
                console.log("HFLL_ isBalanceEmpty: " + isBalanceEmpty + " isGPRSEmpty:" + isGPRSEmpty);
                return !(isBalanceEmpty && isGPRSEmpty);
            }

            return true;
        } catch (e) {
            console.log("HFLL_ error happened: " + e);
            return false;
        }
    }

    function initDataUnit(data) {
        try {
            var content = data.content;
            var balance = content.bill.balance;
            var balanceValue = Number(balance);
            if (isNaN(balanceValue)) {
                content.bill.balance = ERROR_VALUE;
                content.bill.unit = "元";
            } else {
                var isBalanceNegativeValue = false;
                if (balanceValue < 0) {
                    isBalanceNegativeValue = true;
                }
                var showBalanceValue = Math.abs(balanceValue);
                if (showBalanceValue > CREDIT_UNIT_LIMIT * CREDIT_UNIT * CREDIT_UNIT) {
                    content.bill.balance = ERROR_VALUE;
                    content.bill.unit = "元";
                } else if (showBalanceValue >= CREDIT_UNIT * CREDIT_UNIT) {
                    showBalanceValue = showBalanceValue / CREDIT_UNIT / CREDIT_UNIT;
                    showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showBalanceValue > CREDIT_UNIT_LIMIT) {
                        content.bill.balance = ERROR_VALUE;
                        content.bill.unit = "元";
                    } else {
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "亿元";
                    }
                } else if (showBalanceValue >= CREDIT_UNIT) {
                    showBalanceValue = showBalanceValue / CREDIT_UNIT;
                    showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showBalanceValue > CREDIT_UNIT_LIMIT) {
                        showBalanceValue = showBalanceValue / CREDIT_UNIT;
                        showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "亿元";
                    } else {
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "万元";
                    }
                } else {
                    showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showBalanceValue > CREDIT_UNIT_LIMIT) {
                        showBalanceValue = showBalanceValue / CREDIT_UNIT;
                        showBalanceValue = showBalanceValue.toFixed(VALUE_FIXED_NUMBER);
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "万元";
                    } else {
                        content.bill.balance = "" + showBalanceValue;
                        content.bill.unit = "元";
                    }
                }
                if (isBalanceNegativeValue) {
                    var balanceShow = content.bill.balance;
                    var resultBalanceNumber = Number(balanceShow);
                    if (!isNaN(resultBalanceNumber)) {
                        //负数超过四位的处理
                        if (resultBalanceNumber >= 1000) {
                            var fixedResultBalanceNumber = resultBalanceNumber.toFixed(1);
                            if(fixedResultBalanceNumber >= CREDIT_UNIT) {
                                resultBalanceNumber = fixedResultBalanceNumber / CREDIT_UNIT;
                                resultBalanceNumber = resultBalanceNumber.toFixed(VALUE_FIXED_NUMBER);
                                if(content.bill.unit === "元") {
                                    content.bill.balance = "-" + resultBalanceNumber;
                                    content.bill.unit = "万元";
                                } else if(content.bill.unit === "万元") {
                                    content.bill.balance = "-" + resultBalanceNumber;
                                    content.bill.unit = "亿元";
                                } else {
                                    content.bill.balance = ERROR_VALUE;
                                    content.bill.unit = "元";
                                }
                            } else {
                                content.bill.balance = "-" + fixedResultBalanceNumber;
                            }
                        } else {
                            content.bill.balance = "-" + balanceShow;
                        }
                    }
                }
            }

            var gprs = content.gprs.left;
            var gprsValue = Number(gprs);
            if (isNaN(gprsValue)) {
                content.gprs.left = ERROR_VALUE;
                content.gprs.unit = UNIT_MB;
            } else {
                var isGPRSNegativeValue = false;
                if (gprsValue < 0) {
                    isGPRSNegativeValue = true;
                }
                var showGPRSValue = Math.abs(gprsValue);
                if (showGPRSValue > TRAFFIC_UNIT_LIMIT * TRAFFIC_UNIT * TRAFFIC_UNIT) {
                    content.gprs.left = ERROR_VALUE;
                    content.gprs.unit = UNIT_MB;
                } else if (showGPRSValue >= TRAFFIC_UNIT * TRAFFIC_UNIT) {
                    showGPRSValue = showGPRSValue / TRAFFIC_UNIT / TRAFFIC_UNIT;
                    showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showGPRSValue > TRAFFIC_UNIT_LIMIT) {
                        content.gprs.left = ERROR_VALUE;
                        content.gprs.unit = UNIT_MB;
                    } else {
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_TB;
                    }
                } else if (showGPRSValue >= TRAFFIC_UNIT) {
                    showGPRSValue = showGPRSValue / TRAFFIC_UNIT;
                    showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showGPRSValue > TRAFFIC_UNIT_LIMIT) {
                        showGPRSValue = showGPRSValue / TRAFFIC_UNIT;
                        showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_TB;
                    } else {
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_GB;
                    }
                } else {
                    showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                    if (showGPRSValue > TRAFFIC_UNIT_LIMIT) {
                        showGPRSValue = showGPRSValue / TRAFFIC_UNIT;
                        showGPRSValue = showGPRSValue.toFixed(VALUE_FIXED_NUMBER);
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_GB;
                    } else {
                        content.gprs.left = "" + showGPRSValue;
                        content.gprs.unit = UNIT_MB;
                    }
                }
                if (isGPRSNegativeValue) {
                    var leftGPRS = content.gprs.left;
                    var resultGPRSNumber = Number(leftGPRS);
                    if (!isNaN(resultGPRSNumber)) {
                        //负数超过四位的处理
                        if (resultGPRSNumber >= 1000) {
                            var fixedResultGPRSNumber = resultGPRSNumber.toFixed(1);
                            if(fixedResultGPRSNumber >= TRAFFIC_UNIT) {
                                resultGPRSNumber = fixedResultGPRSNumber / TRAFFIC_UNIT;
                                resultGPRSNumber = resultGPRSNumber.toFixed(VALUE_FIXED_NUMBER);
                                if(content.gprs.unit === UNIT_MB
                                    || content.gprs.unit === UNIT_MB_OLD) {
                                    content.gprs.left = "-" + resultGPRSNumber;
                                    content.gprs.unit = UNIT_GB;
                                } else if(content.gprs.unit === UNIT_GB
                                    || content.gprs.unit === UNIT_GB_OLD) {
                                    content.gprs.left = "-" + resultGPRSNumber;
                                    content.gprs.unit = UNIT_TB;
                                } else {
                                    content.gprs.left = ERROR_VALUE;
                                    content.gprs.unit = UNIT_MB;
                                }
                            } else {
                                content.gprs.left = "-" + fixedResultGPRSNumber;
                            }
                        } else {
                            content.gprs.left = "-" + leftGPRS;
                        }
                    }
                }
            }
        } catch (e) {
            console.log("initDataUnit() error happened " + e);
        }
    }

    function recordClickLog(clickPosId, clickPosFocus) {
        console.log("HFLL_ recordClickLog() param is " + clickPosId + " " + clickPosFocus);
        if( "errorTip" === clickPosId && currentErrorCode === WAIT_FOR_AUTH_ERROR) {
            console.log("HFLL_ waiting auth not need record log");
            return;
        }
        if(clickPosFocus) {
            exec("WidgetMMPContainerComponents", "appenCardCpaLog", [clickPosFocus]);
        }
        if(clickPosId) {
            exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.bill, clickPosId]);
        }
    }

    function addOnClickListener(div, func, funcParams, pressColor) {
        if (!div || !func || typeof(func) != "function") {
            return;
        }
        if(!pressColor) {
            pressColor = "";
        }
        if(div.touchStartFunc) {
            div.removeEventListener("touchstart", div.touchStartFunc, false);
        }
        if(div.touchMoveFunc) {
            div.removeEventListener("touchmove",div.touchMoveFunc , false);
        }
        if(div.touchEndFunc) {
            div.removeEventListener("touchend", div.touchEndFunc, false);
        }
        var targetElement = null;
        var touchStartFunc = function () {
            console.log("HFLL_ touchstart: div= " + div);
            event.stopPropagation();
            targetElement = div;
            moveOverCheck.start(event);
            targetElement.style.backgroundColor = pressColor;
        };
        div.touchStartFunc = touchStartFunc;
        div.addEventListener("touchstart",touchStartFunc , false);

        var touchMoveFunc = function () {
            console.log("HFLL_ touchmove: div= " + div);
            event.stopPropagation();
            if (targetElement) {
                targetElement.style.background = "";
                if (moveOverCheck.check(event)) {
                    console.log("HFLL_ touchmove: div= " + div + " is moveing");
                    targetElement = null;
                }
            }
        };
        div.touchMoveFunc = touchMoveFunc;
        div.addEventListener("touchmove",touchMoveFunc , false);

        var touchEndFunc = function () {
            console.log("HFLL_ touchend: div= " + div);
            event.stopPropagation();
            if (targetElement) {
                // 回调处理
                targetElement.style.background = "";
                console.log("HFLL_ touchend: div= " + div + " real end");
                recordClickLog(div.clickLogId, div.clickLogFocus);
                func(funcParams);
            }
            targetElement = null;
        };
        div.touchEndFunc = touchEndFunc;
        div.addEventListener("touchend", touchEndFunc, false);
    }

    /********************动画刷新相关***************************/
    function startLoading(refreshBtn) {
        if(!refreshBtn) {
            console.log("HFLL_ startLoading() param not legal");
            return;
        }
        //停止加载动画
        if (rotateId) {
            stopRotateAnimation(rotateId);
            rotateId = null;
        }
        refreshBtn.src = frame_loading_img;
        //开始动画
        rotateId = startRotateAnimation(refreshBtn);
    }

    function stopLoading(refreshBtn) {
        if(!refreshBtn) {
            console.log("HFLL_ stopLoading() param not legal");
            return;
        }
        //停止加载动画
        if (rotateId) {
            stopRotateAnimation(rotateId);
            rotateId = null;
            resetRotateAnimation(refreshBtn);
        }
        refreshBtn.src = ic_mainpage_refresh;
    }

    /**********************界面创建相关*****************************/
    function createOperatorBusinessMainPage() {
        function createContentPart(isCmcc) {
            var contentPartRoot = document.createElement("div");
            contentPartRoot.className = "css_content_part_div";

            contentPartRoot.refreshData = function(isCmcc) {
                if(!contentPartRoot.phoneCreditPart) {
                    var phoneCreditPart = createPhoneCreditPart(isCmcc);
                    contentPartRoot.phoneCreditPart = phoneCreditPart;
                    contentPartRoot.appendChild(phoneCreditPart);
                } else {
                    contentPartRoot.phoneCreditPart.refreshData(isCmcc);
                }
                if(!contentPartRoot.usedTrafficPart) {
                    var usedTrafficPart = createUsedTrafficPart(isCmcc);
                    contentPartRoot.usedTrafficPart = usedTrafficPart;
                    contentPartRoot.appendChild(usedTrafficPart);
                } else {
                    contentPartRoot.usedTrafficPart.refreshData(isCmcc);
                }

                //如果不需要显示更新时间，则隐藏，否则创建或显示之
                if(!isCmcc) {
                    if(contentPartRoot.updateTime) {
                        contentPartRoot.updateTime.style.display = "none";
                    }
                } else {
                    if(!contentPartRoot.updateTime) {
                        var updateTime = document.createElement("div");
                        updateTime.className = "css_head_part_updatetime_div";
                        updateTimeDiv = updateTime;
                        contentPartRoot.updateTime = updateTime;
                        updateTime.addEventListener("click", function(){}, false);
                        contentPartRoot.appendChild(updateTime);
                    } else {
                        contentPartRoot.updateTime.style.display = "inline-block";
                    }
                    contentPartRoot.updateTime.innerText = "更新于: " + getUpdateTime(operatorBusinessData.content);
                }
            };
            contentPartRoot.refreshData(isCmcc);
            return contentPartRoot;
        }

        function createPhoneCreditPart(isCmcc) {
            var phoneCreditPartRoot = document.createElement("div");
            phoneCreditPartRoot.className = "css_content_part_phonecredit_part_div";

            phoneCreditPartRoot.refreshData = function(isCmcc) {
                if(isCmcc) {
                    if(phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot) {
                        phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot.style.display = "none";
                    }
                    if(!phoneCreditPartRoot.phoneCreditClickCmccPartRoot) {
                        var phoneCreditClickCmccPartRoot = document.createElement("div");
                        phoneCreditClickCmccPartRoot.className = "css_content_part_phonecredit_click_cmcc_part_div";
                        phoneCreditPartRoot.phoneCreditClickCmccPartRoot = phoneCreditClickCmccPartRoot;
                        phoneCreditPartRoot.appendChild(phoneCreditClickCmccPartRoot);

                        var phoneCreditCenterWrapperCmcc = document.createElement("div");
                        phoneCreditCenterWrapperCmcc.className = "css_content_part_phonecredit_centerwrapper_cmcc_div";
                        phoneCreditClickCmccPartRoot.appendChild(phoneCreditCenterWrapperCmcc);

                        var phoneCreditDiv = document.createElement("div");
                        phoneCreditDiv.className = "css_content_part_phonecredit_part_phonecredit_div";
                        phoneCreditDiv.innerText = "话费余额";
                        phoneCreditCenterWrapperCmcc.appendChild(phoneCreditDiv);

                        var phoneCreditVauleDiv = document.createElement("div");
                        phoneCreditPartRoot.phoneCreditVauleDiv = phoneCreditVauleDiv;
                        phoneCreditCenterWrapperCmcc.appendChild(phoneCreditVauleDiv);

                        var phoneCreditUnit = document.createElement("div");
                        phoneCreditUnit.innerText = "元";
                        phoneCreditPartRoot.phoneCreditUnit = phoneCreditUnit;
                        phoneCreditCenterWrapperCmcc.appendChild(phoneCreditUnit);
                        
                        phoneCreditClickCmccPartRoot.clickLogFocus = TELEPHONE_FEE_FOCUS;
                        phoneCreditClickCmccPartRoot.clickLogId = "cmccCredit";
                        addOnClickListener(phoneCreditClickCmccPartRoot, goToPhoneCreditDetailPage, null ,"#efefef");
                    } else {
                        phoneCreditPartRoot.phoneCreditClickCmccPartRoot.style.display = "block";
                    }
                    var phoneCredit = getPhoneCredit(operatorBusinessData.content);
                    var numberCredit = Number(phoneCredit);
                    phoneCreditPartRoot.phoneCreditVauleDiv.innerText = phoneCredit;
                    phoneCreditPartRoot.phoneCreditUnit.innerText = getPhoneCreditUnit(operatorBusinessData.content);
                    var isNeedShowRed = false;
                    if(!isNaN(numberCredit)) {
                        if(numberCredit < 0) {
                            isNeedShowRed = true;
                        } else if(0<= numberCredit && numberCredit < 20) {
                            if(getPhoneCreditUnit(operatorBusinessData.content) === "元") {
                                isNeedShowRed = true;
                            }
                        }
                    }
                    if(isNeedShowRed) {
                        phoneCreditPartRoot.phoneCreditVauleDiv.className = "css_content_part_phonecredit_part_phonecreditvalue_red_div";
                        phoneCreditPartRoot.phoneCreditUnit.className = "css_content_part_phonecredit_part_phonecreditunit_red_div";
                    } else {
                        phoneCreditPartRoot.phoneCreditVauleDiv.className = "css_content_part_phonecredit_part_phonecreditvalue_div";
                        phoneCreditPartRoot.phoneCreditUnit.className = "css_content_part_phonecredit_part_phonecreditunit_div";
                    }
                } else {
                    //非移动结果展示
                    if(phoneCreditPartRoot.phoneCreditClickCmccPartRoot) {
                        phoneCreditPartRoot.phoneCreditClickCmccPartRoot.style.display = "none";
                    }
                    if(!phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot) {
                        var phoneCreditClickNonCmccPartRoot = document.createElement("div");
                        phoneCreditClickNonCmccPartRoot.className = "css_content_part_phonecredit_click_noncmcc_part_div";
                        phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot = phoneCreditClickNonCmccPartRoot;
                        phoneCreditPartRoot.appendChild(phoneCreditClickNonCmccPartRoot);
                        var phoneCreditCenterWrapperNonCmcc = document.createElement("div");
                        phoneCreditCenterWrapperNonCmcc.className = "css_content_part_phonecredit_centerwrapper_noncmcc_div";
                        phoneCreditClickNonCmccPartRoot.appendChild(phoneCreditCenterWrapperNonCmcc);

                        var phoneCreditQueryImgDiv = document.createElement("img");
                        phoneCreditQueryImgDiv.className = "css_content_part_phonecredit_part_phonecreditqueryimg_div";
                        phoneCreditQueryImgDiv.src = ic_mainpage_calls;
                        phoneCreditCenterWrapperNonCmcc.appendChild(phoneCreditQueryImgDiv);

                        var phoneCreditQueryTextDiv = document.createElement("div");
                        phoneCreditQueryTextDiv.className = "css_content_part_phonecredit_part_phonecreditquerytext_div";
                        phoneCreditQueryTextDiv.innerText = "短信查话费";
                        phoneCreditCenterWrapperNonCmcc.appendChild(phoneCreditQueryTextDiv);
                        
                        phoneCreditClickNonCmccPartRoot.clickLogFocus = TELEPHONE_FEE_FOCUS;
                        phoneCreditClickNonCmccPartRoot.clickLogId = "noncmccCredit";
                        addOnClickListener(phoneCreditClickNonCmccPartRoot, smsQueryPhoneCredit, null, "#efefef");
                    } else {
                        phoneCreditPartRoot.phoneCreditClickNonCmccPartRoot.style.display = "block";
                    }
                }
            };
            phoneCreditPartRoot.refreshData(isCmcc);
            return phoneCreditPartRoot;
        }

        function createUsedTrafficPart(isCmcc) {
            var usedTrafficPartRoot = document.createElement("div");
            usedTrafficPartRoot.className = "css_content_part_usedtraffic_part_div";
            usedTrafficPartRoot.refreshData = function(isCmcc) {
                if(isCmcc) {
                    if(usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot) {
                        usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot.style.display = "none";
                    }
                    if(!usedTrafficPartRoot.usedTrafficClickCmccPartRoot) {
                        var usedTrafficClickCmccPartRoot = document.createElement("div");
                        usedTrafficClickCmccPartRoot.className = "css_content_part_usedtraffic_click_cmcc_part_div";
                        usedTrafficPartRoot.usedTrafficClickCmccPartRoot = usedTrafficClickCmccPartRoot;
                        usedTrafficPartRoot.appendChild(usedTrafficClickCmccPartRoot);
                        var usedTrafficCenterWrapperCmcc = document.createElement("div");
                        usedTrafficCenterWrapperCmcc.className = "css_content_part_usedtraffic_centerwrapper_cmcc_div";
                        usedTrafficClickCmccPartRoot.appendChild(usedTrafficCenterWrapperCmcc);

                        var usedTrafficDiv = document.createElement("div");
                        usedTrafficDiv.className = "css_content_part_usedtraffic_part_usedtraffic_div";
                        usedTrafficDiv.innerText = "剩余流量";
                        usedTrafficCenterWrapperCmcc.appendChild(usedTrafficDiv);

                        var usedTrafficVauleDiv = document.createElement("div");
                        usedTrafficVauleDiv.className = "css_content_part_usedtraffic_part_usedtrafficvalue_div";
                        usedTrafficPartRoot.usedTrafficVauleDiv = usedTrafficVauleDiv;
                        usedTrafficCenterWrapperCmcc.appendChild(usedTrafficVauleDiv);

                        var usedTrafficUnit = document.createElement("div");
                        usedTrafficUnit.className = "css_content_part_usedtraffic_part_usedtrafficunit_div";
                        usedTrafficUnit.innerText = UNIT_MB;
                        usedTrafficPartRoot.usedTrafficUnit = usedTrafficUnit;
                        usedTrafficCenterWrapperCmcc.appendChild(usedTrafficUnit);
                        
                        usedTrafficClickCmccPartRoot.clickLogFocus = DATA_TRANSFER_FOCUS;
                        usedTrafficClickCmccPartRoot.clickLogId = "cmccTraffic";
                        addOnClickListener(usedTrafficClickCmccPartRoot, goToUsedTrafficDetailPage, null, "#efefef");
                    } else {
                        usedTrafficPartRoot.usedTrafficClickCmccPartRoot.style.display = "block";
                    }
                    usedTrafficPartRoot.usedTrafficVauleDiv.innerText = getUsedTraffic(operatorBusinessData.content);
                    usedTrafficPartRoot.usedTrafficUnit.innerText = getUsedTrafficUnit(operatorBusinessData.content);
                } else {
                    if(usedTrafficPartRoot.usedTrafficClickCmccPartRoot) {
                        usedTrafficPartRoot.usedTrafficClickCmccPartRoot.style.display = "none";
                    }
                    if(!usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot) {
                        var usedTrafficClickNonCmccPartRoot = document.createElement("div");
                        usedTrafficClickNonCmccPartRoot.className = "css_content_part_usedtraffic_click_noncmcc_part_div";
                        usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot = usedTrafficClickNonCmccPartRoot;
                        usedTrafficPartRoot.appendChild(usedTrafficClickNonCmccPartRoot);
                        var usedTrafficCenterWrapperNonCmcc = document.createElement("div");
                        usedTrafficCenterWrapperNonCmcc.className = "css_content_part_usedtraffic_centerwrapper_noncmcc_div";
                        usedTrafficClickNonCmccPartRoot.appendChild(usedTrafficCenterWrapperNonCmcc);

                        var usedTrafficQueryImgDiv = document.createElement("img");
                        usedTrafficQueryImgDiv.className = "css_content_part_usedtraffic_part_usedtrafficqueryimg_div";
                        usedTrafficQueryImgDiv.src = ic_mainpage_flow;
                        usedTrafficCenterWrapperNonCmcc.appendChild(usedTrafficQueryImgDiv);

                        var usedTrafficQueryTextDiv = document.createElement("div");
                        usedTrafficQueryTextDiv.className = "css_content_part_usedtraffic_part_usedtrafficquerytext_div";
                        usedTrafficQueryTextDiv.innerText = "短信查流量";
                        usedTrafficCenterWrapperNonCmcc.appendChild(usedTrafficQueryTextDiv);
                        
                        usedTrafficClickNonCmccPartRoot.clickLogFocus = DATA_TRANSFER_FOCUS;
                        usedTrafficClickNonCmccPartRoot.clickLogId = "noncmccTraffic";
                        addOnClickListener(usedTrafficClickNonCmccPartRoot, smsQueryUsedTraffic, null, "#efefef");
                    } else {
                        usedTrafficPartRoot.usedTrafficClickNonCmccPartRoot.style.display = "block";
                    }
                }
            };
            usedTrafficPartRoot.refreshData(isCmcc);
            return usedTrafficPartRoot;
        }

        function createFootPart() {
            var footPartRoot = document.createElement("div");
            footPartRoot.className = "css_card_bottom_btn";
            
            footPartRoot.clickLogFocus = TELEPHONE_FEE_FOCUS;
            footPartRoot.clickLogId = "moreBtn";
            addOnClickListener(footPartRoot, goToDetailPage, null, "#efefef");
            footPartRoot.refreshData = function() {
                footPartRoot.innerText = getDetailName(operatorBusinessData.content);
            };
            footPartRoot.refreshData();
            return footPartRoot;
        }

        function goToDetailPage() {
            var detailUrl = getDetailUrl(operatorBusinessData.content);
            console.log("HFLL_ goToDetailPage: " + detailUrl);
            exec("UIComponents", "openBrowser", ["", detailUrl]);
        }
        
        function goToPhoneCreditDetailPage() {
            var pcurl = getPhoneCreditUrl(operatorBusinessData.content);
            console.log("HFLL_ goToPhoneCreditDetailPage: " + pcurl);
            exec("UIComponents", "openBrowser", ["", pcurl]);
        }
        
        function goToUsedTrafficDetailPage() {
            var uturl = getUsedTrafficUrl(operatorBusinessData.content);
            console.log("HFLL_ goToUsedTrafficDetailPage: " + uturl);
            exec("UIComponents", "openBrowser", ["", uturl]);
        }

        function smsQueryPhoneCredit() {
            console.log("HFLL_ smsQueryPhoneCredit()");
            exec("lxOvsExtComponents", "queryBySms", ["queryTelFee"]);
        }

        function smsQueryUsedTraffic() {
            console.log("HFLL_ smsQueryUsedTraffic()");
            exec("lxOvsExtComponents", "queryBySms", ["queryDataTrans"]);
        }

        function getPhoneCredit(content) {
            try{
                return content.bill.balance;
            }catch(e) {
                return null;
            }
        }
        
        function getPhoneCreditUrl(content) {
            var url = null;
            try{
                url = content.bill.url;
                if(isEmptyStr(url)) {
                    url = getDetailUrl(content);
                }
            }catch(e) {
                url = getDetailUrl(content);
            }
            return url;
        }

        function getPhoneCreditUnit(content) {
            try{
                return content.bill.unit;
            }catch(e) {
                return null;
            }
        }

        function getUsedTraffic(content) {
            try{
                return content.gprs.left;
            }catch(e) {
                return null;
            }
        }
        
        function getUsedTrafficUrl(content) {
            var url = null;
            try{
                url = content.gprs.url;
                if(isEmptyStr(url)) {
                    url = getDetailUrl(content);
                }
            }catch(e) {
                url = getDetailUrl(content);
            }
            return url;
        }

        function getUsedTrafficUnit(content) {
            try{
                return content.gprs.unit;
            }catch(e) {
                return null;
            }
        }

        function getDetailName(content) {
            try{
                return content.bottomButton[0].name;
            }catch(e) {
                console.log("HFLL_ getDetailName error :" + e);
                return null;
            }
        }

        function getDetailUrl(content) {
            try{
                return content.bottomButton[0].url;
            }catch(e) {
                console.log("HFLL_ getDetailUrl error: " + e);
                return null;
            }
        }

        function getOperator(content) {
            try {
                return content.operator;
            }catch (e) {
                return null;
            }
        }

        console.log("HFLL_ createOperatorMainPage() ");
        var operatorContentPart = document.createElement("div");

        operatorContentPart.refreshData = function () {
            var isCmccFlag = (getOperator(operatorBusinessData.content) == "cmcc");
            //显示刷新按钮，是否显示更新时间由是否移动结果判定
            cardContainInner.headPart.refreshData(true, isCmccFlag);

            if (!operatorContentPart.contentPartDiv) {
                var contentPartDiv = createContentPart(isCmccFlag);
                operatorContentPart.contentPartDiv = contentPartDiv;
                operatorContentPart.appendChild(contentPartDiv);
            } else {
                operatorContentPart.contentPartDiv.refreshData(isCmccFlag);
            }

            if (!operatorContentPart.footPartDiv) {
                var footPartDiv = createFootPart();
                operatorContentPart.footPartDiv = footPartDiv;
                operatorContentPart.appendChild(footPartDiv);
            } else {
                operatorContentPart.footPartDiv.refreshData(isCmccFlag);
            }
        };

        operatorContentPart.refreshData();
        return operatorContentPart;
    }

    function createOperatorBusinessWaitingView() {
        console.log("HFLL_ createOperatorBusinessWaitingView: ");

        var contentDiv = document.createElement("div");
        contentDiv.className = "css_waiting_view_content";

        var waitingIcon = document.createElement("img");
        waitingIcon.className = "css_waiting_view_icon";
        waitingIcon.src = frame_loading_img;
        startLoading(waitingIcon);
        contentDiv.appendChild(waitingIcon);

        var waitingTip = document.createElement("div");
        waitingTip.className = "css_waiting_view_text";
        waitingTip.innerText = "正在加载";
        contentDiv.appendChild(waitingTip);

        contentDiv.refreshData = function() {
            //更新和刷新都不需要显示
            cardContainInner.headPart.refreshData(false, false);
        };

        contentDiv.refreshData();

        return contentDiv;
    }

    function createOperatorBusinessErrorView(errorCodeParam) {
        console.log("HFLL_ createOperatorBusinessErrorView: ");
        currentErrorCode = errorCodeParam;

        var contentDiv = document.createElement("div");
        contentDiv.className = "css_error_view_content";
        var errorTip = document.createElement("div");
        errorTip.className = "css_error_view_text";
        contentDiv.errorTip = errorTip;
        contentDiv.appendChild(errorTip);
        
        errorTip.clickLogFocus = TELEPHONE_FEE_FOCUS;
        errorTip.clickLogId = "errorTip";
        addOnClickListener(errorTip, userErrorRefresh, errorCodeParam, "#efefef");

        contentDiv.refreshData = function(errorCodeParam) {
            currentErrorCode = errorCodeParam;
            //更新和刷新都不需要显示
            cardContainInner.headPart.refreshData(false, false);
            contentDiv.errorTip.innerText = getTipByErrorCode(errorCodeParam);
        };

        contentDiv.refreshData(errorCodeParam);
        return contentDiv;
    }

    function getTipByErrorCode(errorCode){
        var tip = "加载失败，点击重试";
        if(TOKEN_INEFFCTIVE_ERROR == errorCode || COMMON_NO_TOKEN_ERROR == errorCode) {
            tip = "该手机号未激活，点击激活";
        } else if(WAIT_FOR_AUTH_ERROR == errorCode) {
            tip = "手机号激活中，请稍候...";
        }
        return tip;
    }

    function userErrorRefresh() {
        console.log("HFLL_ userErrorRefresh() errorCode:" + currentErrorCode);
        if(currentErrorCode == WAIT_FOR_AUTH_ERROR) {
            return;
        }
        sendDataRefreshOrAuth("error_page");
    }

    function handleOperatorBusiness() {
        isCssLoaded = true;
        cardContainInner.innerHTML = "";

        //创建共同的头部部分,更新时间和刷新按钮先不创建
        createHeadPart();

        //内容部分占位div
        var contentPartContainer = document.createElement("div");
        cardContainInner.contentPartContainer = contentPartContainer;
        cardContainInner.appendChild(contentPartContainer);

        //展示缓存数据
        if (isOpBusinessDataLegal(operatorBusinessData)) {
            showOperatorBusinessPage();
        } else {
            showRefreshingPage();
        }
        sendDataRequest(UPDATE_TRIGGER_FRAME_LOAD);
        var card_bottom_shadow = document.createElement("div");
        card_bottom_shadow.className = "css_card_bottom_shadow";
        cardContainInner.appendChild(card_bottom_shadow);
        isCardContentCreated = true;
    }

    return createCardFrame;
});