define(function() {
	var defaultData;
	var cacheData;
	var cardDiv;
	var isRequest = false;  //是否正在请求数据
	var isCacheNew = false;   //数据是否已更新
	var currentPage = 0;  //当前页数
	var requestCondition = 0;//0:无网络，不需要请求;1:不判断网络，直接请求;2：判断网络，再请求 
	var MAX_NUM_GAME = 4;
	var RECENT_GAME_KEY = "com.iflytek.cmcc.GAME_RECENT";
	
	var zdOffDom = null;
    var speechCaseDom = null;
	
	//banner载入时的默认界面
	var img_game_default = "./game/res/ic_mainpage_game_default.png";
	
	var opCodeKey = {
		"banner": "banner",
		"list": "list",
		"changeBtn": "switchBtn",
		"moreBtn": "moreBtn"
	};
	
	/** 游戏Banner元素的缓存*/
	var gameBannerCache = {};
	/** 游戏列表项元素的缓存*/
	var gameItemCache = {};
	
	function create(cardDefaultData, initNetState) {
		console.log("create card begin: " + cardDefaultData.id);
		filterH5Game(cardDefaultData);
		defaultData = cardDefaultData;
		
		cardDiv = document.createElement("div");
		cardDiv.id = defaultData.id;
		cardDiv.updateState = updateState;
		
		//读取缓存,判断是否需要显示
		var cacheString = cacheMgr.getCache(defaultData.id);
		console.log("create, cacheString is " + cacheString);
		
		if(cacheString) {
    		try {
    			cacheData = JSON.parse(cacheString);
    			console.log("create, defaultData version is " + defaultData.version);
    			if(cacheData.version != defaultData.version) {
    				console.log("create, version error");
    				defaultData.show = cacheData.show;
    				cacheData = defaultData;
    			}
    		} catch(e) {
    			console.log("create, JSON error");
    			cacheData = defaultData;
    		}
    	} else {
    		cacheData = defaultData;
    	}
    	//将数据存入缓存
    	cacheMgr.setCache(cacheData.id, JSON.stringify(cacheData));
    	
    	/** 注册更新请求回调，框架调用*/
    	cardDiv.updateData = function(){
    		console.log("updateData");
            if (cacheData.show) {
                requestGameCard();
            } else {
                if (!isRequest) {
                    listener.callBack(defaultData.id, CARD_CONTENT_NO_REQUEST);
                }
            }
        };
    	
    	if(cacheData && cacheData.show) {
    		if (initNetState) {
                requestCondition = 1;
            }
            else {
                requestCondition = 0;
            }
    		//加载资源CSS等
    		loadResource(onLoadResourceFinish);
    	} else {
    		//通知框架结果
    		noticeFrame(CARD_CONTENT_NO_REQUEST);
    		requestCondition = 2;
    	}
		
    	if(cacheData) {
    		cardDiv.initShowState = cacheData.show;
    	}
		return cardDiv;
	}
	
	/** 加载CSS*/
	function loadResource(onLoadResourceFinish) {
		xcssParser.parseStyleFile("./game/business.x.css", onLoadResourceFinish);
	}
	
	/** 资源文件加载完成回调，开始创建卡片内容*/
	function onLoadResourceFinish() {
		var innerDiv;
		if(cacheData.content) {
			innerDiv = createContentView(cacheData);
			cardDiv.contentView = innerDiv;
			cardDiv.showContentPage = showContentPage;
		} else {
			innerDiv = createEmptyView();
			cardDiv.emptyView = innerDiv;
		}
		cardDiv.appendChild(innerDiv);
		
		/** 显示不同的视图 1-内容页，2-空白页，3-刷新页*/
		cardDiv.showView = function(viewType) {
			console.log("showView, viewType is " + viewType);
			if(cardDiv.firstChild) {
				cardDiv.firstChild.style.display = "none";
			}
			if(1 == viewType) {
				cardDiv.contentView.style.display = "block";
			} else if(2 == viewType) {
				cardDiv.emptyView.style.display = "block";
			} else if(3 == viewType) {
				cardDiv.refreshView.style.display = "block";
			}
		};
		
		if(cacheData.show) {
			if(0 === requestCondition) {
				//没有网络，不需要请求，但是需要回调
                listener.callBack(defaultData.id, CARD_CONTENT_REQUEST_FAILE);
			} else {
				requestGameCard();
			}
		}
	}
	
	function createContentView(cardData) {
		console.log("createContentView");
		var contentDiv = document.createElement("div");
		contentDiv.className = "css_card";
		
		//初始化为第一页
		currentPage = 1;
		
		var gameTitle = createCardMainTitle(cardData.id, defaultData.name, defaultData.caseList[0], titleResponseListener);
		contentDiv.appendChild(gameTitle);
		var body = createBody(cardData.content);
		contentDiv.appendChild(body);
		contentDiv.body = body;
		contentDiv.appendChild(createFooter(cardData.content.bottomButton));
		
		var card_bottom_shadow = document.createElement("div");
	    card_bottom_shadow.className = "css_card_bottom_shadow";
	    contentDiv.appendChild(card_bottom_shadow);
		return contentDiv;
	}
	
	function createEmptyView() {
		console.log("createEmptyView");
		var emptyDiv = document.createElement("div");
		emptyDiv.className = "css_card css_card_game_empty";
		emptyDiv.appendChild(createTitle());
		
		var card_bottom_shadow = document.createElement("div");
	    card_bottom_shadow.className = "css_card_bottom_shadow css_card_game_bottom_shadow";
	    emptyDiv.appendChild(card_bottom_shadow);
		return emptyDiv;
	}
	
	function createRefreshView() {
		console.log("createRefreshView");
		var refreshDiv = document.createElement("div");
		refreshDiv.className = "css_card css_card_game_refresh";
		refreshDiv.appendChild(createTitle());
		
		var refreshBody = document.createElement("div");
		refreshBody.className = "css_card_game_refresh_body";
		refreshDiv.appendChild(refreshBody);
		
		var errorView = document.createElement("div");
		errorView.className = "css_card_game_refresh_error_view";
		errorView.innerText = "加载失败，点击重试";
		refreshBody.appendChild(errorView);
		
		var loadingView = document.createElement("div");
		loadingView.className = "css_card_game_refresh_loading_view";
		var game_card_loading_div_img = document.createElement("img");
        game_card_loading_div_img.className = "css_card_game_refresh_loading_img";
        game_card_loading_div_img.src = frame_loading_img;
        var game_card_loading_div_txt = document.createElement("div");
        game_card_loading_div_txt.className = "css_card_game_refresh_loading_txt";
        game_card_loading_div_txt.innerText = "正在加载";
        loadingView.appendChild(game_card_loading_div_img);
        loadingView.appendChild(game_card_loading_div_txt);
        refreshBody.appendChild(loadingView);
        
        var gameRotateId;
        refreshDiv.startRoate = function() {
        	console.log("startRoate");
            if(gameRotateId) {
                stopRotateAnimation(gameRotateId);
                gameRotateId = null;
            }
            gameRotateId = startRotateAnimation(game_card_loading_div_img);
            
            errorView.style.display = "none";
            loadingView.style.display = "block";
        };
        refreshDiv.stopRoate = function() {
        	console.log("stopRoate");
            if(gameRotateId) {
                stopRotateAnimation(gameRotateId);
                gameRotateId = null;
            }
            
            loadingView.style.display = "none";
            errorView.style.display = "block";
        };
        
        refreshBody.addEventListener("touchstart", function() {
					moveOverCheck.start(event);
				}, false);
		refreshBody.addEventListener("touchmove", function() {
					moveOverCheck.check(event);
				}, false);
		refreshBody.addEventListener("touchend", function() {
					if (!moveOverCheck.isMoveOver()) {
						if(errorView.style.display != "none") {
							refreshDiv.startRoate();
							requestGameCard();
						}
					}
				}, false);
		
		return refreshDiv;
	}
	
	function createBody(content) {
		console.log("createBody, content is " + JSON.stringify(content));
		var bodyDiv = document.createElement("div");
		
		//banner大图区域
		if(content.banners && content.banners.length > 0) {
			var banner = content.banners[0];
			var bigImgContainer;
			if(banner.id) {
				//先尝试获取缓存的元素
				bigImgContainer = gameBannerCache[banner.id];
			}
			
			//没有缓存则新创建
			if(!bigImgContainer) {
				console.log("nocache, create bigImgContainer");
				bigImgContainer = document.createElement("div");
				bigImgContainer.className = "css_card_game_big_image_container";
				bigImgContainer.gameInfo = banner;
				//加入缓存
				if(banner.id && banner.id.length > 0) {
					gameBannerCache[banner.id] = bigImgContainer;
				}
				bigImgContainer.addEventListener("touchstart", function() {
							event.stopPropagation();
							moveOverCheck.start(event);
						}, false);
				bigImgContainer.addEventListener("touchmove", function() {
							event.stopPropagation();
							moveOverCheck.check(event);
						}, false);
				bigImgContainer.addEventListener("touchend", function() {
					event.stopPropagation();
					if (!moveOverCheck.isMoveOver()) {
						var gameInfo = this.gameInfo;
						exec('UIComponents', "openBrowser", ["", gameInfo.url]);

						updateRecentGame(gameInfo);

						exec("LogComponents", "addCmccLog", [cpaCode.game]);
						exec("WidgetMMPContainerComponents", "appenCardOpLog",
								[cardOpCode.game, opCodeKey.banner]);
					}
				}, false);

				var bigImg = document.createElement("img");
				bigImg.className = "css_card_game_big_image";
				bigImg.onerror = function() {
					bigImg.src = img_game_default;
					if (bigImg.gameId && bigImg.gameId.length > 0) {
						// 图片加载失败时，清除相应的缓存
						console.log("clear banner cache, id is " + bigImg.gameId);
						gameBannerCache[bigImg.gameId] = null;
					}
				};
				bigImg.src = banner.imgUrl;
				bigImg.gameId = banner.id;
				
				bigImgContainer.appendChild(bigImg);
			}

			bodyDiv.appendChild(bigImgContainer);
		}
		
		//游戏列表区域
		var listView = createGameListView(content);
		bodyDiv.appendChild(listView);
		bodyDiv.page = listView;
		
		/** 更换新的一页内容*/
		bodyDiv.changePage = function() {
			currentPage++;
			console.log("changePage, currentPage is " + currentPage);
			var newPage = createGameListView(content);
			this.removeChild(this.page);
			this.appendChild(newPage);
			this.page = newPage;
		};
		
		return bodyDiv;
	}
	
	/** 创建游戏列表*/
	function createGameListView(content) {
		var listView = document.createElement("div");
		//游戏列表区域
		if(content.games && content.games.length > 0) {
			listView.className = "css_card_game_list_view";
			
			var games = getGamesByPage(currentPage);
			for(var i = 0; i < games.length; i++) {
				var gameInfo = games[i];
				
				var gameItemContainer = null;
				if(gameInfo.id) {
					//先尝试获取缓存的元素
					gameItemContainer = gameItemCache[gameInfo.id];
				}
				
				//没有缓存则新创建
				if(!gameItemContainer) {
					console.log("nocache, create gameItemContainer");
					gameItemContainer = document.createElement("div");
					gameItemContainer.className = "css_card_game_item_container";
					gameItemContainer.gameInfo = gameInfo;
					// 加入缓存
					if (gameInfo.id && gameInfo.id.length > 0) {
						gameItemCache[gameInfo.id] = gameItemContainer;
					}

					// 游戏图标
					var smallImg = document.createElement("img");
					smallImg.className = "css_card_game_small_image";
					smallImg.src = gameInfo.icon;
					smallImg.gameId = gameInfo.id;
					smallImg.onerror = function() {
						this.style.display = "none";
						if (this.gameId && this.gameId.length > 0) {
							// 图片加载失败时，清除相应的缓存
							console.log("clear icon cache, id is " + this.gameId);
							gameItemCache[this.gameId] = null;
						}
					};

					var smallImgContainer = document.createElement("div");
					smallImgContainer.className = "css_card_game_small_image_container";
					smallImgContainer.appendChild(smallImg);
					gameItemContainer.appendChild(smallImgContainer);

					// 游戏名称
					var name = document.createElement("div");
					name.className = "css_card_game_item_name";
					name.innerText = cutName(gameInfo.name);
					gameItemContainer.appendChild(name);

					// 进入游戏按钮
					var playBtn = document.createElement("div");
					playBtn.className = "css_card_game_item_play_btn";
					playBtn.innerText = "马上玩";
					
					gameItemContainer.appendChild(playBtn);
				}
				
				//更新位置信息
				gameItemContainer.position = i;
				listView.appendChild(gameItemContainer);
			}
			
			//游戏列表添加点击事件
			var targetItem;
			listView.addEventListener("touchstart", function() {
						event.stopPropagation();
						moveOverCheck.start(event);
						targetItem = getParentOfClass("css_card_game_item_container", event.target);
						if (targetItem) {
							targetItem.style.backgroundColor = "#efefef";
						}
					}, false);
			listView.addEventListener("touchmove", function() {
						event.stopPropagation();
						moveOverCheck.check(event);
						if (targetItem) {
							targetItem.style.backgroundColor = "";
						}
					}, false);
			listView.addEventListener("touchend", function() {
						event.stopPropagation();
						if (targetItem) {
							targetItem.style.backgroundColor = "";
						}
						if (!moveOverCheck.isMoveOver()) {
							if (targetItem) {
								var gameInfo = targetItem.gameInfo;
								updateRecentGame(gameInfo);
								
								exec('UIComponents', "openBrowser", ["",gameInfo.url]);
								
								exec("LogComponents", "addCmccLog",[cpaCode.game]);
								exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.game, opCodeKey.list + (targetItem.position + 1)]);
							}
							
						}
					}, false);
		}
		return listView;
	}
	
	/** 创建底部按钮*/
	function createFooter(bottomButton) {
		console.log("createFooter");
		
		var footer = document.createElement("div");
		footer.className = "css_card_bottom_btn";
		
		var leftBtn = document.createElement("div");
		leftBtn.className = "css_card_game_bottom_left";
		leftBtn.innerText = "换一换";
		leftBtn.index = 1;
		footer.appendChild(leftBtn);
		
		var rightBtn = document.createElement("div");
		rightBtn.className = "css_card_game_bottom_right";
		rightBtn.innerText = bottomButton[0].name;
		rightBtn.link = bottomButton[0].url;
		rightBtn.index = 2;
		footer.appendChild(rightBtn);
		
		var targetItem;
		footer.addEventListener("touchstart", function(){
			event.stopPropagation();
			moveOverCheck.start(event);
			targetItem = getParentOfClass("css_card_game_bottom_left", event.target);
			if(targetItem) {
				targetItem.style.backgroundColor = "#efefef";
			} else {
				targetItem = getParentOfClass("css_card_game_bottom_right", event.target);
				if(targetItem) {
					targetItem.style.backgroundColor = "#efefef";
				}
			}
		},false);
		footer.addEventListener("touchmove", function(){
			event.stopPropagation();
			if (moveOverCheck.check(event)) {
				if(targetItem) {
					targetItem.style.backgroundColor = "";
				}
            }
		},false);
		footer.addEventListener("touchend", function(){
			event.stopPropagation();
			if(targetItem) {
				targetItem.style.backgroundColor = "";
			}
            if (!moveOverCheck.isMoveOver()) {
            	if(targetItem) {
            		if(targetItem.index == 1) {
            			//点击左边按钮
            			if(cardDiv.contentView) {
            				cardDiv.contentView.body.changePage();
            			}
            			
            			exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.game, opCodeKey.changeBtn]);
            		} else if(targetItem.index == 2) {
            			//点击右边按钮
            			exec('UIComponents',"openBrowser",["网页小游戏", targetItem.link]);
            			
            			exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.game, opCodeKey.moreBtn]);
            		}
            	}
            	
            	exec("LogComponents", "addCmccLog",[cpaCode.game]);
            }
		},false);
		
		return footer;
	}
	
	/** 获取第pageIndex页的banner*/
	function getBannerByPage(pageIndex) {
		console.log("getBannerByPage, pageIndex is " + pageIndex);
		var pageNum = cacheData.content.banners.length;
		console.log("getBannerByPage, pageNum is " + pageNum);
		return cacheData.content.banners[(pageIndex-1)%pageNum];
	}
	
	/** 获取第pageIndex页的多个游戏*/
	function getGamesByPage(pageIndex) {
		console.log("getGamesByPage, pageIndex is " + pageIndex);
		var games = cacheData.content.games;
		
		//针对小于等于4个的情况特殊处理，否则一页上会有两个相同游戏
		if(games.length <= 4) {
			return games;
		}
		
		//第pageIndex页的开始序列号
		var startNum = ((pageIndex-1)*MAX_NUM_GAME)%games.length;
		
		var result = [];
		for(var i = 0; i < 4; i++) {
			//计算实际的位置
			var position = (startNum + i)%games.length;
			result[i] = games[position];
		}
		return result;
	}
	
	/** 更新内容*/
	function updateContent(cardData) {
		console.log("game card updateContent");
		
		var newContent = createContentView(cardData);
		if (cardDiv.contentView) {
			cardDiv.removeChild(cardDiv.contentView);
		}
		cardDiv.contentView = newContent;
		cardDiv.appendChild(newContent);
	}
	
	/** 请求游戏卡片数据 */
    function requestGameCard(){
    	console.log("requestGameCard");
    	//请求数据
    	var params = {};
		params.cardID = defaultData.id;
		params.versionCode = defaultData.version;
    	params.onSuccess = onSuccess;
    	params.onFail = onFail;
    	
    	var cardRequestBaseInfo = getBseInfo();
	    
	    if (cardRequestBaseInfo && cardRequestBaseInfo.businessRequestUrl) {
	    	var timeStr = new Date().valueOf();
		    params.url = cardRequestBaseInfo.businessRequestUrl + "?c=1007&gz=0&v=1.0&t=" + timeStr;
	    } else {
	    	cardRequestBaseInfo = null;
	    	noticeFrame(CARD_CONTENT_REQUEST_FAILE);
	    	return;
	    }
	    
	    var base = organizeJsonBaseData(cardRequestBaseInfo);
	    if(!base){
	    	base = {};
	    }
		var requestJson = {
			"cmd": "1007",
			"base": base,
			"param": {
			      "id": defaultData.id,
			      "version": "" + defaultData.version,
			      "extendParam":{}
			}
		};
		
		params.data = JSON.stringify(requestJson);
	
	    sendJsonAjaxRequest(params);
    }
    
    /** 请求成功处理*/
    function onSuccess(jsonStr) {
    	console.log("requestGameCard, onSuccess");
    	isRequest = false;
    	
    	if(cardDiv.refreshView && cardDiv.refreshView.display != "none") {
    		//如果当前是刷新页则停止刷新动画
    		cardDiv.refreshView.stopRoate();
    	}
    	
    	try {
			var jsonObj = JSON.parse(jsonStr);
			if (jsonObj) {
				console.log("requestGameCard, errorCode is "
						+ jsonObj.errorCode);
				if ("success" == jsonObj.status) {
					cacheData.content = jsonObj.content;
					filterH5Game(cacheData);
					saveCache(cacheData);
					isCacheNew = true;
					updateContent(cacheData);
					// 通知框架结果
					noticeFrame(CARD_CONTENT_REQUEST_SUCCESS);
				} else {
					console.log("requestGameCard, errorCode is not 000000");
					// 通知框架结果
					noticeFrame(CARD_CONTENT_REQUEST_FAILE);
				}
			}
		} catch (e) {
			console.log("requestGameCard, JSON error, e is " + e);
			// 通知框架结果
			noticeFrame(CARD_CONTENT_REQUEST_FAILE);
		}

    }
    
    /** 请求失败处理*/
    function onFail() {
    	console.log("requestGameCard, onFail");
		isRequest = false;
		
		if(cardDiv) {
			if(cardDiv.emptyView && cardDiv.emptyView.style.display != "none") {
				//如果当前是空白页则显示刷新页
				var refreshView = createRefreshView();
				cardDiv.refreshView = refreshView;
				cardDiv.appendChild(refreshView);
			} else if(cardDiv.refreshView && cardDiv.refreshView.display != "none") {
				//如果当前是刷新页则停止刷新动画
				cardDiv.refreshView.stopRoate();
			}
		}
		
		// 通知框架结果
		noticeFrame(CARD_CONTENT_REQUEST_FAILE);
    }
    
    /** 保存卡片数据到缓存*/
    function saveCache(cardData) {
		var objToSave = JSON.stringify(cardData);
		console.log("saveCache, objToSave is " + objToSave);
		cacheMgr.setCache(cardData.id, objToSave);
	}
    
    /** 开关卡片*/
	function updateState(show) {
		console.log("updateState, show is " + show);
		//更新缓存
		cacheData.show = show;
    	saveCache(cacheData);
    	
		if(show) {
			cardDiv.style.display = "block";
			if(cardDiv.children.length === 0) {  //如果内容为空需要去加载资源
				console.log("updateState, content is empty");
				loadResource(onLoadResourceFinish);
			} else {
				if (!isCacheNew && !isRequest) {
					console.log("updateState, requestGameCard");
					requestGameCard();
				}
				showContentPage();
			}
		} else {
			cardDiv.style.display = "none";
		}
	}
	
	/** 通知框架层卡片加载情况*/
	function noticeFrame(value) {
		if (listener) {
			listener.callBack(cacheData.id, value);
		}
	}
	
	/** 更新最近游戏列表*/
	function updateRecentGame(gameInfo) {
		console.log("updateRecentGame, game is " + gameInfo.name);
		var dataStr = exec("SystemComponents", "getSetting", [RECENT_GAME_KEY, 3]);
		console.log("getSetting is " + dataStr);
		
		var message = getResultMessage(dataStr);
		var gameList;
		if(message.value) {
			try {
				gameList = JSON.parse(message.value);
			} catch (e) {
				console.log("updateRecentGame, error is " + e);
				gameList = [];
			}
		} else {
			gameList = [];
		}
		
		//如果已存在则删除原有游戏信息
		for(var i=0;i<gameList.length;i++) {
			var info = gameList[i];
			if(info.url == gameInfo.url) {
				console.log("game exist, name is " + gameInfo.name);
				gameList.splice(i, 1);
				break;
			}
		}
		
		//向数组开头添加游戏信息
		gameList.unshift(gameInfo);
		
		//如果长度过长，删除最后一个
		if(gameList.length > 5) {
			gameList.pop();
		}
		
		exec("SystemComponents", "setSetting", [RECENT_GAME_KEY, JSON.stringify(gameList), 3]);
	}
	
	/** 过滤掉APP类型的游戏*/
	function filterH5Game(cardData) {
		var banners = cardData.content.banners;
		var newBanners = [];
		for(var i=0;i<banners.length;i++) {
			var banner = banners[i];
			if(banner.type == "H5") {
				newBanners.push(banner);
			}
		}
		var games = cardData.content.games;
		var newGames = [];
		for(var j=0;j<games.length;j++) {
			var game = games[j];
			if(game.type == "H5") {
				newGames.push(game);
			}
		}
		
		cardData.content.banners = newBanners;
		cardData.content.games = newGames;
	}
	
	/** 对游戏名称进行分割*/
	function cutName(rawName) {
		if(rawName.length <= 5) {
			return rawName;
		} else {
			return rawName.substr(0,4) + "...";
		}
	}
	
	/** 显示内容区域*/
	function showContentPage() {
		console.log("showContentPage");
		if(zdOffDom) {
            zdOffDom.style.display = "none";
        }
        if(speechCaseDom) {
            speechCaseDom.style.display = "none";
        }
        if(cardDiv.contentView) {
        	cardDiv.contentView.style.display = "block";
        }
	}
	
	/** 标题栏点击事件回调*/
	function titleResponseListener(responseId){
		console.log("titleResponseListener, responseId is " + responseId);
		switch(responseId) {
            case 0://点击说法示例区域
                if(zdOffDom) {
                    zdOffDom.style.display = "none";
                }
                
                cardDiv.contentView.style.display = "none";
                if (speechCaseDom) {
                    speechCaseDom.style.display = "block";
                } else {
                    speechCaseDom = createSpeechCaseView(cacheData.id, defaultData.name, defaultData.caseList);
                    //判断一下是否为空
                    if(null != speechCaseDom) {
                    	speechCaseDom.setCancelListener(speechCaseCallBack);
                    	cardDiv.appendChild(speechCaseDom);
                    }
                }
                break;
            case 1://点击置顶箭头按钮
                if(speechCaseDom) {
                    speechCaseDom.style.display = "none";
                }
                cardDiv.contentView.style.display = "none";
                
                if (zdOffDom) {
                    zdOffDom.style.display = "block";
                } else {
                    zdOffDom = createOperationView(cacheData.id, defaultData.name);
                    //判断一下是否为空
                    if( null != zdOffDom) {
                    	zdOffDom.setOpListener(operateCallBack);
                    	cardDiv.appendChild(zdOffDom);
                    }
                }
                break;
            case 2://刷新，暂时没有实现
                break;
            default:
                break;
        }
	}
	
	/** 说法示例点击回调*/
	function speechCaseCallBack(){
        showContentPage();
    }
    
    /** 置顶关闭按钮点击回调*/
    function operateCallBack(callBackId) {
        switch(callBackId) {
            case 0://取消
                showContentPage();
                break;
            case 1://置顶
                showContentPage();
                stickTopCardByDom(cardDiv);
                break;
            case 2://点击关闭
                //显示关闭确认弹框，暂时未实现
                showCloseConfirmDialogById(cacheData.id);
                break;
            
            default:
                break;
        }
    }
    
    return create;
});