define(function(){
    var cardContainer = null;
    var lifeArea = null;
    var lifeCardData = null;
    var lifeXcssParsed = false;
    
	var zdOffDom = null;
    var speechCaseDom = null;
	
    function create(lifeData){
        console.log("create life card begins: " + lifeData.id);
        if (!lifeData) {
            console.log("lifeData is null");
            return;
        }
        lifeCardData = lifeData;
        console.log("lifeCardData.id: " + lifeCardData.id);
        console.log("lifeCardData.version: " + lifeCardData.version);
        
        cardContainer = document.createElement("div");
        cardContainer.id = lifeCardData.id;
        lifeArea = document.createElement("div");
        lifeArea.className = "css_card";
        
        // 卡片管理更新显示状态
        cardContainer.updateState = function(state){
            if (state) {
                if (lifeXcssParsed) {
                    cardContainer.style.display = "block";
					//showContentPage();
                }
                else {
                    lifeXcssParsed = true;
                    xcssParser.parseStyleFile("./life/business.x.css", onResourceLoadFinish);
                }
                lifeCardData.show = true;
            }
            else {
                cardContainer.style.display = "none";
                lifeCardData.show = false;
            }
            
            // 缓存
            cacheMgr.setCache(lifeCardData.id, JSON.stringify(lifeCardData));
        };
        
        // 读取缓存
        var lifeCacheData = null;
        var lifeCacheString = cacheMgr.getCache(lifeData.id);
        if (lifeCacheString) {
            if (typeof lifeCacheString == "string") {
                try {
                    lifeCacheData = JSON.parse(lifeCacheString);
                } 
                catch (e) {
                    console.log("JSON parse exception");
                }
            }
        }
        if (lifeCacheData) {
            lifeCardData.show = lifeCacheData.show;
            if (lifeCacheData.version == lifeData.version) {
				// 保证卡片的caseList使用默认数据
				lifeCardData.caseList = lifeData.caseList;
            }
			cacheMgr.setCache(lifeCardData.id, JSON.stringify(lifeCardData));
        }
        else {
            cacheMgr.setCache(lifeCardData.id, JSON.stringify(lifeCardData));
        }
        
        if (lifeCardData.show) {
            lifeXcssParsed = true;
            xcssParser.parseStyleFile("./life/business.x.css", onResourceLoadFinish);
        }
        
        listener.callBack(lifeCardData.id, CARD_CONTENT_NO_REQUEST);
        
		cardContainer.date_type = "card";
        cardContainer.initShowState = lifeCardData.show;
		
		return cardContainer;
    }
    
    
	
	 function operateCallBack(callBackId) {
        switch(callBackId) {
            case 0://取消
                zdOffDom.style.display = "none";
                lifeArea.style.display = "block";
                break;
            case 1://置顶
                zdOffDom.style.display = "none";
                lifeArea.style.display = "block";
                stickTopCardByDom(cardContainer);
                break;
            case 2://点击关闭
                //显示关闭确认弹框，暂时未实现
                showCloseConfirmDialogById(cardContainer.id);
                break;
            
            default:
                break;
        }
    }
    function speechCaseCallBack(){
        if(zdOffDom) {
            zdOffDom.style.display = "none";
        }
        if(speechCaseDom) {
            speechCaseDom.style.display = "none";
        }
        lifeArea.style.display = "block";
    }
    function titleResponseListener(responseId){
        switch(responseId) {
            case 0://点击说法示例区域
                if(zdOffDom) {
                    zdOffDom.style.display = "none";
                }
                
                lifeArea.style.display = "none";
                if (speechCaseDom) {
                    speechCaseDom.style.display = "block";
                } else {
                    speechCaseDom = createSpeechCaseView(lifeCardData.id, lifeCardData.name, lifeCardData.caseList);
                    //判断一下是否为空
                    speechCaseDom.setCancelListener(speechCaseCallBack);
                    cardContainer.appendChild(speechCaseDom);
                }
                break;
            case 1://点击置顶箭头按钮
                if(speechCaseDom) {
                    speechCaseDom.style.display = "none";
                }
                lifeArea.style.display = "none";
                
                if (zdOffDom) {
                    zdOffDom.style.display = "block";
                } else {
                    zdOffDom = createOperationView(lifeCardData.id, lifeCardData.name);
                    //判断一下是否为空
                    zdOffDom.setOpListener(operateCallBack);
                    cardContainer.appendChild(zdOffDom);
                }
                break;
            case 2://刷新，暂时没有实现
                break;
            default:
                break;
        }
    }
    function showContentPage(){
        if(zdOffDom) {
            zdOffDom.style.display = "none";
        }
        if(speechCaseDom) {
            speechCaseDom.style.display = "none";
        }
        lifeArea.style.display = "block";
    }
	
	
    function onResourceLoadFinish(){
        console.log("onResourceLoadFinish begins");
        createLifeArea();
    }
    
    function createLifeArea(){
        console.log("createLifeArea begins");
        
        //var titleDiv = createTitleDiv();
		var titleDiv = createCardMainTitle(lifeCardData.id, lifeCardData.name, lifeCardData.caseList[0], titleResponseListener);
        
        var contentDiv_with_logo = document.createElement("div");
        contentDiv_with_logo.className = 'life_content_with_logo';
        contentDiv_with_logo.appendChild(createContentDiv_with_logo());
        
        //var contentDiv_only_title = document.createElement("div");
        //contentDiv_only_title.className = 'life_content_only_title';
        //contentDiv_only_title.appendChild(createContentDiv_only_title());
        
        //底部添加阴影
        var card_bottom_shadow = document.createElement("div");
        card_bottom_shadow.className = "css_card_bottom_shadow";
        
        lifeArea.appendChild(titleDiv);
        lifeArea.appendChild(contentDiv_with_logo);
        //lifeArea.appendChild(contentDiv_only_title);
        lifeArea.appendChild(createFooter());
        lifeArea.appendChild(card_bottom_shadow);
        cardContainer.appendChild(lifeArea);
		cardContainer.showContentPage = showContentPage;
    }
    
    function createTitleDiv(){
        console.log("createTitleDiv begins");
        var titleDiv = document.createElement("div");
        titleDiv.className = "css_card_title_bar";
        var label = document.createElement("label");
        label.className = "css_card_title_text";
        label.innerText = lifeCardData.name;
        titleDiv.appendChild(label);
        return titleDiv;
    }
    
    // 创建底部按钮
    function createFooter(){
        console.log("createFooter");
        
        var footer = document.createElement("div");
        footer.className = "css_card_bottom_btn";
        footer.opKey = "moreBtn";
        
        if (lifeCardData.content.bottomButton && lifeCardData.content.bottomButton.length > 0) {
            footer.innerHTML = lifeCardData.content.bottomButton[0].name;
            footer.url = lifeCardData.content.bottomButton[0].url;
        }
        else {
            footer.innerHTML = "查看更多";
            footer.url = "http://hao.uc.cn/business?source=ydlx";
        }
        
        var targetItem = null;
        var cardBottomMove = false;
        footer.addEventListener("touchstart", function(){
            console.log("footer touchstart");
            event.stopPropagation();
            moveOverCheck.start(event);
            cardBottomMove = false;
            targetItem = event.target;
            if (targetItem) {
                targetItem.style.backgroundColor = "#efefef";
            }
        }, false);
        footer.addEventListener("touchmove", function(){
            console.log("NovelCard footer touchmove");
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                cardBottomMove = true;
            }
            targetItem.style.backgroundColor = "";
        }, false);
        footer.addEventListener("touchend", function(){
            console.log("NovelCard footer touchend");
            event.stopPropagation();
            
            if (cardBottomMove == false) {
                targetItem.style.backgroundColor = "";
                if (targetItem) {
                    // 点击查看更多按钮
                    if (footer.url) {
                        exec('UIComponents', "openBrowser", ["", footer.url]);
                    }
                    exec("WidgetMMPContainerComponents", "appenCardCpaLog", ["website"]);
                    exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.life, footer.opKey]);
                    
                }
            }
            targetItem = null;
        }, false);
        
        return footer;
    }
    
    function createContentDiv_with_logo(){
        console.log("createContentDiv_with_logo begins");
        if (!lifeCardData.content.service) {
            return null;
        }
        var lifeContentFragments = createContentFragments_with_logo(lifeCardData.content.service);
        
        var tuochTarget = null;
        lifeArea.addEventListener("touchstart", function(){
            event.stopPropagation();
            // 避免同时出现按下两个按钮不回退的情况
            if (tuochTarget) {
                tuochTarget.backE.style.backgroundColor = "";
            }
            tuochTarget = getParentOfClass("life_temp_with_logo", event.target);
            if (tuochTarget) {
                tuochTarget.backE.style.backgroundColor = "#efefef";
                moveOverCheck.start(event);
            }
        }, false);
        
        lifeArea.addEventListener("touchmove", function(){
            event.stopPropagation();
            if (tuochTarget) {
                if (tuochTarget.backE) {
                    tuochTarget.backE.style.backgroundColor = "";
                }
                if (moveOverCheck.check(event)) {
                    tuochTarget = null;
                }
            }
        }, false);
        
        lifeArea.addEventListener("touchcancel", function(){
            event.stopPropagation();
            if (tuochTarget) {
                if (tuochTarget.backE) {
                    tuochTarget.backE.style.backgroundColor = "";
                }
                tuochTarget = null;
            }
        }, false);
        
        lifeArea.addEventListener("touchend", function(){
            event.stopPropagation();
            if (tuochTarget && tuochTarget.backE) {
                tuochTarget.backE.style.backgroundColor = "";
                exec("UIComponents", "openBrowser", ["", tuochTarget.attribute.link]);
                // 日志统计
                exec("WidgetMMPContainerComponents", "appenCardCpaLog", [tuochTarget.attribute.focus]);
                exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.life, tuochTarget.opCodeKey]);
            }
            tuochTarget = null;
        }, false);
        
        return lifeContentFragments;
    }
    
    // 卡片版本3不再使用
    function createContentDiv_only_title(){
        console.log("createContentDiv_only_title begins");
        var lifeContentFragments = createContentFragments_only_title(lifeCardData.content.onlyTitle);
        
        var tuochTarget = null;
        lifeArea.addEventListener("touchstart", function(){
            event.stopPropagation();
            // 避免同时出现按下两个按钮不回退的情况
            if (tuochTarget) {
                tuochTarget.backE.style.backgroundColor = "";
            }
            tuochTarget = getParentOfClass("life_temp_only_title", event.target);
            if (tuochTarget) {
                tuochTarget.backE.style.backgroundColor = "#efefef";
                moveOverCheck.start(event);
            }
        }, false);
        
        lifeArea.addEventListener("touchmove", function(){
            event.stopPropagation();
            if (tuochTarget) {
                if (tuochTarget.backE) {
                    tuochTarget.backE.style.backgroundColor = "";
                }
                if (moveOverCheck.check(event)) {
                    tuochTarget = null;
                }
            }
        }, false);
        
        lifeArea.addEventListener("touchcancel", function(){
            event.stopPropagation();
            if (tuochTarget) {
                if (tuochTarget.backE) {
                    tuochTarget.backE.style.backgroundColor = "";
                }
                tuochTarget = null;
            }
        }, false);
        
        lifeArea.addEventListener("touchend", function(){
            event.stopPropagation();
            if (tuochTarget && tuochTarget.backE) {
                tuochTarget.backE.style.backgroundColor = "";
                exec("UIComponents", "openBrowser", ["", tuochTarget.attribute.link]);
                // 日志统计
                exec("WidgetMMPContainerComponents", "appenCardCpaLog", [tuochTarget.attribute.focus]);
                exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.life, tuochTarget.opCodeKey]);
            }
            tuochTarget = null;
        }, false);
        
        return lifeContentFragments;
    }
    
    function createContentFragments_with_logo(content){
        console.log("createContentFragments_with_logo begins");
        var length = content.length;
        console.log("content withLog length: " + length);
        
        var contentFragments = null;
        if (content && length && length > 0) {
            contentFragments = document.createDocumentFragment();
            var grid = [];
            for (var nCount = 0; nCount < length; nCount++) {
                grid[nCount] = createGridDiv_with_logo(content[nCount], nCount);
                grid[nCount].attribute = content[nCount];
                grid[nCount].opCodeKey = "lifeCard" + ((nCount < 9) ? "0" : "") + (nCount + 1);
                contentFragments.appendChild(grid[nCount]);
            }
        }
        return contentFragments;
    }
    
    function createGridDiv_with_logo(tempData){
        console.log("createGridDiv_with_logo begins");
        
        var gridDiv = document.createElement("div");
        gridDiv.className = "life_temp_with_logo";
        
        var container = document.createElement("div");
        container.className = "life_temp_container_with_logo";
        
        var logo = document.createElement("img");
        var title = document.createElement("div");
        logo.className = "life_temp_logo";
        title.className = "life_temp_name_with_logo";
        
        logo.src = tempData.logoUrl;
        logo.onerror = function(){
            console.log("lifeCard logo load error, logo.src: " + logo.src);
        };
        title.innerHTML = tempData.name;
        
        container.appendChild(logo);
        container.appendChild(title);
        gridDiv.appendChild(container);
        
        gridDiv.backE = container;
        return gridDiv;
    }
    
    // 卡片版本3不再使用
    function createContentFragments_only_title(content){
        console.log("createContentFragments_only_title begins");
        var length = content.length;
        console.log("content onlyTitle length: " + length);
        
        var contentFragments = null;
        if (content && length && length > 0) {
            contentFragments = document.createDocumentFragment();
            var grid = [];
            for (var nCount = 0; nCount < length; nCount++) {
                grid[nCount] = createGridDiv_only_title(content[nCount], nCount);
                grid[nCount].attribute = content[nCount];
                var nCountNew = nCount + lifeCardData.content.withLogo.length;
                grid[nCount].opCodeKey = "lifeCard" + ((nCountNew < 9) ? "0" : "") + (nCountNew + 1);
                contentFragments.appendChild(grid[nCount]);
            }
        }
        return contentFragments;
    }
    
    // 卡片版本3不再使用
    function createGridDiv_only_title(tempData){
        console.log("createGridDiv_only_title begins");
        
        var gridDiv = document.createElement("div");
        gridDiv.className = "life_temp_only_title";
        
        var container = document.createElement("div");
        container.className = "life_temp_container_only_title";
        
        
        var title = document.createElement("div");
        title.className = "life_temp_name_only_title";
        title.innerHTML = tempData.name;
        
        container.appendChild(title);
        gridDiv.appendChild(container);
        
        gridDiv.backE = container;
        return gridDiv;
    }
    
    return create;
});
