define(function() {
	var defaultData;
	var cacheData;
	var cardDiv;
	var isRequest = false;  //是否正在请求数据
	var isCacheNew = false;   //数据是否已更新
	var requestCondition = 0;//0:无网络，不需要请求;1:不判断网络，直接请求;2：判断网络，再请求 
	var opCodeKey = {
		"banner": "banner",
		"hotRing": "hotRing",
		"category": "category",
		"moreBtn": "moreBtn"
	};
	
	var zdOffDom = null;
    var speechCaseDom = null;
	
	//banner载入时的默认界面
	var ic_mainpage_music_default = "./music/res/ic_mainpage_music_default.png";
	
	function create(cardDefaultData, initNetState) {
		console.log("create card begin: " + cardDefaultData.id);
		defaultData = cardDefaultData;
		
		cardDiv = document.createElement("div");
		cardDiv.id = defaultData.id;
		cardDiv.updateState = updateState;
		
		//读取缓存,判断是否需要显示
		var cacheString = cacheMgr.getCache(defaultData.id);
		console.log("create, cacheString is " + cacheString);
    	if(cacheString) {
    		try {
    			cacheData = JSON.parse(cacheString);
    			console.log("create, defaultData version is " + defaultData.version);
    			if(cacheData.version != defaultData.version) {
    				console.log("create, version error");
    				defaultData.show = cacheData.show;
    				cacheData = defaultData;
    				//将默认数据存入缓存
    				cacheMgr.setCache(cacheData.id, JSON.stringify(defaultData));
    			}
    		} catch(e) {
    			console.log("create, JSON error");
    			cacheData = defaultData;
    			//将默认数据存入缓存
    			cacheMgr.setCache(cacheData.id, JSON.stringify(cacheData));
    		}
    	} else {
    		cacheData = defaultData;
    		//将默认数据存入缓存
    		cacheMgr.setCache(cacheData.id, JSON.stringify(cacheData));
    	}
    	
    	/** 注册更新请求回调，框架调用*/
    	cardDiv.updateData = function(){
    		console.log("updateData");
            if (cacheData.show) {
                requestMusicCard();
            } else {
                if (!isRequest) {
                    listener.callBack(defaultData.id, CARD_CONTENT_NO_REQUEST);
                }
            }
        };
    	
    	if(cacheData && cacheData.show) {
    		if (initNetState) {
                requestCondition = 1;
            }
            else {
                requestCondition = 0;
            }
    		//加载资源CSS等
    		loadResource(onLoadResourceFinish);
    	} else {
    		//通知框架结果
    		noticeFrame(CARD_CONTENT_NO_REQUEST);
    		requestCondition = 2;
    	}
    	
    	if(cacheData) {
    		cardDiv.initShowState = cacheData.show;
    	}
		return cardDiv;
	}
	
	/** 资源文件加载完成回调，开始创建卡片内容*/
	function onLoadResourceFinish() {
		var contentDiv = document.createElement("div");
		contentDiv.className = "css_card";
		
		addContent(contentDiv, cacheData);
		
		if(cardDiv) {
			console.log("add music card");
			cardDiv.appendChild(contentDiv);
			cardDiv.content = contentDiv;
			cardDiv.showContentPage = showContentPage;
		}
		
		if(cacheData.show) {
			if(0 === requestCondition) {
				//没有网络，不需要请求，但是需要回调
                listener.callBack(defaultData.id, CARD_CONTENT_REQUEST_FAILE);
			} else {
				requestMusicCard();
			}
		}
	}
	
	/** 生成卡片内容*/
	function addContent(contentDiv, cardData) {
		console.log("music card, addContent");
		
		var musicTitle = createCardMainTitle(cardData.id, defaultData.name, defaultData.caseList[0], titleResponseListener);
		contentDiv.appendChild(musicTitle);
		if(cardData.content) {
			contentDiv.appendChild(createBody(cardData.content));
			contentDiv.appendChild(createFooter(cardData.content));
		}
		
		var card_bottom_shadow = document.createElement("div");
	    card_bottom_shadow.className = "css_card_bottom_shadow";
	    contentDiv.appendChild(card_bottom_shadow);
	}
	
	/** 更新卡片内容*/
	function updateContent(cardData) {
		console.log("music card, updateContent");
		if(cardDiv && cardDiv.content) {
			var contentDiv = cardDiv.content;
			contentDiv.innerHTML = "";
			addContent(contentDiv, cardData);
		}
	}
	
	/** 加载CSS*/
	function loadResource(onLoadResourceFinish) {
		xcssParser.parseStyleFile("./music/business.x.css", onLoadResourceFinish);
	}
	
	/** 创建卡片中间区域*/
	function createBody(content) {
		console.log("createBody");
		var bodyDiv = document.createElement("div");
		
		//banner入口
		if(content.items && content.items.length > 0) {
			var bigImgContainer = document.createElement("div");
			bigImgContainer.className = "css_card_music_big_image_container";
			bigImgContainer.addEventListener("touchstart", function() {
						moveOverCheck.start(event);
					},false);
			bigImgContainer.addEventListener("touchmove", function() {
						moveOverCheck.check(event);
					},false);
			bigImgContainer.addEventListener("touchend", function() {
						if (!moveOverCheck.isMoveOver()) {
							exec('UIComponents', "openBrowser", ["", this.link]);
							
							exec("WidgetMMPContainerComponents", "appenCardCpaLog", ["music"]);
							exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.music, opCodeKey.banner]);
						}
					},false);

			var bigImg = document.createElement("img");
			bigImg.className = "css_card_music_big_image";
			bigImg.onerror = function() {
				bigImg.src = ic_mainpage_music_default;
			};
			bigImg.src = content.items[0].picture;
			bigImgContainer.link = content.items[0].url;
			bigImgContainer.appendChild(bigImg);

			bodyDiv.appendChild(bigImgContainer);
		}
		
		if(content.category) {
			bodyDiv.appendChild(createSongOrderEntry(content.category));
		}
		
		return bodyDiv;
	}
	
	/** 创建底部按钮*/
	function createFooter(content) {
		console.log("createFooter");
		
		var bottomButton = content.bottomButton;
		
		var footer = document.createElement("div");
		footer.className = "css_card_bottom_btn css_card_music_footer";
		
		var leftBtn = document.createElement("div");
		leftBtn.className = "css_card_music_bottom_left";
		if(bottomButton && bottomButton[0]) {
			leftBtn.link = bottomButton[0].url;
			leftBtn.innerText = bottomButton[0].name;
		}
		leftBtn.index = 1;
		footer.appendChild(leftBtn);
		
		var rightBtn = document.createElement("div");
		rightBtn.className = "css_card_music_bottom_right";
		if(bottomButton && bottomButton[1]) {
			rightBtn.innerText = bottomButton[1].name;
			rightBtn.link = bottomButton[1].url;
		}
		rightBtn.index = 2;
		footer.appendChild(rightBtn);
		
		var targetItem;
		footer.addEventListener("touchstart", function(){
			event.stopPropagation();
			moveOverCheck.start(event);
			targetItem = getParentOfClass("css_card_music_bottom_left", event.target);
			if(targetItem) {
				targetItem.style.backgroundColor = "#efefef";
			} else {
				targetItem = getParentOfClass("css_card_music_bottom_right", event.target);
				if(targetItem) {
					targetItem.style.backgroundColor = "#efefef";
				}
			}
		},false);
		footer.addEventListener("touchmove", function(){
			event.stopPropagation();
			if (moveOverCheck.check(event)) {
				if(targetItem) {
					targetItem.style.backgroundColor = "";
				}
            }
		},false);
		footer.addEventListener("touchend", function(){
			event.stopPropagation();
			if(targetItem) {
				targetItem.style.backgroundColor = "";
			}
            if (!moveOverCheck.isMoveOver()) {
            	if(targetItem) {
            		if(targetItem.index == 1) {
            			//点击左边按钮
            			exec('UIComponents',"openBrowser",["", targetItem.link]);
            			
            			exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.music, opCodeKey.hotRing]);
            		} else if(targetItem.index == 2) {
            			//点击右边按钮
            			exec('UIComponents',"openBrowser",["", targetItem.link]);
            			
            			exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.music, opCodeKey.moreBtn]);
            		}
            	}
            	
            	exec("WidgetMMPContainerComponents", "appenCardCpaLog", ["music"]);
            }
		},false);
		
		return footer;
	}
	
	/** 创建点歌入口*/
	function createSongOrderEntry(category) {
		var songOrderEntry = document.createElement("div");
		songOrderEntry.className = "css_card_music_song_order_entry";
		
		var count = 0;
		console.log("category length is " + category.length);
		var length = category.length>3 ? 3:category.length;
		for (var i = 0; i < length; i++) {
			count++;
			var songOrderItem = document.createElement("div");
			songOrderItem.className = "css_card_music_song_order_item";
			songOrderItem.innerText = category[i].title;
			songOrderItem.link = category[i].url;
			songOrderItem.position = i;
			songOrderEntry.appendChild(songOrderItem);
			
			songOrderItem.addEventListener("touchstart", function() {
						this.style.backgroundColor = "#e0e0e0";
						moveOverCheck.start(event);
					},false);
			songOrderItem.addEventListener("touchmove", function() {
						if (moveOverCheck.check(event)) {
							this.style.backgroundColor = "#f0f0f0";
						}
					},false);
			songOrderItem.addEventListener("touchend", function() {
						this.style.backgroundColor = "#f0f0f0";
						if (!moveOverCheck.isMoveOver()) {
							exec('UIComponents',"openBrowser",["", this.link]);
							
							exec("WidgetMMPContainerComponents", "appenCardCpaLog", ["music"]);
							exec("WidgetMMPContainerComponents", "appenCardOpLog", [cardOpCode.music, opCodeKey.category + (this.position + 1)]);
						}
					},false);
					
			if(count == 3) {
				// 最多显示6个选项
				break;
			}
		}
		
		return songOrderEntry;
	}
	
	/** 请求成功处理*/
	function onSuccess(jsonStr) {
		console.log("requestMusicCard, onSuccess");
		isRequest = false;
		try {
			var jsonObj = JSON.parse(jsonStr);
			if (jsonObj) {
				console.log("requestMusicCard, errorCode is "
						+ jsonObj.errorCode);
				if ("success" == jsonObj.status) {
					var cardData = saveCache(jsonObj.content);
					isCacheNew = true;
					updateContent(cardData);
					// 通知框架结果
					noticeFrame(CARD_CONTENT_REQUEST_SUCCESS);
				} else {
					console.log("requestMusicCard, errorCode is not 000000");
					// 通知框架结果
					noticeFrame(CARD_CONTENT_REQUEST_FAILE);
				}
			}
		} catch (e) {
			console.log("requestMusicCard, JSON error");
			// 通知框架结果
			noticeFrame(CARD_CONTENT_REQUEST_FAILE);
		}

	}
	
	/** 请求失败处理*/
	function onFail() {
		console.log("requestMusicCard, onFail");
		isRequest = false;

		// 通知框架结果
		noticeFrame(CARD_CONTENT_REQUEST_FAILE);
	}
	
    /** 请求音乐卡片数据 */
    function requestMusicCard(){
    	console.log("requestMusicCard");
    	//请求数据
    	var params = new Object();
		params.cardID = defaultData.id;
		params.versionCode = defaultData.version;
    	params.onSuccess = onSuccess;
    	params.onFail = onFail;
    	
    	require(["./music/musicRequestHelper.js"], function(musicRequestHelper) {
    		isRequest = true;
    		musicRequestHelper.requestMusicCard(params);
    	});
    }
    
    /** 保存缓存数据，发回保存的JSON对象*/
    function saveCache(content) {
    	cacheData.content = content;
    	console.log("saveCache, JSON string is " + JSON.stringify(cacheData));
    	cacheMgr.setCache(cacheData.id, JSON.stringify(cacheData));
    	
    	return cacheData;
    }
    
    /** 同步载入JS*/
    function loadJS(url, success) {
		var domScript = document.createElement('script');
		domScript.src = url;
		success = success || function() {
		};
		domScript.onload = domScript.onreadystatechange = function() {
			if (!this.readyState || 'loaded' === this.readyState
					|| 'complete' === this.readyState) {
				success();
				this.onload = this.onreadystatechange = null;
				this.parentNode.removeChild(this);
			}
		};
		document.getElementsByTagName('head')[0].appendChild(domScript);
	}
	
	/** 开关卡片*/
	function updateState(show) {
		console.log("updateState, show is " + show);
		//更新缓存
		cacheData.show = show;
    	cacheMgr.setCache(cacheData.id, JSON.stringify(cacheData));
    	
		if(show) {
			cardDiv.style.display = "block";
			if(cardDiv.children.length == 0) {  //如果内容为空需要去加载资源
				console.log("updateState, content is empty");
				loadResource(onLoadResourceFinish);
			} else {
				if (!isCacheNew && !isRequest) {
					console.log("updateState, requestMusicCard");
					requestMusicCard();
				}
				showContentPage();
			}
		} else {
			cardDiv.style.display = "none";
		}
	}
	
	/** 通知框架层卡片加载情况*/
	function noticeFrame(value) {
		if (listener) {
			listener.callBack(cacheData.id, value);
		}
	}
	
	/** 显示内容区域*/
	function showContentPage() {
		if(zdOffDom) {
            zdOffDom.style.display = "none";
        }
        if(speechCaseDom) {
            speechCaseDom.style.display = "none";
        }
        if(cardDiv.content) {
        	cardDiv.content.style.display = "block";
        }
	}
	
	/** 标题栏点击事件回调*/
	function titleResponseListener(responseId){
		switch(responseId) {
            case 0://点击说法示例区域
                if(zdOffDom) {
                    zdOffDom.style.display = "none";
                }
                
                cardDiv.content.style.display = "none";
                if (speechCaseDom) {
                    speechCaseDom.style.display = "block";
                } else {
                    speechCaseDom = createSpeechCaseView(cacheData.id, defaultData.name, defaultData.caseList);
                    //判断一下是否为空
                    if(null != speechCaseDom) {
                    	speechCaseDom.setCancelListener(speechCaseCallBack);
                    	cardDiv.appendChild(speechCaseDom);
                    }
                }
                break;
            case 1://点击置顶箭头按钮
                if(speechCaseDom) {
                    speechCaseDom.style.display = "none";
                }
                cardDiv.content.style.display = "none";
                
                if (zdOffDom) {
                    zdOffDom.style.display = "block";
                } else {
                    zdOffDom = createOperationView(cacheData.id, defaultData.name);
                    //判断一下是否为空
                    if(null != zdOffDom) {
                    	zdOffDom.setOpListener(operateCallBack);
                    	cardDiv.appendChild(zdOffDom);
                    }
                }
                break;
            case 2://刷新，暂时没有实现
                break;
            default:
                break;
        }
	}
	
	/** 说法示例点击回调*/
	function speechCaseCallBack(){
        showContentPage();
    }
    
    /** 置顶关闭按钮点击回调*/
    function operateCallBack(callBackId) {
        switch(callBackId) {
            case 0://取消
                showContentPage();
                break;
            case 1://置顶
                showContentPage();
                stickTopCardByDom(cardDiv);
                break;
            case 2://点击关闭
                //显示关闭确认弹框，暂时未实现
                showCloseConfirmDialogById(cacheData.id);
                break;
            
            default:
                break;
        }
    }
    
	return create;
});