/**
 * 音乐业务请求
 *
 * @author xfchen2 2014-6-20
 */
define(function() {
    const MUSIC_CARD_CODE = "1007";
    const MUSIC_CARD_CMD = "1007";
    
    var bseInfo = getBseInfo();
    
    /** 请求音乐卡片数据*/
    function requestMusicCard(params) {
    	console.log('requestMusicCard');
    	var jsonStr = createtMusicCardJSONStr(params.cardID, params.versionCode);
    	var timeStr = new Date().valueOf();
    	var url;
    	if(bseInfo && bseInfo.businessRequestUrl) {
    		url = bseInfo.businessRequestUrl + "?c=" + MUSIC_CARD_CODE + "&v=1.0&gz=0&t=" + timeStr;
    	} else {
    		params.onFail();
    		return;
    	}
    	var options = new Object();
    	options.url = url;
    	options.data = jsonStr;
    	options.onSuccess = params.onSuccess;
    	options.onFail = params.onFail;
    	sendJsonAjaxRequest(options);
    }
    
    /** 生成音乐卡片请求参数*/
    function createtMusicCardJSONStr(cardID, versionCode) {
    	console.log('createtMusicCardJSONStr');
    	
    	var json = {};

        //cmd
        json.cmd = MUSIC_CARD_CMD;

        //base
        json.base = organizeJsonBaseData(bseInfo);
        
        //param
        var param = {};
        param.id = cardID;
        param.version = versionCode.toString();
        param.extendParam = {};
        json.param = param;
        
        var jsonStr = JSON.stringify(json);

        console.log('createtMusicCardJSONStr end, jsonStr is ' + jsonStr);
        return jsonStr;
    }
    
    //export
    var musicRequestHelper = {};
    musicRequestHelper.requestMusicCard = requestMusicCard;
    return musicRequestHelper;
    
});