//判断是否为移动终端
var isTouch = ('ontouchstart' in window);

// 屏幕滑动距离检测器
var moveOverCheck = new checkMoveOver();

/********************初始化工作开始***************************/
// 获取设备信息
var resultDevice = ifly_getDeviceInfo();
if (!resultDevice) {
    resultDevice = {};
    if (isTouch) {
        //移动端设置为窗口宽度
        resultDevice.screenWidth = window.innerWidth;
    } else {
        //pc端设置为固定宽度
        resultDevice.screenWidth = 720;
    }
    resultDevice.model = 'unknown';
    resultDevice.release = '2.2';
}

//设备分辨率
var deviceWidth = resultDevice.screenWidth;
//华为G660，G730手机特殊适配wm
if (resultDevice.model == "HUAWEI G660-L075" || resultDevice.model == "HUAWEI G730-L075") {
    deviceWidth = 360;
}


//是否开启动画
var enableAnimation = false;
//皮肤包路径
var skinPath = "../skin/theme_new/";
//版本标识，用来区分灵犀还是语点。默认值为true，表示灵犀
var cmcc_flag = true;

//获取环境信息(皮肤、版本标识、cpu)
var environmentInfo = ifly_getEnvironmentInfo();
if (environmentInfo) {
    skinPath = environmentInfo.skinPath;
    cmcc_flag = environmentInfo.isCmcc;

    //双核及以上手机开启动画
    if (environmentInfo.cpuCount >= 2) {
        enableAnimation = true;
    }

    //该款手机开启动画容易崩溃，暂时关闭。by mdhuang 2014年1月22日14:07:20
    if (resultDevice.model.indexOf("HUAWEI D2") > -1) {
        enableAnimation = false;
    }
} else {
    enableAnimation = true;
}


// 适配比例，xcss文件解析时需要
var scale = deviceWidth / 320;

var marginBottom = 6 * scale; //来自css_dilaog_out_div中的margin_bottom

//平移动画的滚动距离
var translateAnimDistance = 100 * scale;

var flagBusCSSLoaded = false;

// 是否需要延迟加载
var isNeedResetScale = false;
console.log("resultDevice.release = " + resultDevice.release);
if (resultDevice.release && resultDevice.release.indexOf("4.0") == 0) {
    isNeedResetScale = true;
}
// 加载资源
function loadResource() {
    console.log("loadResource() is called");
    function createXcssElement(id) {
        var css = document.createElement('link');
        css.id = id;
        css.rel = 'stylesheet/xcss';
        css.type = 'text/css';
        return css;
    }

    function createScriptElement(id) {
        var script = document.createElement('script');
        script.id = id;
        script.type = "text/javascript";
        return script;
    }

    var head = document.getElementsByTagName('head').item(0);

    // 加载js文件
    var resouceJs = createScriptElement('resouceJs');
    var resourceFolderName = null;

    resouceJs.src = "./schedule/resources.js";

    console.log("com_iflytek_local_resourceFolder  = " + com_iflytek_local_resourceFolder);

    console.log("resourcePath = " + "./" + "schedule" + "/resources.js");
    head.appendChild(resouceJs);

    // 捕获xcss解析完成的事件
    document.documentElement.addEventListener("xcssParseFinish", function () {
        if (document.getElementById('businessXcss')) {
            // 删除已经不需要的节点
            head.removeChild(document.getElementById('businessXcss'));
            head.removeChild(document.getElementById('xcssParser'));
            // 通知java层，business.xcss解析完毕
            //添加用户引导
            createChannel();

            exec('WidgetMMPContainerComponents', 'businessXcssParseFinish', []);

        } else {
            console.warn('unknown parseFinish event');
        }
    }, false);

    //加载解析xcss样式文件
    var businessXcss = createXcssElement('businessXcss');
    businessXcss.href = "./" + "schedule" + "/business.x.css";
    head.appendChild(businessXcss);

    var xcssParser = createScriptElement('xcssParser');
    xcssParser.src = skinPath + "dialogModeRes/xcssParser.js";
    head.appendChild(xcssParser);
}


if (!isNeedResetScale) {
    loadResource();
}


/**
 * 在调用业务处理逻辑前，再获取一次屏幕宽度，重新计算一次scale
 */
function resetScale() {
    if (!isNeedResetScale) {
        console.log("there's no need reset Scale");
        return;
    }
    console.log("before reset scale is " + scale);
    setTimeout(function () {     // 延迟200毫秒获取页面宽度
        deviceWidth = document.body.clientWidth;
        scale = deviceWidth / 320;
        console.log("after reset scale is " + scale);
        marginBottom = 6 * scale;
        translateAnimDistance = 100 * scale;
        // 调用业务处理逻辑
        loadResource();
    }, 150);
}


/********************初始化工作结束***************************/


/**
 * Java函数对语音识别结果进行处理后，调用此函数进行页面展示
 *
 * @param viewName
 *            需要处理的view的类型，如对话、提醒、股票等
 * @param result
 *            java进行处理后的数据结果，json格式字符串
 */
function addE(viewName, result) {
    console.log('addE begin, viewName is ' + viewName + ' ,result is ' + result);
    if (viewName in functionMap) {
        require(functionMap[viewName].url, function (func) {
            if (func && typeof func == 'function') {
                //解析业务数据
                var resultJson = eval('(' + result + ')');

                //创建节点，并添加到页面中
                var view = func(resultJson);

                //设置动画
                setAnim(viewName, view, resultJson);

                //重设节点margin值，以保证该节点至少“占据”一屏的空间
                resetElementMargin(view);

                //滚动节点位置
                scrollElement(view, resultJson);

                //开始动画
                startAnim(viewName, view, resultJson);
                forceRefreshScreen();

            } else {
                console.error('addE faile, create func is null');
            }
        });
    }
}

/**
 * 重设元素的margin值
 * @param view
 */
function resetElementMargin(view, isErrorView) {
    if (!view.previousElementSibling) {
        console.log('first element, need not control position');
        return;
    }

    //errorView特殊处理
    if (isErrorView) {
        view.style.marginBottom = window.innerHeight + 'px';
    }
    //先设置当前节点的margin值
    else if (view.clientHeight + 2 * marginBottom < window.innerHeight) {
        view.style.marginBottom = (window.innerHeight - view.clientHeight - marginBottom) + 'px';
    }

    //然后再恢复前一个节点的margin值，这样能够把当前节点给“拉起来”
    if (view.previousElementSibling) {
        view.previousElementSibling.style.marginBottom = marginBottom + 'px';
    }
}

/**
 * 滚动节点位置
 */
function scrollElement(view, resultJson) {
    // 本节点为第一置顶元素
    if (view.topFirst) {
        // 直接将本节点置顶
        scrollToView(view);
    }
    // 本节点为第二置顶元素
    else if (view.topSecond) {
        if (view.previousElementSibling && view.previousElementSibling.topFirst) {
            // 前节点为第一置顶元素，保险起见将前节点再次置顶，规避某些手机上出现不置顶的情况
            scrollToView(view.previousElementSibling);
        } else {
            // 前面没有第一置顶元素，则将本节点置顶
            scrollToView(view);
        }
    }
}

/********************动画处理函数***************************/
function setAnim(viewName, element, resultJson) {
    if (resultJson.isHistoryResult || element.noAnim) {
        console.log('no setAnim, return');
        return;
    }
    if (viewName === 'WidgetCustomerQuestionView' || viewName === 'WidgetViaFlyAnswerView') {
        addOpacityAnim(element);
    } else {
        addTranslateAnim(element);
    }
}

function startAnim(viewName, element, resultJson) {
    if (resultJson.isHistoryResult || element.noAnim) {
        console.log('no startAnim, return');
        return;
    }
    if (viewName === 'WidgetCustomerQuestionView' || viewName === 'WidgetViaFlyAnswerView') {
        startOpacityAnim(viewName, element);
    } else {
        startTranslateAnim(element);
    }
}

//渐变动画
function addOpacityAnim(element) {
    if (enableAnimation) {
        element.style.opacity = "0.0";
        addClass(element, 'css_dialog_opacity_anim');
    }
}

function startOpacityAnim(viewName, element) {
    if (enableAnimation) {
        //动画结束后的清理工作
        var animEndListener = function () {
            removeClass(element, 'css_dialog_opacity_anim');
            element.removeEventListener("webkitTransitionEnd", animEndListener);
        };
        element.addEventListener("webkitTransitionEnd", animEndListener);

        if (viewName === 'WidgetCustomerQuestionView') {
            //转写气泡动画延时一段时间再显示，以便先完成位置置顶的动作
            setTimeout(function () {
                element.style.opacity = "1.0";
            }, 100);
        } else {
            element.style.opacity = "1.0";
        }
    }
}

//平移动画
function addTranslateAnim(element) {
    if (enableAnimation) {
        element.style.opacity = "0.0";
        element.style.webkitTransform = "translate(0," + translateAnimDistance + "px)";
        addClass(element, 'css_dialog_translate_anim');
    }
}

function startTranslateAnim(element) {
    if (enableAnimation) {
        //动画结束后的清理工作
        var animEndListener = function () {
            removeClass(element, 'css_dialog_translate_anim');
            element.removeEventListener("webkitTransitionEnd", animEndListener);

            //强制界面重排，解决某些情况下translate完成后界面多出一大块空白的问题
            if (element.style.marginBottom) {
                element.style.marginBottom = (parseFloat(element.style.marginBottom) + 1) + 'px';
            } else {
                element.style.marginBottom = (marginBottom + 1) + 'px';
            }
        };
        element.addEventListener("webkitTransitionEnd", animEndListener);

        element.style.opacity = "1.0";
        element.style.webkitTransform = "translate(0,0px)";
    }
}

/* 创建position为relative的外层div */
function createOutDiv(id) {
    var relativeDiv = document.createElement("div");
    relativeDiv.className = "css_dilaog_out_div";
    if (id != undefined && id != null) {
        relativeDiv.id = id;
    }
    return relativeDiv;
}

/* 创建外层容器div */
function createBoxDiv(id, outDiv) {
//    var inner_box = document.createElement("div");
//    inner_box.className = "box_inner";
//    inner_box.appendChild(outDiv);

    var out_box = document.createElement("div");
    out_box.className = "box_out";
    out_box.appendChild(outDiv);

    if (id) {
        out_box.id = id;
    }
    return out_box;
}

//添加转写气泡
function addQuestionView(text) {
    var viewData = {};
    viewData.questionText = text;
    viewData.taskHandler = 'demo_questionView';
    viewData.intentType = 'demo';
    viewData.editEnable = false;
    addE('QuestionView', JSON.stringify(viewData));
}
function delayedAddAnswerView(text, focus, delayTime) {
    var viewData = {};
    viewData.answerText = text;
    viewData.taskHandler = 'demo_answerView';
    viewData.type = 'NORMAL';
    viewData.showShare = false;
    viewData.topic = 'demo';
    viewData.focus = focus;
    viewData.speechText = text;
    viewData.needTaskButton = false;

    setTimeout(function () {
        addE('AnswerView', JSON.stringify(viewData));
    }, delayTime);
}

//添加转写气泡
function addAnswerView(text) {
    var viewData = {};
    if (text) {
        viewData.answerText = text;
    } else {
        viewData.answerText = "";
    }
    viewData.taskHandler = 'demo_answerView';
    viewData.intentType = 'demo';
    viewData.editEnable = false;
    addE('AnswerView', JSON.stringify(viewData));
}

function addWebE(viewName, jsonResult) {
    console.log('addWebE begin');
    if (viewName in functionMap) {
        require(functionMap[viewName].url, function (func) {
            if (func && typeof func == 'function') {
                //创建节点，并添加到页面中
                var view = func(jsonResult);
                forceRefreshScreen();
            } else {
                console.error('addE fail, create func is null');
            }
        });
    }
}


/**
 * 删除当前可被删除的元素
 */
function removeCurrentCanDeleteView() {
    console.log("removeCurrentCanDeleteView :" + currentCanDeleteView);
    if (currentCanDeleteView && currentCanDeleteView.parentNode) {
        if (currentCanDeleteView.deleteView && typeof currentCanDeleteView.deleteView === "function") {
            currentCanDeleteView.deleteView();
        }
        removeChild(currentCanDeleteView.parentNode, currentCanDeleteView);
        currentCanDeleteView = null;
    }
    //forceRefreshScreen();
}


/**
 * 删除子节点，使用此方法便于进行一些公共的逻辑处理。
 *
 * @param parent
 * @param child
 */
function removeChild(parent, child) {
    console.log('removeChild begin');

    // 删除之前，判断是否对页面最后节点的操作
    var isLastElement = false;
    if (parent == document.body.lastElementChild || child == document.body.lastElementChild) {
        isLastElement = true;
    }

    parent.removeChild(child);

    // 最后的节点发生了变化，需要重新调整位置
    var view = document.body.lastElementChild;
    if (isLastElement && view) {
        if (child == document.body.dashbordErrorView) {
            resetElementMargin(view, true);
        } else {
            resetElementMargin(view);
        }
    }

}

//原有提醒二级频道的变量
var foldKey;
var defaultMsgFlag;
var guideFoldState;
var isWeatherClickedKey;
var isWeatherClicked;
var doneScheduleLength = 0;
var betoScheduleLength = 0;
var isShrinked = true;
var schedulePanel;
var hotScheduleListContainer;
var scheduleHistory;


function createChannel() {
    console.log("createGuide() is called");

    //main-translate.js文件可能会比resources.js文件先加载完毕，所以判断一下
    if (!window.resourcesJsloadFinish) {
        setTimeout(function () {
            createChannel();
            return;
        }, 50);
        return;
    }


    /**
     * 原有提醒二级频道
     */
//    define(function() {
    foldKey = "sub_schedule_fold";
    defaultMsgFlag = "default_schedule_msgFlag";
    guideFoldState = false;
    isWeatherClickedKey = "is_weather_clicked";
    isWeatherClicked = false;


    doneScheduleLength = 0;
    betoScheduleLength = 0;
    isShrinked = true;

    schedulePanel = document.getElementById("scheduleChannelPanel");

    if (base_getItem(isWeatherClickedKey)) {
        isWeatherClicked = true;
    }

    //跟新红点的状态
    var result = exec("ScheduleBusinessHandler", 'getRingGuideState', []);
    var resultObjct = getResultMessage(result);
    if (resultObjct && !resultObjct.isClosed) {
        var ring_guide_div = document.createElement("div");
        ring_guide_div.className = "css_ring_guide_div";
        var ring_guide_img = document.createElement("img");
        ring_guide_img.className = "css_ring_guide_img";
        ring_guide_img.src=schedule_ringtone_guide;
        var ring_guide_close_button = document.createElement("img");
        ring_guide_close_button.className = "css_ring_guide_close_button";
        ring_guide_close_button.src = ic_person_ring_guide_operations_close;
        ring_guide_div.appendChild(ring_guide_img);
        ring_guide_div.appendChild(ring_guide_close_button);
        if(scale) {
            ring_guide_div.style.height= 93*scale + "px";
        }

        //清除运营位的点击事件
        var ringGuideDivMove = false;
        ring_guide_div.addEventListener("touchstart", function() {
            event.stopPropagation();
            moveOverCheck.start(event);
        }, false);
        ring_guide_div.addEventListener("touchmove", function() {
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                ringGuideDivMove = true;
            }
        }, false);
        ring_guide_div.addEventListener("touchend", function() {
            event.stopPropagation();
            if (false == ringGuideDivMove) {
               // ring_guide_div.style.display="none";

                if (event.target == ring_guide_img) {
                    exec("ScheduleBusinessHandler", 'clickRingGuide', []);
                } else if (event.target == ring_guide_close_button) {
                    ring_guide_div.style.height="0px";
                    exec("ScheduleBusinessHandler", 'closeRingGuide', []);
                }
            }
            ringGuideDivMove = false;
        }, false);
        schedulePanel.appendChild(ring_guide_div);
    }

    hotScheduleListContainer = createHotRemindSub();
    schedulePanel.appendChild(hotScheduleListContainer);

    scheduleHistory = createRemindsSub();
    schedulePanel.appendChild(scheduleHistory);

    schedulePanel.show = function () {
//            schedulePanel.style.display = "block";
//
//            var hotScheduleResult = exec("ScheduleBusinessHandler", 'getHotScheduleList', []);
        var result = exec("ScheduleBusinessHandler", 'getScheduleList', []);
//             result = '{code:"OK",message:{"toDoJsonData":{"todo_remind_list_length":1,"toDoRemindItems":[{"content":"","mFocus":"","mId":2,"remindtime":"16:45","date":"今天","openRemind":true,"week":"周三"}]},"doneJsonData":{"done_remind_list_length":1,"doneRemindItems":[{"content":"","mFocus":"","mId":1,"remindtime":"16:20","date":"今天","openRemind":false,"week":"周三"}]},"dataType":"scheduleList"}}';

        console.log(result);
        console.log(JSON.toString(result));
        var value = getResultMessage(result);
        console.log(value);
        console.log(JSON.toString(value));
        schedulePanel.updateUI(value);
    };

    schedulePanel.updateUI = function (allJsonData) {
        if (!allJsonData) {
            return;
        }
        var dataType = allJsonData.dataType;
        if ("scheduleList" == dataType) {
            scheduleHistory.refresh(allJsonData);
        }
//            else if ("hotSchedule" == dataType) {
//                hotScheduleListContainer.refresh(allJsonData);
//            }
    };

    schedulePanel.dismiss = function () {
        schedulePanel.style.display = "none";
    };


    /**
     * 生成热门提醒区域
     * @returns {热门提醒区域}
     */
    function createHotRemindSub() {
        /**
         * 提醒列表的title区域
         */
        var hot_schedule_title_div = document.createElement("div");
        hot_schedule_title_div.className = "css_hot_schedule_title_div";

        //热门提醒的右边的图片
        var hot_schedule_left_icon = document.createElement("img");
        hot_schedule_left_icon.className = "css_hot_schedule_left_icon";
        hot_schedule_left_icon.src = ic_reminder_hot;
        hot_schedule_title_div.appendChild(hot_schedule_left_icon);

        /**
         *提醒列表的title中的文字的父容器
         */
        var hot_schedule_title_text_div = document.createElement("div");
        hot_schedule_title_text_div.className = "css_hot_schedule_title_text";
        hot_schedule_title_text_div.innerText = "热门提醒";

        hot_schedule_title_div.appendChild(hot_schedule_title_text_div);


        //热门提醒的右边的图片
        var hot_schedule_right_icon = document.createElement("img");
        hot_schedule_right_icon.className = "css_hot_schedule_right_icon";
        hot_schedule_right_icon.src = ic_list_arrow_left;
        hot_schedule_title_div.appendChild(hot_schedule_right_icon);

        //创建红点区域
        var redDot = document.createElement("img");
        redDot.id = "hot_schedule_red_hot_id";
        redDot.className = "hot_schedule_red_dot";
        redDot.src = "../skin/theme_new/dialogModeRes/image/default/ic_new_version.png";

        //跟新红点的状态
        var result = exec("ScheduleBusinessHandler", 'getHotScheduleRedhotState', []);
        var resultObjct = getResultMessage(result);
        if (resultObjct && resultObjct.RedHotState) {
            redDot.style.display = "block";
        } else {
            redDot.style.display = "none";
        }

        hot_schedule_title_div.appendChild(redDot);

        //添加外壳
        var hot_schedule_title_outbox_div = createBoxDiv("", hot_schedule_title_div);

        //添加监听事件
        var moreHotRemindMove = false;
        hot_schedule_title_div.addEventListener("touchstart", function () {
            console.log("more_hot_remind_div touchstart");
            event.stopPropagation();
            moveOverCheck.start(event);
            hot_schedule_title_div.style.backgroundColor = "#e5e5e5";
        }, false);

        hot_schedule_title_div.addEventListener("touchmove", function () {
            console.log("more_hot_remind_div touchmove");
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                moreHotRemindMove = true;
            }
            hot_schedule_title_div.style.backgroundColor = "";
        }, false);

        hot_schedule_title_div.addEventListener("touchend", function () {
            console.log("more_hot_remind_div touchend");
            event.stopPropagation();
            hot_schedule_title_div.style.backgroundColor = "";
            if (moreHotRemindMove == false) {
                //调用java代码
                exec("ScheduleBusinessHandler", 'clickMoreHotScheduleList', []);
                exec("ScheduleBusinessHandler", 'clickScheduleRedhot', []);
                redDot.style.display = "none";
            }
            moreHotRemindMove = false;
        }, false);


        return hot_schedule_title_outbox_div;
    }


    /**
     * 创建提醒列表区域
     * @returns {整个提醒列表包括新建提醒部分}
     */
    function createRemindsSub() {
        var doneTargetItem = null;
        var touchType = -1;
        var doneItems = [];

        var betoTargetItem = null;
        var touchType = -1;
        var betoItems = [];

        var MIN_LONG_CLICK_TIME_INTERNAL = 2 * 1000;

        //提醒列表的主体
        var remind_list_inner_div = document.createElement("div");
        remind_list_inner_div.id = "id_remind_list_inner_div";
        remind_list_inner_div.className = "css_remind_list_inner_div"


        //创建提醒列表的标题部分
        var remind_list_title_div = createRemindListTitleDiv();
        //创建提醒实例的展示部分
        var remind_example_div = document.createElement("div");
        remind_list_inner_div.appendChild(remind_list_title_div);
        remind_list_inner_div.appendChild(remind_example_div);

        //创建提醒列表的更多按钮
        var more_remind_div = createMoreRemindDiv();
        remind_list_inner_div.appendChild(more_remind_div);
        more_remind_div.style.display = "none";

        //为提醒列表添加监听事件
        var touchBetoScheduleMove = false;

        var longClickTimer;
        remind_example_div.addEventListener("touchstart", function () {
            event.stopPropagation();
            betoTargetItem = getParentOfClass("css_remind_item_div", event.target);
            console.log(betoTargetItem + " touchstart");
            if (betoTargetItem) {
                betoTargetItem.style.backgroundColor = "#e5e5e5";
                touchBetoScheduleMove = false;//解决android4.0.x系统，在滑动屏幕时，touchend不触发的兼容性问题
                var offsetX = event.targetTouches[0].pageX;
                var offsetY = betoTargetItem.getBoundingClientRect().top;
                var itemNo = betoTargetItem.item_no;
                var itemHeight = betoTargetItem.offsetHeight;

                //长按事件的处理
                function onLongClickCallback() {
                    exec("ScheduleBusinessHandler", 'longClickSchedule', [itemNo, offsetY, offsetX, itemHeight]);
                    longClickTimer = null;
                }

                longClickTimer = setTimeout(onLongClickCallback, 500);

            }
            moveOverCheck.start(event);
        }, false);

        remind_example_div.addEventListener("touchmove", function () {
            event.stopPropagation();
            console.log(betoTargetItem + " touchmove");
            if (betoTargetItem) {
                if (null != longClickTimer) {
                    betoTargetItem.style.background = "";
                }
                if (moveOverCheck.check(event)) {
                    clearTimeout(longClickTimer);
                    longClickTimer = null;
                    touchBetoScheduleMove = true;
                }
            }
        }, false);

        remind_example_div.addEventListener("touchend", function () {
            event.stopPropagation();
            console.log(betoTargetItem + " touchend");
            if (longClickTimer) {
                clearTimeout(longClickTimer);
                longClickTimer = null;
                if (betoTargetItem) {
                    if (touchBetoScheduleMove == false) {
                        exec("ScheduleBusinessHandler", 'clickSchedule', [betoTargetItem.item_no]);
                        betoTargetItem.style.background = "";
                    }

                }
            }
            touchBetoScheduleMove = false;
            betoTargetItem = null;

        }, false);
        //刷新
        remind_list_inner_div.refresh = function (allJsonData) {
            //若播报天气提醒已点击过，则将new图标消失掉

            if (!allJsonData) {
                return;
            }
            console.log('remind_list refresh, all josn data is ' + allJsonData);

            // 清除原来的提醒列表
            remind_example_div.innerHTML = "";

            var scheduleInfoItems = allJsonData.scheduleJsonData;
            var scheduleInfoLength = 0;
            if(scheduleInfoItems && scheduleInfoItems.length >= 0) {
                scheduleInfoLength = scheduleInfoItems.length;
            }
            var i = 0;
            var scheduleInfoItem;
            //添加天气提醒的设置
            var MAX_SCHEDULE_LIST_LENGTH = 10;
            for(;i < scheduleInfoLength && i < MAX_SCHEDULE_LIST_LENGTH; i++) {
                scheduleInfoItem = scheduleInfoItems[i];
                var item;
                item = createRemindListItem(!scheduleInfoItem.isCompleted, scheduleInfoItem.mId,
                    scheduleInfoItem.content,
                    scheduleInfoItem.date,
                    scheduleInfoItem.remindtime,
                    scheduleInfoItem.week,
                    scheduleInfoItem.openRemind,
                    scheduleInfoItem.mFocus,
                    scheduleInfoItem.from
                );

                item.className += " sub_list_divider";
                betoItems[i] = item;
                remind_example_div.appendChild(item);
            }




//            var toDoJsonData = allJsonData.toDoJsonData;
//            var be_to_list_length = toDoJsonData.todo_remind_list_length;
//            betoScheduleLength = be_to_list_length;
//            var toDoRemindItems = toDoJsonData.toDoRemindItems;
//
//            var doneJsonData = allJsonData.doneJsonData;
//            var done_list_length = doneJsonData.done_remind_list_length;
//            var doneRemindItems = doneJsonData.doneRemindItems;
//
//            // 清除原来的提醒列表
//            remind_example_div.innerHTML = "";
//
//            //添加天气提醒的设置
//             var MAX_SCHEDULE_LIST_LENGTH = 10;
//            var default_weather_schedule = allJsonData.defaultWeatherJsonObject;
//            if (default_weather_schedule) {
//                var default_weather_schedule_item = createRemindListItem(!default_weather_schedule.isCompleted, default_weather_schedule.mId,
//                    default_weather_schedule.content,
//                    default_weather_schedule.date,
//                    default_weather_schedule.remindtime,
//                    default_weather_schedule.week,
//                    default_weather_schedule.openRemind,
//                    default_weather_schedule.mFocus,
//                    default_weather_schedule.from
//                );
//                default_weather_schedule_item.className += " sub_list_divider";
//                remind_example_div.appendChild(default_weather_schedule_item);
//                MAX_SCHEDULE_LIST_LENGTH = 9;
//            }
//
//            var i = 0;
//            for (; i < betoScheduleLength && i < MAX_SCHEDULE_LIST_LENGTH; i++) {
//                var item;
//                item = createRemindListItem(true, toDoRemindItems[i].mId,
//                    toDoRemindItems[i].content,
//                    toDoRemindItems[i].date,
//                    toDoRemindItems[i].remindtime,
//                    toDoRemindItems[i].week,
//                    toDoRemindItems[i].openRemind,
//                    toDoRemindItems[i].mFocus,
//                    toDoRemindItems[i].from
//                );
//
//                item.className += " sub_list_divider";
//                betoItems[i] = item;
//                remind_example_div.appendChild(item);
//            }
//
//            var j = 0;
//            while (j < done_list_length && i < MAX_SCHEDULE_LIST_LENGTH) {
//                var item;
//                item = createRemindListItem(false, doneRemindItems[j].mId,
//                    doneRemindItems[j].content,
//                    doneRemindItems[j].date,
//                    doneRemindItems[j].remindtime,
//                    doneRemindItems[j].week,
//                    doneRemindItems[j].openRemind,
//                    doneRemindItems[j].mFocus,
//                    doneRemindItems[j].from
//                );
//
//                item.className += " sub_list_divider";
//                betoItems[i] = item;
//                remind_example_div.appendChild(item);
//                j++;
//                i++;
//            }
//
            if (scheduleInfoLength > MAX_SCHEDULE_LIST_LENGTH) {
                more_remind_div.style.display = "block";
            } else {
                more_remind_div.style.display = "none";
            }
        };
//        forceRefreshScreen();
        //添加外壳
        var remind_list_inner_div_outbox_div = createBoxDiv("", remind_list_inner_div);
        remind_list_inner_div_outbox_div.refresh = remind_list_inner_div.refresh;
        return remind_list_inner_div_outbox_div;

    }


    function createHotScheduleListTitleDiv() {

    }

    /**
     * 创建提醒的标题
     * @returns {HTMLElement}
     */
    function createRemindListTitleDiv() {
        /**
         * 提醒列表的title区域
         */
        var schedule_list_title_div = document.createElement("div");
        schedule_list_title_div.className = "css_schedule_list_title_div";

        //提醒的右边的图片
        var schedule_list_title_left_icon = document.createElement("img");
        schedule_list_title_left_icon.className = "css_schedule_list_left_icon";
        schedule_list_title_left_icon.src = ic_reminder_add;
        schedule_list_title_div.appendChild(schedule_list_title_left_icon);

        /**
         * 提醒列表title的容器
         */
        var schedule_list_title_text_div = document.createElement("div");
        schedule_list_title_text_div.className = "css_schedule_list_title_text";
        schedule_list_title_div.appendChild(schedule_list_title_text_div);

        /**
         *提醒列表的title中的文字
         */
        var schedule_list_title_text_label = document.createElement("label");
        schedule_list_title_text_label.className = "css_schedule_list_title_text_label";
        schedule_list_title_text_label.innerText = "新建提醒";
        schedule_list_title_text_div.appendChild(schedule_list_title_text_label);

        //提醒的右边箭头
        var schedule_list_title_right_icon = document.createElement("img");
        schedule_list_title_right_icon.className = "css_schedule_list_right_icon";
        schedule_list_title_right_icon.src = ic_list_arrow_left;
        schedule_list_title_div.appendChild(schedule_list_title_right_icon);

        var is_schedule_list_title_move = false;
        schedule_list_title_div.addEventListener("touchstart", function () {
            event.stopPropagation();
            moveOverCheck.start(event);
            schedule_list_title_div.style.backgroundColor = "#e5e5e5";
        }, false);
        schedule_list_title_div.addEventListener("touchmove", function () {
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                is_schedule_list_title_move = true;
            }
            schedule_list_title_div.style.backgroundColor = "";
        }, false);
        schedule_list_title_div.addEventListener("touchend", function () {
            event.stopPropagation();
            if (is_schedule_list_title_move == false) {
                exec("ScheduleBusinessHandler", 'clickNewSchedule', []);
            }
            schedule_list_title_div.style.backgroundColor = "";
            is_schedule_list_title_move = false;
        }, false);


        return schedule_list_title_div;
    }


    //创建热门提醒区域
    function createHotRemindDiv() {
        //热门提醒的外层div
        var more_hot_remind_div = document.createElement("div");
        more_hot_remind_div.id = "id_more_hot_remind_div";
        more_hot_remind_div.className = "css_done_remind_div";

        //更多热门提醒文字说明的div
        var more_hot_remind_text_div = document.createElement("div");
        more_hot_remind_text_div.className = "css_done_remind_text_div";
        var done_remind_text = document.createElement("label");
        done_remind_text.className = "css_done_remind_text";
        done_remind_text.innerText = "查看更多";
        more_hot_remind_text_div.appendChild(done_remind_text);

        //热门提醒的右边的图片
        var more_hot_remind_icon_div = document.createElement("div");
        more_hot_remind_icon_div.className = "css_done_remind_icon_div";
        var more_hot_remind_icon = document.createElement("img");
        more_hot_remind_icon.className = "css_done_remind_icon";
        more_hot_remind_icon.src = ic_list_arrow_left;
        more_hot_remind_icon_div.appendChild(more_hot_remind_icon);

        more_hot_remind_div.appendChild(more_hot_remind_text_div);
        more_hot_remind_div.appendChild(more_hot_remind_icon_div);

        //添加监听事件
        var moreHotRemindMove = false;

        more_hot_remind_div.addEventListener("touchstart", function () {
            console.log("more_hot_remind_div touchstart");
            event.stopPropagation();
            moveOverCheck.start(event);
            more_hot_remind_div.style.backgroundColor = "#e5e5e5";
        }, false);

        more_hot_remind_div.addEventListener("touchmove", function () {
            console.log("more_hot_remind_div touchmove");
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                moreHotRemindMove = true;
            }
            more_hot_remind_div.style.backgroundColor = "";
        }, false);

        more_hot_remind_div.addEventListener("touchend", function () {
            console.log("more_hot_remind_div touchend");
            event.stopPropagation();
            more_hot_remind_div.style.backgroundColor = "";
            if (moreHotRemindMove == false) {
                //调用java代码
                exec("ScheduleBusinessHandler", 'clickMoreHotScheduleList', []);
            }
            moreHotRemindMove = false;
        }, false);

        return more_hot_remind_div;
    }

    //更多提醒的按钮
    function createMoreRemindDiv() {
        //更多提醒的外层div
        var more_remind_div = document.createElement("div");
        more_remind_div.className = "css_done_remind_div";

        //更多提醒文字说明的div
        var more_remind_text_div = document.createElement("div");
        more_remind_text_div.className = "css_done_remind_text_div";
        var more_remind_text = document.createElement("label");
        more_remind_text.className = "css_done_remind_text";
        more_remind_text.innerText = "查看更多";
        more_remind_text_div.appendChild(more_remind_text);

        //更多提醒的右边的图片
        var more_remind_icon_div = document.createElement("div");
        more_remind_icon_div.className = "css_done_remind_icon_div";
        var more_remind_icon = document.createElement("img");
        more_remind_icon.className = "css_done_remind_icon";
        more_remind_icon.src = ic_list_arrow_left;
        more_remind_icon_div.appendChild(more_remind_icon);

        more_remind_div.appendChild(more_remind_text_div);
        more_remind_div.appendChild(more_remind_icon_div);

        //添加监听事件
        var moreRemindMove = false;
        more_remind_div.addEventListener("touchstart", function () {
            console.log("more_remind_div touchstart");
            event.stopPropagation();
            moveOverCheck.start(event);
            more_remind_div.style.backgroundColor = "#e5e5e5";
        }, false);
        more_remind_div.addEventListener("touchmove", function () {
            console.log("more_remind_div touchmove");
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
                moreRemindMove = true;
            }
            more_remind_div.style.backgroundColor = "";
        }, false);
        more_remind_div.addEventListener("touchend", function () {
            console.log("more_remind_div touchend");
            event.stopPropagation();
            more_remind_div.style.backgroundColor = "";
            if (moreRemindMove == false) {
                //调用java代码
                exec("ScheduleBusinessHandler", 'clickDoneScheduleList', []);
            }
            moreRemindMove = false;
        }, false);

        return more_remind_div;
    }

    /**
     * 创建提醒列表元素
     * @param flag true表示未完成，false表示已完成提醒
     * @param mId 提醒的id
     * @param content 提醒内容
     * @param date 提醒的日期
     * @param remindtime 提醒的事件
     * @param week 提醒的重复描述
     * @param openRemind 提醒是否打开
     * @param mFocus 表示是否是电话短信提醒
     * @param mIsFromPush 是否是推送提醒
     * @returns {HTMLElement}
     */
    function createRemindListItem(flag, mId, content, date, remindtime, week, openRemind, mFocus, mIsFromPush) {
        var itemDiv = document.createElement("div");
        itemDiv.id = "remindListItem" + mId;
        itemDiv.className = "css_remind_item_div";

        var contentAndTime = document.createElement("div");
        contentAndTime.className = "css_remind_content_and_time_div";

        // content
        var contentDiv = document.createElement("div");
        contentDiv.className = "schedule_list_first_lint_text";
        if (content) {
            contentDiv.innerText = content;
        } else {
            contentDiv.innerText = "自定义";
        }

        contentDiv.id = "remindContent" + mId;

        // time
        var timeDiv = document.createElement("label");
        timeDiv.className = "list_second_line_text";
        timeDiv.innerHTML = remindtime + "&nbsp;&nbsp;" + date + "&nbsp;&nbsp;"
            + week;

        contentAndTime.appendChild(contentDiv);
        contentAndTime.appendChild(timeDiv);

        if (flag) {
            var imgContainer = document.createElement("div");
            imgContainer.className = "css_remind_img_container";

            var typeImg = document.createElement("img");
            typeImg.id = "id_remind_type_img" + mId;
            typeImg.className = "css_remind_type_img";
            if (mFocus == "telephone") {
                typeImg.style.display = "inline-block";
                // 打电话的图标
                typeImg.src = btn_call_nor;
            } else if (mFocus == "message") {
                typeImg.style.display = "inline-block";
                // 发短信的图标
                typeImg.src = btn_sms_nor;
            } else {
                typeImg.style.display = "none";
            }

            var touchTypeImgMove = false;
            var touchSwitchImgMove = false;
            typeImg.addEventListener("touchstart", function () {
                typeImg = event.target;
                if (mFocus == "telephone") {
                    typeImg.src = btn_call_press;
                } else if (mFocus == "message") {
                    typeImg.src = btn_sms_press;
                }
                event.stopPropagation();
                moveOverCheck.start(event);
            }, false);

            typeImg.addEventListener("touchmove", function () {
                event.stopPropagation();
                typeImg = event.target;
                if (mFocus == "telephone") {
                    typeImg.src = btn_call_nor;
                } else if (mFocus == "message") {
                    typeImg.src = btn_sms_nor;
                }
                if (moveOverCheck.check(event)) {
                    touchTypeImgMove = true;
                }
            }, false);

            typeImg.addEventListener("touchend", function () {
                typeImg = event.target;
                if (mFocus == "telephone") {
                    typeImg.src = btn_call_nor;
                } else if (mFocus == "message") {
                    typeImg.src = btn_sms_nor;
                }
                if (touchTypeImgMove == false) {
                    exec("ScheduleBusinessHandler", 'clickScheduleTypeFlag', [mId]);
                }
                touchTypeImgMove = false;
                event.stopPropagation();
            }, false);

            // 是否开启提醒，会有点击事件
            var switchImg = document.createElement("img");
            switchImg.id = "id_remind_switch_img" + mId;
            switchImg.className = "css_remind_switch_img";
            if (openRemind) {
                // 开启了提醒
                switchImg.src = switch_on;
            } else {
                // 关闭了提醒
                switchImg.src = switch_off;
            }

            switchImg.addEventListener("touchstart", function () {
                console.log('switchImg ontouchstart');
                switchImg = event.target;
                event.stopPropagation();
                moveOverCheck.start(event);
            }, false);

            switchImg.addEventListener("touchmove", function () {
                console.log('switchImg ontouchmove');
                switchImg = event.target;
                event.stopPropagation();
                if (moveOverCheck.check(event)) {
                    touchSwitchImgMove = true;
                }
            }, false);

            switchImg.addEventListener("touchend", function () {
                console.log('switchImg ontouchend');
                switchImg = event.target;
                if (touchSwitchImgMove == true) {
                    touchSwitchImgMove = false;
                } else {
                    // 获取提醒开关的标志，并执行相反的操作
                    exec("ScheduleBusinessHandler", 'clickScheduleSwitchFlag', [mId]);
                }
                event.stopPropagation();
            }, false);

            imgContainer.appendChild(typeImg);
            imgContainer.appendChild(switchImg);

            itemDiv.appendChild(contentAndTime);
            itemDiv.appendChild(imgContainer);
        } else {

            var schedule_item_complete_indicator_div = document.createElement("div");
            schedule_item_complete_indicator_div.className = "css_schedule_item_complete_text";

            var schedule_item_complete_indicator_label = document.createElement("label");
            schedule_item_complete_indicator_label.className = "css_schedule_item_complete_text_label";
            schedule_item_complete_indicator_label.innerText = "已完成";
            schedule_item_complete_indicator_div.appendChild(schedule_item_complete_indicator_label);

            itemDiv.appendChild(contentAndTime);
            itemDiv.appendChild(schedule_item_complete_indicator_div);
        }

        itemDiv.item_no = mId;
        return itemDiv;
    }


    function refreshSwitch(id, result) {
        console.log('refreshSwitch begin');
        var mId = "id_remind_switch_img" + id;
        var element = document.getElementById(mId);
        if (result) {
            // 若果是开的,关掉
            element.src = switch_on;
        } else {
            element.src = switch_off;
        }
    }

    function refreshRemindList(confirmClearSchedule) {
        console.log('refreshRemindList begin' + confirmClearSchedule);
        if (confirmClearSchedule) {
            document.getElementById("id_done_remind_list_content_main_div").innerHTML = "";
            doneScheduleLength = 0;
            forceRefreshScreen();
        }
    }

    function refreshHistory(allJsonData) {
        console.log('refreshHistory begin  ' + allJsonData);
        document.getElementById("id_remind_list_inner_div")
            .refresh(allJsonData);
    }

    /**
     * 删除指定id的提醒列表
     * @param id
     */
    function deleteScheduleById(id) {
        var schedule_list_item = document.getElementById("remindListItem" + id);
        console.log("deleteScheduleById:" + schedule_list_item + ":" + id);
        if (schedule_list_item) {
            addClass(schedule_list_item, 'css_schedule_delete_item');
            schedule_list_item.innerHTML = "";
            schedule_list_item.style.height = "0px";


            setTimeout(function () {
                exec("ScheduleBusinessHandler", 'deleteScheduleById', [id]);
                console.log("Exec deleteScheduleById" + id);
            }, 1000);
        }
    }

    /**
     * 刷新提醒列表元素的背景
     * @param id
     */
    function refreshScheduleItemBackground(id) {
        var schedule_list_item = document.getElementById("remindListItem" + id);
        if (schedule_list_item) {
            schedule_list_item.style.background = "";
        }
    }

    /**
     * 跟新提醒红点的状态
     */
    function updateScheduleRedhot() {
        var redDot = document.getElementById("hot_schedule_red_hot_id");
        if (redDot) {
            redDot.style.display = "block";
        }
    }

    window.sub_schedule = schedulePanel;
    sub_schedule.updateScheduleRedhot = updateScheduleRedhot;
    sub_schedule.refreshSwitch = refreshSwitch;
    sub_schedule.refreshRemindList = refreshRemindList;
    sub_schedule.refreshHistory = refreshHistory;
    sub_schedule.deleteScheduleById = deleteScheduleById;
    sub_schedule.refreshScheduleItemBackground = refreshScheduleItemBackground;
    schedulePanel.show();
}


/**
 * 函数映射表
 */
var functionMap = {
    QuestionView: {
        url: [ "./common/questionView.js" ]
    },
    WidgetCustomerQuestionView: {
        url: [ "./common/questionView.js" ]
    },
    AnswerView: {
        url: [ "./common/dialogView.js" ]
    },
    WidgetViaFlyAnswerView: {
        url: [ "./common/dialogView.js" ]
    },
    WidgetRemindView: {
        url: [ "./schedule/remindView.js" ]
    },
    WidgetRemindConfirmView: {
        url: [ "./schedule/remindConfirm.js" ]
    }
};

console.log("main-translate.js load finish");