/*******************股票View**********************/
define(function() {
    //需要监听按钮点击事件
    exec("LxBrowserComponents", "isEventCallBackForJS", [true]);
    
	function createStockWaitingContainer(id) {
		console.log("waiting canvas id: " + id);
		var stock_waiting_container = document.createElement("div");
		stock_waiting_container.id = id;
		stock_waiting_container.className = "css_stock_waiting_container";

		var stock_waiting_img = document.createElement("canvas");
		stock_waiting_img.setAttribute("height", dialog_content_play_waiting_canvas_width + "px");
		stock_waiting_img.setAttribute("width", dialog_content_play_waiting_canvas_width + "px");
		
		var stock_waiting_tip = document.createElement("div");
		stock_waiting_tip.className = "css_stock_waiting_tip";
		stock_waiting_tip.innerText = "努力加载中......";
		
		stock_waiting_container.appendChild(stock_waiting_img);
		stock_waiting_container.appendChild(stock_waiting_tip);
		stock_waiting_container.img = stock_waiting_img;
		
		return stock_waiting_container;
	}

	function createStockFailureContainer(id) {
		console.log("failure container id: " + id);
		var stock_failure_container = document.createElement("div");
		stock_failure_container.id = id;

		stock_failure_container.className = "css_dialog_failure_container";
		var stock_refresh_image = document.createElement("img");
		stock_refresh_image.className = "css_dialog_failure_refresh_image";
		stock_refresh_image.src = dialog_stock_refresh;
		var stock_failure_tip_text = document.createElement("label");
		stock_failure_tip_text.className = "css_dialog_failure_tip_text";
		stock_failure_tip_text.innerText = "点击屏幕重新加载";
		//stock_failure_container.appendChild(stock_refresh_image);
		stock_failure_container.appendChild(stock_failure_tip_text);
		return stock_failure_container;
	}

	function createStockSuccessImageContainer(id, imgId) {
		console.log("success container id: " + id);
		console.log("success img id: " + imgId);
		var stock_image_container = document.createElement("div");
		stock_image_container.id = id;

		stock_image_container.className = "css_dialog_stock_image_data_container";

		var stock_success_image = document.createElement("img");
		stock_success_image.id = imgId;
		stock_success_image.className = "css_dialog_stock_success_image";

		stock_image_container.appendChild(stock_success_image);
		if (cmcc_flag == false) {
			var stock_image_cover_top = document.createElement("div");
			stock_image_cover_top.className = "css_dialog_stock_image_data_cover_top";
			var stock_image_cover_bottom = document.createElement("div");
			stock_image_cover_bottom.className = "css_dialog_stock_image_data_cover_bottom";

			stock_image_container.appendChild(stock_image_cover_top);
			stock_image_container.appendChild(stock_image_cover_bottom);
		}
		/** ********************************************* */
		stock_image_container.getImage = function() {
			return stock_success_image;
		};
		/** ********************************************* */

		return stock_image_container;
	}

	function createCMBottomStock(stockInfo) {
		var bottomDiv = document.createElement("div");
		bottomDiv.className = "cm_stock_bottom";
		var stockLogo = document.createElement("img");
		stockLogo.className = "cm_stock_logo";
		stockLogo.src = cm_stock_icon;
		var stockFrom = document.createElement("label");
		stockFrom.className = "stock_bottom_text";
		stockFrom.innerText = "股票123";
		
		var stock_last_update_time = document.createElement("div");
        stock_last_update_time.className = "css_dialog_stock_update_time";
        stock_last_update_time.innerText = stockInfo.updateTime;

		bottomDiv.appendChild(stockLogo);
		bottomDiv.appendChild(stockFrom);
		bottomDiv.appendChild(stock_last_update_time);
		bottomDiv.addEventListener("click", function(){
		    console.log("stockView, bottomDiv click");
		});
		
		return bottomDiv;
	}
	
	function createLinkMoreDiv(stockInfo) {
	    var linkMoreDiv = document.createElement("div");
        linkMoreDiv.className = "css_dialog_stock_link_more_div";
        
        var relatedInfoDiv = document.createElement("div");
        relatedInfoDiv.className = "css_dialog_stock_relatedinfo_div";
        relatedInfoDiv.innerText = "相关资讯";
        relatedInfoDiv.link = stockInfo.articleUrl;
        linkMoreDiv.appendChild(relatedInfoDiv);
        
        var briefCommentDiv = document.createElement("div");
        briefCommentDiv.className = "css_dialog_stock_brief_comment_div";
        briefCommentDiv.innerText = "短线快评";
        briefCommentDiv.link = stockInfo.reviewUrl;
        
        var briefCommentDivBox = document.createElement("div");
        briefCommentDivBox.className = "css_dialog_stock_brief_comment_div_box";
        briefCommentDivBox.appendChild(briefCommentDiv);
        linkMoreDiv.appendChild(briefCommentDivBox);
        
        relatedInfoDiv.addEventListener("touchstart", function(event){
            event.stopPropagation();
            relatedInfoDiv.style.backgroundColor = "#e5e5e5";
            moveOverCheck.start(event);
        });
        relatedInfoDiv.addEventListener("touchmove", function(){
            event.stopPropagation();
            if (moveOverCheck.check(event)) {
            	relatedInfoDiv.style.backgroundColor = "";
            }
        });
        relatedInfoDiv.addEventListener("touchend", function(){
            event.stopPropagation();
            relatedInfoDiv.style.backgroundColor = "";
            if (!moveOverCheck.isMoveOver()) {
            	exec("UIComponents", 'openBrowser', [ "", this.link ]);
            }
        });
        
        briefCommentDiv.addEventListener("touchstart", function(event){
        	event.stopPropagation();
        	briefCommentDiv.style.backgroundColor = "#e5e5e5";
            moveOverCheck.start(event);
        });
        briefCommentDiv.addEventListener("touchmove", function(){
        	event.stopPropagation();
        	if (moveOverCheck.check(event)) {
            	briefCommentDiv.style.backgroundColor = "";
            }
        });
        briefCommentDiv.addEventListener("touchend", function(){
        	event.stopPropagation();
        	briefCommentDiv.style.backgroundColor = "";
        	if (!moveOverCheck.isMoveOver()) {
        		exec("UIComponents", 'openBrowser', [ "", this.link ]);
        	}
        });
        
        return linkMoreDiv;
	}

	function createStockView(stockInfo) {
		var outDiv = document.createElement("div");
        outDiv.className = 'box_content_white';
        
		var dialog_stock_inner_div = document.createElement("div");
		dialog_stock_inner_div.className = "css_dialog_stock_inner";

		var currentPrice = stockInfo.currentPrice;
		var curPriceTooLong = currentPrice.length > 7;

		var dialog_stock_detail_container = document.createElement("div");
		if (curPriceTooLong) {
			dialog_stock_detail_container.className = "css_dialog_stock_detail_small";
		} else {
			dialog_stock_detail_container.className = "css_dialog_stock_detail";
		}
		
		var dialog_stock_overview_container = document.createElement("div");
		dialog_stock_overview_container.className = "css_dialog_stock_overview";

		var dialog_stock_data_div = document.createElement("div");
		dialog_stock_data_div.className = "css_dialog_stock_data_div";

		var dialog_stock_name_code_div = document.createElement("div");
		dialog_stock_name_code_div.className = "css_dialog_stock_name_code_div";

		var dialog_stock_name = document.createElement("label");
		dialog_stock_name.className = "css_dialog_stock_name";
		dialog_stock_name.innerText = stockInfo.stockName;
		var dialog_stock_code = document.createElement("label");
		dialog_stock_code.innerText = stockInfo.stockCode;

		var dialog_stock_price_rise_div = document.createElement("div");
		dialog_stock_price_rise_div.className = "dialog_stock_price_rise_div";

		var dialog_stock_current_price = document.createElement("label");
		if (curPriceTooLong) {
			dialog_stock_code.className = "css_dialog_stock_code_small";
			dialog_stock_current_price.className = "css_dialog_stock_current_price_small";
		} else {
			dialog_stock_code.className = "css_dialog_stock_code";
			dialog_stock_current_price.className = "css_dialog_stock_current_price";
		}
		dialog_stock_current_price.innerText = stockInfo.currentPrice;

		var stock_rise_status = stockInfo.stockStatus;

		if (stock_rise_status !== 3) {
			var dialog_stock_rise_down_flag = document.createElement("img");
			if (curPriceTooLong) {
				dialog_stock_rise_down_flag.className = "css_dialog_stock_rise_down_flag_small";
			} else {
				dialog_stock_rise_down_flag.className = "css_dialog_stock_rise_down_flag";
			}
		}

		var dialog_stock_rise_rate_value_div = document.createElement("div");
		dialog_stock_rise_rate_value_div.className = "css_dialog_stock_rise_value_rate";
		var dialog_stock_rise_value = document.createElement("label");
		dialog_stock_rise_value.className = "css_dialog_stock_rise_value";
		dialog_stock_rise_value.innerText = stockInfo.riseValue;
		var dialog_stock_rise_rate = document.createElement("label");
		dialog_stock_rise_rate.innerText = stockInfo.riseRate;

		if (stock_rise_status == 1) {
			dialog_stock_rise_down_flag.src = dialog_stock_down_flag;
			dialog_stock_detail_container.style.background = "#67C869";
			dialog_stock_rise_rate_value_div.className = "css_dialog_stock_rise_value_rate_down";
			dialog_stock_data_div.className = "css_dialog_stock_data_div_down";
		} else if (stock_rise_status == 2) {
			dialog_stock_rise_down_flag.src = dialog_stock_up_flag;
			dialog_stock_detail_container.style.background = "#F25555";
			dialog_stock_rise_rate_value_div.className = "css_dialog_stock_rise_value_rate_up";
			dialog_stock_data_div.className = "css_dialog_stock_data_div_up";
		} else {
			dialog_stock_detail_container.style.background = "#5BC8FB";
			dialog_stock_rise_rate_value_div.className = "css_dialog_stock_rise_value_rate_stop";
			dialog_stock_data_div.className = "css_dialog_stock_data_div_stop";
		}

		dialog_stock_rise_rate_value_div.appendChild(dialog_stock_rise_value);
		dialog_stock_rise_rate_value_div.appendChild(dialog_stock_rise_rate);
        
        if (stock_rise_status !== 3) {
            dialog_stock_price_rise_div.appendChild(dialog_stock_rise_down_flag);
        }
		dialog_stock_price_rise_div.appendChild(dialog_stock_current_price);

		dialog_stock_name_code_div.appendChild(dialog_stock_name);
		dialog_stock_name_code_div.appendChild(dialog_stock_code);

		dialog_stock_overview_container.appendChild(dialog_stock_name_code_div);
		dialog_stock_overview_container.appendChild(dialog_stock_price_rise_div);

		var dialog_stock_data1 = document.createElement("div");
		var dialog_stock_data2 = document.createElement("div");

		var price_flag_text = ["今开价", "最高价", "昨收价", "最低价"];
		var price_flag_label = [];
		for (var i = 0; i < 4; i++) {
			var dialog_stock_price_flag = document.createElement("label");
			dialog_stock_price_flag.className = "css_dialog_stock_price_flag";
			dialog_stock_price_flag.innerText = price_flag_text[i];
			price_flag_label[i] = dialog_stock_price_flag;
		}
		var dialog_stock_opening_price = document.createElement("label");
		dialog_stock_opening_price.innerText = stockInfo.openningPrice;
		dialog_stock_opening_price.className = "css_dialog_stock_price_text";

		var dialog_stock_high_price = document.createElement("label");
		dialog_stock_high_price.innerText = stockInfo.highPrice;
		dialog_stock_high_price.className = "css_dialog_stock_price_text";

		var dialog_stock_closing_price = document.createElement("label");
		dialog_stock_closing_price.innerText = stockInfo.yestadayPrice;
		dialog_stock_closing_price.className = "css_dialog_stock_price_text";

		var dialog_stock_low_price = document.createElement("label");
		dialog_stock_low_price.innerText = stockInfo.lowPrice;
		dialog_stock_low_price.className = "css_dialog_stock_price_text";

		var data_left_flag_block = document.createElement("div");
		data_left_flag_block.className = "css_dialog_stock_price_flag_block";
		data_left_flag_block.appendChild(price_flag_label[0]);
		data_left_flag_block.appendChild(price_flag_label[2]);

		var data_left_data_block = document.createElement("div");
		data_left_data_block.className = 'css_dialog_stock_price_data_block';
		data_left_data_block.appendChild(dialog_stock_opening_price);
		data_left_data_block.appendChild(dialog_stock_closing_price);

		var data_left = document.createElement("div");
		data_left.className = 'css_dialog_stock_data_float_left';
		data_left.appendChild(data_left_flag_block);
		data_left.appendChild(data_left_data_block);

		var data_right = document.createElement("div");
		data_right.className = 'css_dialog_stock_data_float_left';
		data_right.style.textAlign = "right";

		var data_right_flag_block = document.createElement("div");
		data_right_flag_block.className = "css_dialog_stock_price_flag_block";
		data_right_flag_block.appendChild(price_flag_label[1]);
		data_right_flag_block.appendChild(price_flag_label[3]);

		var data_right_data_block = document.createElement("div");
		data_right_data_block.className = 'css_dialog_stock_price_data_block';
		data_right_data_block.appendChild(dialog_stock_high_price);
		data_right_data_block.appendChild(dialog_stock_low_price);

		data_right.appendChild(data_right_flag_block);
		data_right.appendChild(data_right_data_block);

		dialog_stock_data_div.appendChild(data_left);
		dialog_stock_data_div.appendChild(data_right);

		dialog_stock_detail_container.appendChild(dialog_stock_overview_container);
		dialog_stock_detail_container.appendChild(dialog_stock_rise_rate_value_div);
		dialog_stock_detail_container.appendChild(dialog_stock_data_div);

		var dialog_stock_img_container = document.createElement("div");
		dialog_stock_img_container.className = "css_dialog_stock_image_container";

		var dialog_success_container = createStockSuccessImageContainer("stock_success", "stock_img");
		var dialog_failure_container = createStockFailureContainer("stock_failure");
		var dialog_waiting_container = createStockWaitingContainer("stock_waiting");
        dialog_waiting_container.style.background = "#FFFFFF";
		dialog_stock_img_container.appendChild(dialog_waiting_container);
		dialog_stock_img_container.appendChild(dialog_failure_container);
		dialog_stock_img_container.appendChild(dialog_success_container);
		
		var linkMoreDiv = null;
		if(null != stockInfo.articleUrl && null != stockInfo.reviewUrl) {
		    linkMoreDiv = createLinkMoreDiv(stockInfo);
		}

		dialog_stock_inner_div.appendChild(dialog_stock_detail_container);
		dialog_stock_inner_div.appendChild(dialog_stock_img_container);
		if(null != linkMoreDiv) {
		    dialog_stock_inner_div.appendChild(linkMoreDiv);
		}
		
		var cm_stock_bottom = createCMBottomStock(stockInfo);
        dialog_stock_inner_div.appendChild(cm_stock_bottom);

		outDiv.appendChild(dialog_stock_inner_div);

		//添加外壳
	    var outDivBox = createBoxDiv(null, outDiv);
	    outDivBox.style.marginTop = 4*scale + "px";
		document.body.appendChild(outDivBox);
		
		//显示播报按钮
        exec("LxBrowserComponents", "showSpeakButton", [true]);
        
        require(["./stock/stockSpeakHandler.js"], function(stockSpeakHandler) {
            console.log("require stockSpeakHandler");
            stockSpeakHandler.speak(stockInfo);
        }); 
        
		var wait_stock_id = null;

		var stockImage = dialog_success_container.getImage();
		var retryTimes = 0;
		var inLoading = null;
		var isOverTime = false;
		var isLoadingSuccess = false;

		dialog_failure_container.addEventListener('touchend', function() {
			dialog_failure_container.style.display = "none";

			if (wait_stock_id != null) {
				stopRotate(wait_stock_id);
				wait_stock_id = null;
			}

			if (isLoadingSuccess) {
				showSuccess();
			} else {
				isOverTime = false;
				inLoading = setTimeout(function() {
					isOverTime = true;
					showError();
				}, 8000);
				wait_stock_id = startRotate(dialog_waiting_container.img);

				dialog_waiting_container.style.display = "inline-block";
				stockImage.src = stockInfo.chartUrl + "?rc" + retryTimes;
			}
		}, false);

		dialog_waiting_container.style.display = "inline-block";
		wait_stock_id = startRotate(dialog_waiting_container.img);
		
		// 图片加载
		inLoading = setTimeout(function() {
			isOverTime = true;
			showError();
		}, 8000);
		stockImage.src = stockInfo.chartUrl;

		showSuccess = function() {
		    console.log("stockView, showSuccess");
			if (wait_stock_id != null) {
				stopRotate(wait_stock_id);
				wait_stock_id = null;
			}
			clearTimeout(inLoading);
			inLoading = null;

			dialog_waiting_container.style.display = "none";
			dialog_failure_container.style.display = "none";
			dialog_success_container.style.display = "block";
		};
		showError = function() {
		    console.log("stockView, showError");
			if (wait_stock_id != null) {
				stopRotate(wait_stock_id);
				wait_stock_id = null;
			}
			dialog_waiting_container.style.display = "none";
			dialog_failure_container.style.display = "block";
			dialog_success_container.style.display = "none";
		};

		stockImage.onload = function() {
			console.log("stock image load success");
			if (isOverTime == false) {
				showSuccess();
			}
			isLoadingSuccess = true;
		};
		stockImage.onerror = function() {
			isLoadingSuccess = false;
			if (isOverTime == false) {
				// 加载出错就不停地进行重试
				stockImage.src = stockInfo.chartUrl + "?rc" + retryTimes;
				retryTimes++;
				console.log("stock image load error : " + retryTimes);
			}
		};

		outDivBox.refresh = function() {
			dialog_stock_share.refresh();
		};

		return outDivBox;
	}
	
    /**
     * canvas方式实现图片旋转
     */
    function startRotate(target_canvas, img) {
        // stopRotate(content_play_loading_interval);
        console.error("high rotate function is called");
        var dialog_waiting = function() {
            // 获取上下文
            var ctx = target_canvas.getContext("2d");
            // 清空画布
            ctx.clearRect(0, 0, target_canvas.width, target_canvas.height);
            //
            ctx.translate(target_canvas.width / 2, target_canvas.height / 2);

            ctx.rotate(Math.PI / 4);

            ctx.translate(-target_canvas.width / 2, -target_canvas.height / 2);

            if (img != undefined && img != null) {
                ctx.drawImage(img, 0, 0, target_canvas.width, target_canvas.height);
            } else {
                ctx.drawImage(img_dialog_waiting_A[0], 0, 0, target_canvas.width, target_canvas.height);
            }
        };
        var funtion_id = setInterval(function() {
            dialog_waiting();
        }, 125);
        return funtion_id;
    }

    /**
     * 停止加载动画
     */
    function stopRotate(funtion_id) {
        console.log('stopRotate, id ' + funtion_id);
        if (funtion_id != null && typeof funtion_id != "undefined") {
            clearInterval(funtion_id);
            funtion_id = null;
        }
    }
    
	return createStockView;
}); 